_newATCAIface:
;atca_iface.c,64 :: 		ATCAIface newATCAIface(ATCAIfaceCfg *cfg)  // constructor
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;atca_iface.c,66 :: 		ATCAIface caiface = (ATCAIface)Malloc(sizeof(T_atca_iface));
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R25, 12(SP)
ORI	R25, R0, 40
JAL	_Malloc+0
NOP	
LW	R25, 12(SP)
; caiface start address is: 16 (R4)
MOVZ	R4, R2, R0
;atca_iface.c,68 :: 		caiface->mType = cfg->iface_type;
LBU	R3, 0(R25)
SB	R3, 0(R2)
;atca_iface.c,69 :: 		caiface->mIfaceCFG = cfg;
ADDIU	R2, R4, 4
SW	R25, 0(R2)
;atca_iface.c,71 :: 		if (atinit(caiface) != ATCA_SUCCESS) {
SW	R4, 12(SP)
MOVZ	R25, R4, R0
JAL	_atinit+0
NOP	
LW	R4, 12(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__newATCAIface7
NOP	
J	L__newATCAIface4
NOP	
L__newATCAIface7:
;atca_iface.c,72 :: 		Free((void*)caiface,sizeof(caiface));
ORI	R26, R0, 4
MOVZ	R25, R4, R0
; caiface end address is: 16 (R4)
JAL	_Free+0
NOP	
;atca_iface.c,73 :: 		caiface = 0;
; caiface start address is: 8 (R2)
MOVZ	R2, R0, R0
; caiface end address is: 8 (R2)
;atca_iface.c,74 :: 		}
J	L_newATCAIface0
NOP	
L__newATCAIface4:
;atca_iface.c,71 :: 		if (atinit(caiface) != ATCA_SUCCESS) {
MOVZ	R2, R4, R0
;atca_iface.c,74 :: 		}
L_newATCAIface0:
;atca_iface.c,76 :: 		return caiface;
; caiface start address is: 8 (R2)
; caiface end address is: 8 (R2)
;atca_iface.c,77 :: 		}
;atca_iface.c,76 :: 		return caiface;
;atca_iface.c,77 :: 		}
L_end_newATCAIface:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _newATCAIface
_atinit:
;atca_iface.c,81 :: 		ATCA_STATUS atinit(ATCAIface caiface)
ADDIU	SP, SP, -48
SW	RA, 0(SP)
;atca_iface.c,83 :: 		ATCA_STATUS status = ATCA_COMM_FAIL;
SW	R26, 4(SP)
;atca_iface.c,86 :: 		_atinit( caiface, &hal );
ADDIU	R2, SP, 12
SW	R25, 8(SP)
MOVZ	R26, R2, R0
JAL	__atinit+0
NOP	
LW	R25, 8(SP)
;atca_iface.c,88 :: 		status = caiface->atinit( &hal, caiface->mIfaceCFG );
ADDIU	R2, R25, 8
LW	R4, 0(R2)
ADDIU	R2, R25, 4
LW	R3, 0(R2)
ADDIU	R2, SP, 12
SW	R25, 8(SP)
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JALR	RA, R4
NOP	
LW	R25, 8(SP)
; status start address is: 12 (R3)
ANDI	R3, R2, 255
;atca_iface.c,89 :: 		if (status == ATCA_SUCCESS) {
ANDI	R2, R2, 255
BEQ	R2, R0, L__atinit9
NOP	
J	L__atinit3
NOP	
L__atinit9:
; status end address is: 12 (R3)
;atca_iface.c,90 :: 		caiface->hal_data = hal.hal_data;
ADDIU	R3, R25, 36
LW	R2, 44(SP)
SW	R2, 0(R3)
;atca_iface.c,93 :: 		status = caiface->atpostinit( caiface );
ADDIU	R2, R25, 12
LW	R2, 0(R2)
JALR	RA, R2
NOP	
; status start address is: 12 (R3)
ANDI	R3, R2, 255
; status end address is: 12 (R3)
ANDI	R2, R3, 255
;atca_iface.c,94 :: 		}
J	L_atinit1
NOP	
L__atinit3:
;atca_iface.c,89 :: 		if (status == ATCA_SUCCESS) {
ANDI	R2, R3, 255
;atca_iface.c,94 :: 		}
L_atinit1:
;atca_iface.c,96 :: 		return status;
; status start address is: 8 (R2)
; status end address is: 8 (R2)
;atca_iface.c,97 :: 		}
;atca_iface.c,96 :: 		return status;
;atca_iface.c,97 :: 		}
L_end_atinit:
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 48
JR	RA
NOP	
; end of _atinit
_atsend:
;atca_iface.c,99 :: 		ATCA_STATUS atsend(ATCAIface caiface, uint8_t *txdata, int txlength)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atca_iface.c,101 :: 		return caiface->atsend(caiface, txdata, txlength);
ADDIU	R2, R25, 16
LW	R2, 0(R2)
JALR	RA, R2
NOP	
;atca_iface.c,102 :: 		}
L_end_atsend:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atsend
_atreceive:
;atca_iface.c,104 :: 		ATCA_STATUS atreceive( ATCAIface caiface, uint8_t *rxdata, uint16_t *rxlength)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atca_iface.c,106 :: 		return caiface->atreceive(caiface, rxdata, rxlength);
ADDIU	R2, R25, 20
LW	R2, 0(R2)
JALR	RA, R2
NOP	
;atca_iface.c,107 :: 		}
L_end_atreceive:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atreceive
_atwake:
;atca_iface.c,109 :: 		ATCA_STATUS atwake(ATCAIface caiface)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atca_iface.c,111 :: 		return caiface->atwake(caiface);
ADDIU	R2, R25, 24
LW	R2, 0(R2)
JALR	RA, R2
NOP	
;atca_iface.c,112 :: 		}
L_end_atwake:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atwake
_atidle:
;atca_iface.c,114 :: 		ATCA_STATUS atidle(ATCAIface caiface)
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_iface.c,116 :: 		atca_delay_ms(1);
SW	R25, 4(SP)
ORI	R25, R0, 1
JAL	_atca_delay_ms+0
NOP	
LW	R25, 4(SP)
;atca_iface.c,117 :: 		return caiface->atidle(caiface);
ADDIU	R2, R25, 28
LW	R2, 0(R2)
JALR	RA, R2
NOP	
;atca_iface.c,118 :: 		}
L_end_atidle:
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atidle
_atsleep:
;atca_iface.c,120 :: 		ATCA_STATUS atsleep(ATCAIface caiface)
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atca_iface.c,122 :: 		atca_delay_ms(1);
SW	R25, 4(SP)
ORI	R25, R0, 1
JAL	_atca_delay_ms+0
NOP	
LW	R25, 4(SP)
;atca_iface.c,123 :: 		return caiface->atsleep(caiface);
ADDIU	R2, R25, 32
LW	R2, 0(R2)
JALR	RA, R2
NOP	
;atca_iface.c,124 :: 		}
L_end_atsleep:
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atsleep
_atgetifacecfg:
;atca_iface.c,126 :: 		ATCAIfaceCfg * atgetifacecfg(ATCAIface caiface)
;atca_iface.c,128 :: 		return caiface->mIfaceCFG;
ADDIU	R2, R25, 4
LW	R2, 0(R2)
;atca_iface.c,129 :: 		}
L_end_atgetifacecfg:
JR	RA
NOP	
; end of _atgetifacecfg
_atgetifacehaldat:
;atca_iface.c,131 :: 		void* atgetifacehaldat(ATCAIface caiface)
;atca_iface.c,133 :: 		return caiface->hal_data;
ADDIU	R2, R25, 36
LW	R2, 0(R2)
;atca_iface.c,134 :: 		}
L_end_atgetifacehaldat:
JR	RA
NOP	
; end of _atgetifacehaldat
_deleteATCAIface:
;atca_iface.c,136 :: 		void deleteATCAIface(ATCAIface *caiface) // destructor
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;atca_iface.c,138 :: 		if ( *caiface ) {
SW	R26, 4(SP)
LW	R2, 0(R25)
BNE	R2, R0, L__deleteATCAIface19
NOP	
J	L_deleteATCAIface2
NOP	
L__deleteATCAIface19:
;atca_iface.c,139 :: 		hal_iface_release( (*caiface)->mType, (*caiface)->hal_data);  // let HAL clean up and disable physical level interface if ref count is 0
LW	R4, 0(R25)
ADDIU	R2, R4, 36
LW	R3, 0(R2)
LBU	R2, 0(R4)
SW	R25, 8(SP)
MOVZ	R26, R3, R0
ANDI	R25, R2, 255
JAL	_hal_iface_release+0
NOP	
LW	R25, 8(SP)
;atca_iface.c,140 :: 		Free((void*)*caiface,sizeof(*caiface));
LW	R2, 0(R25)
SW	R25, 8(SP)
ORI	R26, R0, 4
MOVZ	R25, R2, R0
JAL	_Free+0
NOP	
LW	R25, 8(SP)
;atca_iface.c,141 :: 		}
L_deleteATCAIface2:
;atca_iface.c,143 :: 		*caiface = 0;
SW	R0, 0(R25)
;atca_iface.c,144 :: 		}
L_end_deleteATCAIface:
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _deleteATCAIface
__atinit:
;atca_iface.c,146 :: 		ATCA_STATUS _atinit(ATCAIface caiface, ATCAHAL_t *hal)
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;atca_iface.c,149 :: 		hal_iface_init( caiface->mIfaceCFG, hal );
ADDIU	R2, R25, 4
LW	R2, 0(R2)
SW	R26, 4(SP)
SW	R25, 8(SP)
MOVZ	R25, R2, R0
JAL	_hal_iface_init+0
NOP	
LW	R25, 8(SP)
LW	R26, 4(SP)
;atca_iface.c,150 :: 		caiface->atinit     = hal->halinit;
ADDIU	R3, R25, 8
LW	R2, 0(R26)
SW	R2, 0(R3)
;atca_iface.c,151 :: 		caiface->atpostinit = hal->halpostinit;
ADDIU	R3, R25, 12
ADDIU	R2, R26, 4
LW	R2, 0(R2)
SW	R2, 0(R3)
;atca_iface.c,152 :: 		caiface->atsend     = hal->halsend;
ADDIU	R3, R25, 16
ADDIU	R2, R26, 8
LW	R2, 0(R2)
SW	R2, 0(R3)
;atca_iface.c,153 :: 		caiface->atreceive  = hal->halreceive;
ADDIU	R3, R25, 20
ADDIU	R2, R26, 12
LW	R2, 0(R2)
SW	R2, 0(R3)
;atca_iface.c,154 :: 		caiface->atwake     = hal->halwake;
ADDIU	R3, R25, 24
ADDIU	R2, R26, 16
LW	R2, 0(R2)
SW	R2, 0(R3)
;atca_iface.c,155 :: 		caiface->atsleep    = hal->halsleep;
ADDIU	R3, R25, 32
ADDIU	R2, R26, 24
LW	R2, 0(R2)
SW	R2, 0(R3)
;atca_iface.c,156 :: 		caiface->atidle     = hal->halidle;
ADDIU	R3, R25, 28
ADDIU	R2, R26, 20
LW	R2, 0(R2)
SW	R2, 0(R3)
;atca_iface.c,157 :: 		caiface->hal_data   = hal->hal_data;
ADDIU	R3, R25, 36
ADDIU	R2, R26, 32
LW	R2, 0(R2)
SW	R2, 0(R3)
;atca_iface.c,159 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_iface.c,160 :: 		}
L_end__atinit:
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of __atinit
