_CL_hashInit:
;sha1_routines.c,45 :: 		void CL_hashInit(CL_HashContext *ctx)
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;sha1_routines.c,56 :: 		memset(ctx, 0, sizeof(*ctx));
SW	R26, 4(SP)
SW	R27, 8(SP)
ORI	R27, R0, 92
MOVZ	R26, R0, R0
JAL	_memset+0
NOP	
;sha1_routines.c,57 :: 		memcpy_P(ctx->h, hashContext_h_init, sizeof(ctx->h));
ORI	R27, R0, 20
LUI	R26, hi_addr(CL_hashInit_hashContext_h_init_L0+0)
ORI	R26, R26, lo_addr(CL_hashInit_hashContext_h_init_L0+0)
JAL	_memmove+0
NOP	
;sha1_routines.c,58 :: 		}
L_end_CL_hashInit:
LW	R27, 8(SP)
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _CL_hashInit
_CL_hashUpdate:
;sha1_routines.c,60 :: 		void CL_hashUpdate(CL_HashContext *ctx, U8 *src, int nbytes)
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;sha1_routines.c,82 :: 		freeBytes = (U8)(ctx->byteCount);
ADDIU	R2, R25, 84
LW	R2, 0(R2)
;sha1_routines.c,83 :: 		freeBytes &= 63;
ANDI	R3, R2, 63
;sha1_routines.c,84 :: 		freeBytes = (U8)(64 - freeBytes);
ORI	R2, R0, 64
SUBU	R2, R2, R3
; freeBytes start address is: 24 (R6)
ANDI	R6, R2, 255
; freeBytes end address is: 24 (R6)
;sha1_routines.c,86 :: 		while (nbytes > 0) {
L_CL_hashUpdate0:
; freeBytes start address is: 24 (R6)
SEH	R2, R27
SLTI	R2, R2, 1
BEQ	R2, R0, L__CL_hashUpdate37
NOP	
J	L_CL_hashUpdate1
NOP	
L__CL_hashUpdate37:
;sha1_routines.c,89 :: 		i = freeBytes;
; i start address is: 28 (R7)
ANDI	R7, R6, 255
;sha1_routines.c,90 :: 		if (nbytes < i) i = (U8)nbytes;
SEH	R3, R27
ANDI	R2, R6, 255
SLT	R2, R3, R2
BNE	R2, R0, L__CL_hashUpdate38
NOP	
J	L__CL_hashUpdate33
NOP	
L__CL_hashUpdate38:
ANDI	R7, R27, 255
; i end address is: 28 (R7)
J	L_CL_hashUpdate2
NOP	
L__CL_hashUpdate33:
L_CL_hashUpdate2:
;sha1_routines.c,93 :: 		if (i == 64)
; i start address is: 28 (R7)
ANDI	R3, R7, 255
ORI	R2, R0, 64
BEQ	R3, R2, L__CL_hashUpdate39
NOP	
J	L_CL_hashUpdate3
NOP	
L__CL_hashUpdate39:
;sha1_routines.c,95 :: 		*(Buf64*)(ctx->buf) = *(Buf64*)src;
ADDIU	R2, R25, 20
ORI	R4, R0, 64
MOVZ	R3, R2, R0
MOVZ	R2, R26, R0
; i end address is: 28 (R7)
ANDI	R5, R7, 255
J	L_CL_hashUpdate4
NOP	
L__CL_hashUpdate34:
L_CL_hashUpdate4:
; i start address is: 20 (R5)
; i start address is: 20 (R5)
; i end address is: 20 (R5)
; freeBytes start address is: 24 (R6)
; freeBytes end address is: 24 (R6)
LBU	R30, 0(R2)
SB	R30, 0(R3)
ADDIU	R4, R4, -1
ADDIU	R2, R2, 1
ADDIU	R3, R3, 1
BEQ	R4, R0, L__CL_hashUpdate40
NOP	
J	L__CL_hashUpdate34
NOP	
L__CL_hashUpdate40:
; i end address is: 20 (R5)
; freeBytes end address is: 24 (R6)
; freeBytes start address is: 24 (R6)
; i start address is: 20 (R5)
ANDI	R3, R6, 255
; i end address is: 20 (R5)
ANDI	R13, R5, 255
J	L_CL_hashUpdate5
NOP	
L_CL_hashUpdate3:
;sha1_routines.c,98 :: 		memcpy(((U8*)ctx->buf) + 64 - freeBytes, src, i);
; i start address is: 28 (R7)
ADDIU	R2, R25, 20
ADDIU	R3, R2, 64
ANDI	R2, R6, 255
SUBU	R2, R3, R2
SH	R27, 4(SP)
SW	R25, 8(SP)
ANDI	R27, R7, 255
MOVZ	R25, R2, R0
JAL	_memcpy+0
NOP	
; i end address is: 28 (R7)
; freeBytes end address is: 24 (R6)
LW	R25, 8(SP)
LH	R27, 4(SP)
ANDI	R3, R6, 255
ANDI	R13, R7, 255
L_CL_hashUpdate5:
;sha1_routines.c,101 :: 		src += i;
; i start address is: 52 (R13)
; freeBytes start address is: 12 (R3)
ANDI	R2, R13, 255
ADDU	R2, R26, R2
MOVZ	R26, R2, R0
;sha1_routines.c,102 :: 		nbytes -= i;
ANDI	R2, R13, 255
SUBU	R2, R27, R2
SEH	R27, R2
;sha1_routines.c,103 :: 		freeBytes -= i;
SUBU	R2, R3, R13
; freeBytes end address is: 12 (R3)
;sha1_routines.c,106 :: 		if (freeBytes == 0)
ANDI	R2, R2, 255
BEQ	R2, R0, L__CL_hashUpdate41
NOP	
J	L_CL_hashUpdate6
NOP	
L__CL_hashUpdate41:
;sha1_routines.c,107 :: 		shaEngine(ctx->buf, ctx->h);
ADDIU	R2, R25, 20
SW	R26, 4(SP)
SW	R25, 8(SP)
MOVZ	R26, R25, R0
MOVZ	R25, R2, R0
JAL	_shaEngine+0
NOP	
LW	R25, 8(SP)
LW	R26, 4(SP)
L_CL_hashUpdate6:
;sha1_routines.c,110 :: 		temp32 = (ctx->byteCount += i);
ADDIU	R4, R25, 84
LW	R3, 0(R4)
ANDI	R2, R13, 255
; i end address is: 52 (R13)
ADDU	R2, R3, R2
SW	R2, 0(R4)
LW	R2, 0(R4)
;sha1_routines.c,111 :: 		if (temp32 == 0) ++ctx->byteCountHi;
BEQ	R2, R0, L__CL_hashUpdate42
NOP	
J	L_CL_hashUpdate7
NOP	
L__CL_hashUpdate42:
ADDIU	R3, R25, 88
LW	R2, 0(R3)
ADDIU	R2, R2, 1
SW	R2, 0(R3)
L_CL_hashUpdate7:
;sha1_routines.c,114 :: 		freeBytes = 64;
; freeBytes start address is: 24 (R6)
ORI	R6, R0, 64
;sha1_routines.c,115 :: 		}
; freeBytes end address is: 24 (R6)
J	L_CL_hashUpdate0
NOP	
L_CL_hashUpdate1:
;sha1_routines.c,116 :: 		}
L_end_CL_hashUpdate:
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _CL_hashUpdate
_CL_hashFinal:
;sha1_routines.c,118 :: 		void CL_hashFinal(CL_HashContext *ctx, U8 *dest)
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;sha1_routines.c,131 :: 		nbytes = (U8)(ctx->byteCount) & 63;
SW	R27, 4(SP)
ADDIU	R2, R25, 84
LW	R2, 0(R2)
ANDI	R2, R2, 63
; nbytes start address is: 16 (R4)
ANDI	R4, R2, 255
;sha1_routines.c,132 :: 		((U8*)ctx->buf)[nbytes] = 0x80;
ADDIU	R3, R25, 20
ANDI	R2, R2, 255
ADDU	R3, R3, R2
ORI	R2, R0, 128
SB	R2, 0(R3)
;sha1_routines.c,133 :: 		for (i = (nbytes + 1); i < 64; i++) ((U8*)ctx->buf)[i] = 0;
ADDIU	R2, R4, 1
; i start address is: 20 (R5)
ANDI	R5, R2, 255
; nbytes end address is: 16 (R4)
; i end address is: 20 (R5)
L_CL_hashFinal8:
; i start address is: 20 (R5)
; nbytes start address is: 16 (R4)
ANDI	R2, R5, 255
SLTIU	R2, R2, 64
BNE	R2, R0, L__CL_hashFinal44
NOP	
J	L_CL_hashFinal9
NOP	
L__CL_hashFinal44:
ADDIU	R3, R25, 20
ANDI	R2, R5, 255
ADDU	R2, R3, R2
SB	R0, 0(R2)
ADDIU	R2, R5, 1
ANDI	R5, R2, 255
; i end address is: 20 (R5)
J	L_CL_hashFinal8
NOP	
L_CL_hashFinal9:
;sha1_routines.c,139 :: 		if (nbytes > (64 - 9)) {
ANDI	R2, R4, 255
; nbytes end address is: 16 (R4)
SLTIU	R2, R2, 56
BEQ	R2, R0, L__CL_hashFinal45
NOP	
J	L_CL_hashFinal11
NOP	
L__CL_hashFinal45:
;sha1_routines.c,140 :: 		shaEngine(ctx->buf, ctx->h);
ADDIU	R2, R25, 20
SW	R26, 8(SP)
SW	R25, 12(SP)
MOVZ	R26, R25, R0
MOVZ	R25, R2, R0
JAL	_shaEngine+0
NOP	
LW	R25, 12(SP)
;sha1_routines.c,141 :: 		memset(ctx->buf, 0, 64);
ADDIU	R2, R25, 20
SW	R25, 12(SP)
ORI	R27, R0, 64
MOVZ	R26, R0, R0
MOVZ	R25, R2, R0
JAL	_memset+0
NOP	
LW	R25, 12(SP)
LW	R26, 8(SP)
;sha1_routines.c,142 :: 		}
L_CL_hashFinal11:
;sha1_routines.c,149 :: 		temp = ctx->byteCount << 3; // low 4 bytes of bit count
ADDIU	R2, R25, 84
LW	R2, 0(R2)
SLL	R2, R2, 3
; temp start address is: 20 (R5)
MOVZ	R5, R2, R0
;sha1_routines.c,150 :: 		ptr = &((U8*)ctx->buf)[63]; // point to low byte of bit count
ADDIU	R2, R25, 20
ADDIU	R2, R2, 63
; ptr start address is: 16 (R4)
MOVZ	R4, R2, R0
;sha1_routines.c,151 :: 		for (i = 0; i < 4; i++) {
; i start address is: 12 (R3)
MOVZ	R3, R0, R0
; ptr end address is: 16 (R4)
; temp end address is: 20 (R5)
; i end address is: 12 (R3)
L_CL_hashFinal12:
; i start address is: 12 (R3)
; ptr start address is: 16 (R4)
; temp start address is: 20 (R5)
ANDI	R2, R3, 255
SLTIU	R2, R2, 4
BNE	R2, R0, L__CL_hashFinal46
NOP	
J	L_CL_hashFinal13
NOP	
L__CL_hashFinal46:
;sha1_routines.c,152 :: 		*ptr-- = (U8)temp;
SB	R5, 0(R4)
ADDIU	R2, R4, -1
MOVZ	R4, R2, R0
;sha1_routines.c,153 :: 		temp >>= 8;
SRL	R2, R5, 8
MOVZ	R5, R2, R0
;sha1_routines.c,151 :: 		for (i = 0; i < 4; i++) {
ADDIU	R2, R3, 1
ANDI	R3, R2, 255
;sha1_routines.c,154 :: 		}
; temp end address is: 20 (R5)
; i end address is: 12 (R3)
J	L_CL_hashFinal12
NOP	
L_CL_hashFinal13:
;sha1_routines.c,156 :: 		temp = ctx->byteCountHi << 3;
ADDIU	R2, R25, 88
LW	R2, 0(R2)
SLL	R3, R2, 3
;sha1_routines.c,157 :: 		temp |= ctx->byteCount >> (32 - 3); // high 4 bytes of bit count
ADDIU	R2, R25, 84
LW	R2, 0(R2)
SRL	R2, R2, 29
OR	R2, R3, R2
; temp start address is: 20 (R5)
MOVZ	R5, R2, R0
;sha1_routines.c,158 :: 		for (i = 0; i < 4; i++) {
; i start address is: 12 (R3)
MOVZ	R3, R0, R0
; ptr end address is: 16 (R4)
; temp end address is: 20 (R5)
; i end address is: 12 (R3)
L_CL_hashFinal15:
; i start address is: 12 (R3)
; temp start address is: 20 (R5)
; ptr start address is: 16 (R4)
ANDI	R2, R3, 255
SLTIU	R2, R2, 4
BNE	R2, R0, L__CL_hashFinal47
NOP	
J	L_CL_hashFinal16
NOP	
L__CL_hashFinal47:
;sha1_routines.c,159 :: 		*ptr-- = (U8)temp;
SB	R5, 0(R4)
ADDIU	R2, R4, -1
MOVZ	R4, R2, R0
;sha1_routines.c,160 :: 		temp >>= 8;
SRL	R2, R5, 8
MOVZ	R5, R2, R0
;sha1_routines.c,158 :: 		for (i = 0; i < 4; i++) {
ADDIU	R2, R3, 1
ANDI	R3, R2, 255
;sha1_routines.c,161 :: 		}
; ptr end address is: 16 (R4)
; temp end address is: 20 (R5)
; i end address is: 12 (R3)
J	L_CL_hashFinal15
NOP	
L_CL_hashFinal16:
;sha1_routines.c,165 :: 		shaEngine(ctx->buf, ctx->h);
ADDIU	R2, R25, 20
SW	R26, 8(SP)
SW	R25, 12(SP)
MOVZ	R26, R25, R0
MOVZ	R25, R2, R0
JAL	_shaEngine+0
NOP	
LW	R25, 12(SP)
LW	R26, 8(SP)
;sha1_routines.c,168 :: 		memcpy(dest, ctx->h, 20);
SW	R26, 8(SP)
SW	R25, 12(SP)
SW	R26, 16(SP)
ORI	R27, R0, 20
MOVZ	R26, R25, R0
LW	R25, 16(SP)
JAL	_memcpy+0
NOP	
LW	R25, 12(SP)
LW	R26, 8(SP)
;sha1_routines.c,169 :: 		for (i = 0; i < 5; i++) {
; i start address is: 20 (R5)
MOVZ	R5, R0, R0
; i end address is: 20 (R5)
L_CL_hashFinal18:
; i start address is: 20 (R5)
ANDI	R2, R5, 255
SLTIU	R2, R2, 5
BNE	R2, R0, L__CL_hashFinal48
NOP	
J	L_CL_hashFinal19
NOP	
L__CL_hashFinal48:
;sha1_routines.c,170 :: 		dest[i * 4 + 0] = (ctx->h[i] >> 24) & 0xFF;
ANDI	R2, R5, 255
SLL	R4, R2, 2
SEH	R2, R4
ADDU	R3, R26, R2
SEH	R2, R4
ADDU	R2, R25, R2
LW	R2, 0(R2)
SRL	R2, R2, 24
ANDI	R2, R2, 255
SB	R2, 0(R3)
;sha1_routines.c,171 :: 		dest[i * 4 + 1] = (ctx->h[i] >> 16) & 0xFF;
ANDI	R2, R5, 255
SLL	R4, R2, 2
ADDIU	R2, R4, 1
SEH	R2, R2
ADDU	R3, R26, R2
SEH	R2, R4
ADDU	R2, R25, R2
LW	R2, 0(R2)
SRL	R2, R2, 16
ANDI	R2, R2, 255
SB	R2, 0(R3)
;sha1_routines.c,172 :: 		dest[i * 4 + 2] = (ctx->h[i] >>  8) & 0xFF;
ANDI	R2, R5, 255
SLL	R4, R2, 2
ADDIU	R2, R4, 2
SEH	R2, R2
ADDU	R3, R26, R2
SEH	R2, R4
ADDU	R2, R25, R2
LW	R2, 0(R2)
SRL	R2, R2, 8
ANDI	R2, R2, 255
SB	R2, 0(R3)
;sha1_routines.c,173 :: 		dest[i * 4 + 3] = (ctx->h[i] >>  0) & 0xFF;
ANDI	R2, R5, 255
SLL	R4, R2, 2
ADDIU	R2, R4, 3
SEH	R2, R2
ADDU	R3, R26, R2
SEH	R2, R4
ADDU	R2, R25, R2
LW	R2, 0(R2)
ANDI	R2, R2, 255
SB	R2, 0(R3)
;sha1_routines.c,169 :: 		for (i = 0; i < 5; i++) {
ADDIU	R2, R5, 1
ANDI	R5, R2, 255
;sha1_routines.c,174 :: 		}
; i end address is: 20 (R5)
J	L_CL_hashFinal18
NOP	
L_CL_hashFinal19:
;sha1_routines.c,175 :: 		}
L_end_CL_hashFinal:
LW	R27, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _CL_hashFinal
_CL_hash:
;sha1_routines.c,178 :: 		void CL_hash(U8 *msg, int msgBytes, U8 *dest)
ADDIU	SP, SP, -112
SW	RA, 0(SP)
;sha1_routines.c,182 :: 		CL_hashInit(&ctx);
SW	R25, 4(SP)
SW	R26, 8(SP)
ADDIU	R2, SP, 20
SW	R27, 12(SP)
SW	R25, 16(SP)
MOVZ	R25, R2, R0
JAL	_CL_hashInit+0
NOP	
LW	R25, 16(SP)
;sha1_routines.c,183 :: 		CL_hashUpdate(&ctx, msg, msgBytes);
ADDIU	R2, SP, 20
SEH	R27, R26
MOVZ	R26, R25, R0
MOVZ	R25, R2, R0
JAL	_CL_hashUpdate+0
NOP	
LW	R27, 12(SP)
;sha1_routines.c,184 :: 		CL_hashFinal(&ctx, dest);
ADDIU	R2, SP, 20
MOVZ	R26, R27, R0
MOVZ	R25, R2, R0
JAL	_CL_hashFinal+0
NOP	
;sha1_routines.c,185 :: 		}
L_end_CL_hash:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 112
JR	RA
NOP	
; end of _CL_hash
_shaEngine:
;sha1_routines.c,187 :: 		void shaEngine(U32 *buf, U32 *h)
ADDIU	SP, SP, -4
;sha1_routines.c,205 :: 		U32 temp = 0;
; temp start address is: 16 (R4)
MOVZ	R4, R0, R0
;sha1_routines.c,207 :: 		U32 *w = (U32*)buf;
; w start address is: 20 (R5)
MOVZ	R5, R25, R0
;sha1_routines.c,214 :: 		p = (U8*)w;
; p start address is: 28 (R7)
MOVZ	R7, R25, R0
;sha1_routines.c,215 :: 		for (t = 0; t < 16; t++) {
; t start address is: 24 (R6)
MOVZ	R6, R0, R0
; p end address is: 28 (R7)
; temp end address is: 16 (R4)
; w end address is: 20 (R5)
; t end address is: 24 (R6)
L_shaEngine21:
; t start address is: 24 (R6)
; p start address is: 28 (R7)
; w start address is: 20 (R5)
; temp start address is: 16 (R4)
ANDI	R2, R6, 255
SLTIU	R2, R2, 16
BNE	R2, R0, L__shaEngine51
NOP	
J	L_shaEngine22
NOP	
L__shaEngine51:
;sha1_routines.c,216 :: 		temp = (temp << 8) | *p++;
SLL	R3, R4, 8
; temp end address is: 16 (R4)
LBU	R2, 0(R7)
ANDI	R2, R2, 255
OR	R2, R3, R2
ADDIU	R4, R7, 1
; p end address is: 28 (R7)
;sha1_routines.c,217 :: 		temp = (temp << 8) | *p++;
SLL	R3, R2, 8
LBU	R2, 0(R4)
ANDI	R2, R2, 255
OR	R2, R3, R2
ADDIU	R4, R4, 1
;sha1_routines.c,218 :: 		temp = (temp << 8) | *p++;
SLL	R3, R2, 8
LBU	R2, 0(R4)
ANDI	R2, R2, 255
OR	R2, R3, R2
ADDIU	R4, R4, 1
;sha1_routines.c,219 :: 		temp = (temp << 8) | *p++;
SLL	R3, R2, 8
LBU	R2, 0(R4)
ANDI	R2, R2, 255
OR	R3, R3, R2
; temp start address is: 28 (R7)
MOVZ	R7, R3, R0
ADDIU	R2, R4, 1
; p start address is: 16 (R4)
MOVZ	R4, R2, R0
;sha1_routines.c,220 :: 		w[t] = temp;
ANDI	R2, R6, 255
SLL	R2, R2, 2
ADDU	R2, R5, R2
SW	R3, 0(R2)
;sha1_routines.c,215 :: 		for (t = 0; t < 16; t++) {
ADDIU	R2, R6, 1
ANDI	R6, R2, 255
;sha1_routines.c,221 :: 		}
SW	R4, 0(SP)
; temp end address is: 28 (R7)
; p end address is: 16 (R4)
; t end address is: 24 (R6)
MOVZ	R4, R7, R0
LW	R7, 0(SP)
J	L_shaEngine21
NOP	
L_shaEngine22:
;sha1_routines.c,237 :: 		a = h[0];
LW	R2, 0(R26)
; a start address is: 16 (R4)
MOVZ	R4, R2, R0
;sha1_routines.c,238 :: 		b = h[1];
ADDIU	R2, R26, 4
LW	R2, 0(R2)
; b start address is: 32 (R8)
MOVZ	R8, R2, R0
;sha1_routines.c,239 :: 		c = h[2];
ADDIU	R2, R26, 8
LW	R2, 0(R2)
; c start address is: 28 (R7)
MOVZ	R7, R2, R0
;sha1_routines.c,240 :: 		d = h[3];
ADDIU	R2, R26, 12
LW	R2, 0(R2)
; d start address is: 36 (R9)
MOVZ	R9, R2, R0
;sha1_routines.c,241 :: 		e = h[4];
ADDIU	R2, R26, 16
LW	R2, 0(R2)
; e start address is: 40 (R10)
MOVZ	R10, R2, R0
;sha1_routines.c,244 :: 		for (t = 0; t < 80; t++) {
; t start address is: 24 (R6)
MOVZ	R6, R0, R0
; a end address is: 16 (R4)
; e end address is: 40 (R10)
; d end address is: 36 (R9)
; c end address is: 28 (R7)
; b end address is: 32 (R8)
; t end address is: 24 (R6)
L_shaEngine24:
; t start address is: 24 (R6)
; e start address is: 40 (R10)
; d start address is: 36 (R9)
; c start address is: 28 (R7)
; b start address is: 32 (R8)
; a start address is: 16 (R4)
; w start address is: 20 (R5)
; w end address is: 20 (R5)
ANDI	R2, R6, 255
SLTIU	R2, R2, 80
BNE	R2, R0, L__shaEngine52
NOP	
J	L_shaEngine25
NOP	
L__shaEngine52:
; w end address is: 20 (R5)
;sha1_routines.c,247 :: 		leftRotate(temp, 5);
; w start address is: 20 (R5)
SLL	R3, R4, 5
SRL	R2, R4, 27
OR	R2, R3, R2
;sha1_routines.c,248 :: 		temp += e;
ADDU	R3, R2, R10
; e end address is: 40 (R10)
;sha1_routines.c,249 :: 		temp += w[t & 0xf];
ANDI	R2, R6, 15
ANDI	R2, R2, 255
SLL	R2, R2, 2
ADDU	R2, R5, R2
LW	R2, 0(R2)
ADDU	R2, R3, R2
; temp start address is: 40 (R10)
MOVZ	R10, R2, R0
;sha1_routines.c,251 :: 		if (t < 20) {
ANDI	R2, R6, 255
SLTIU	R2, R2, 20
BNE	R2, R0, L__shaEngine53
NOP	
J	L_shaEngine27
NOP	
L__shaEngine53:
;sha1_routines.c,252 :: 		temp += (b & c) | (~b & d);
AND	R3, R8, R7
NOR	R2, R8, R0
AND	R2, R2, R9
OR	R2, R3, R2
ADDU	R3, R10, R2
; temp end address is: 40 (R10)
;sha1_routines.c,253 :: 		temp += 0x5a827999L;
LUI	R2, 23170
ORI	R2, R2, 31129
ADDU	R2, R3, R2
; temp start address is: 44 (R11)
MOVZ	R11, R2, R0
;sha1_routines.c,254 :: 		}else if (t < 40) {
; temp end address is: 44 (R11)
J	L_shaEngine28
NOP	
L_shaEngine27:
; temp start address is: 40 (R10)
ANDI	R2, R6, 255
SLTIU	R2, R2, 40
BNE	R2, R0, L__shaEngine54
NOP	
J	L_shaEngine29
NOP	
L__shaEngine54:
;sha1_routines.c,255 :: 		temp += b ^ c ^ d;
XOR	R2, R8, R7
XOR	R2, R2, R9
ADDU	R3, R10, R2
; temp end address is: 40 (R10)
;sha1_routines.c,256 :: 		temp += 0x6ed9eba1L;
LUI	R2, 28377
ORI	R2, R2, 60321
ADDU	R2, R3, R2
; temp start address is: 8 (R2)
;sha1_routines.c,257 :: 		}else if (t < 60) {
MOVZ	R11, R2, R0
; temp end address is: 8 (R2)
J	L_shaEngine30
NOP	
L_shaEngine29:
; temp start address is: 40 (R10)
ANDI	R2, R6, 255
SLTIU	R2, R2, 60
BNE	R2, R0, L__shaEngine55
NOP	
J	L_shaEngine31
NOP	
L__shaEngine55:
;sha1_routines.c,258 :: 		temp += (b & c) | (b & d) | (c & d);
AND	R3, R8, R7
AND	R2, R8, R9
OR	R3, R3, R2
AND	R2, R7, R9
OR	R2, R3, R2
ADDU	R3, R10, R2
; temp end address is: 40 (R10)
;sha1_routines.c,259 :: 		temp += 0x8f1bbcdcL;
LUI	R2, 36635
ORI	R2, R2, 48348
ADDU	R2, R3, R2
; temp start address is: 8 (R2)
;sha1_routines.c,260 :: 		}else {
; temp end address is: 8 (R2)
J	L_shaEngine32
NOP	
L_shaEngine31:
;sha1_routines.c,261 :: 		temp += b ^ c ^ d;
; temp start address is: 40 (R10)
XOR	R2, R8, R7
XOR	R2, R2, R9
ADDU	R3, R10, R2
; temp end address is: 40 (R10)
;sha1_routines.c,262 :: 		temp += 0xca62c1d6L;
LUI	R2, 51810
ORI	R2, R2, 49622
ADDU	R2, R3, R2
; temp start address is: 12 (R3)
MOVZ	R3, R2, R0
; temp end address is: 12 (R3)
MOVZ	R2, R3, R0
;sha1_routines.c,263 :: 		}
L_shaEngine32:
; temp start address is: 8 (R2)
MOVZ	R11, R2, R0
; temp end address is: 8 (R2)
L_shaEngine30:
; temp start address is: 44 (R11)
; temp end address is: 44 (R11)
L_shaEngine28:
;sha1_routines.c,265 :: 		e = d;
; temp start address is: 44 (R11)
; e start address is: 40 (R10)
MOVZ	R10, R9, R0
;sha1_routines.c,266 :: 		d = c;
MOVZ	R9, R7, R0
; c end address is: 28 (R7)
;sha1_routines.c,267 :: 		c = b; leftRotate(c, 30);
SLL	R3, R8, 30
SRL	R2, R8, 2
; b end address is: 32 (R8)
OR	R2, R3, R2
; c start address is: 28 (R7)
MOVZ	R7, R2, R0
;sha1_routines.c,268 :: 		b = a;
; b start address is: 32 (R8)
MOVZ	R8, R4, R0
; a end address is: 16 (R4)
;sha1_routines.c,269 :: 		a = temp;
; a start address is: 48 (R12)
MOVZ	R12, R11, R0
; temp end address is: 44 (R11)
;sha1_routines.c,271 :: 		temp = w[t & 0xf] ^ w[(t - 3) & 0xf] ^ w[(t - 8) & 0xf] ^ w[(t - 14) & 0xf];
ANDI	R2, R6, 15
ANDI	R2, R2, 255
SLL	R2, R2, 2
ADDU	R4, R5, R2
LW	R3, 0(R4)
ANDI	R2, R6, 255
ADDIU	R2, R2, -3
ANDI	R2, R2, 15
SEH	R2, R2
SLL	R2, R2, 2
ADDU	R2, R5, R2
LW	R2, 0(R2)
XOR	R3, R3, R2
ANDI	R2, R6, 255
ADDIU	R2, R2, -8
ANDI	R2, R2, 15
SEH	R2, R2
SLL	R2, R2, 2
ADDU	R2, R5, R2
LW	R2, 0(R2)
XOR	R3, R3, R2
ANDI	R2, R6, 255
ADDIU	R2, R2, -14
ANDI	R2, R2, 15
SEH	R2, R2
SLL	R2, R2, 2
ADDU	R2, R5, R2
LW	R2, 0(R2)
XOR	R2, R3, R2
;sha1_routines.c,272 :: 		leftRotate(temp, 1);
SLL	R3, R2, 1
SRL	R2, R2, 31
OR	R2, R3, R2
;sha1_routines.c,273 :: 		w[t & 0xf] = temp;
SW	R2, 0(R4)
;sha1_routines.c,244 :: 		for (t = 0; t < 80; t++) {
ADDIU	R2, R6, 1
ANDI	R6, R2, 255
;sha1_routines.c,275 :: 		}
; w end address is: 20 (R5)
; a end address is: 48 (R12)
; t end address is: 24 (R6)
MOVZ	R4, R12, R0
J	L_shaEngine24
NOP	
L_shaEngine25:
;sha1_routines.c,278 :: 		h[0] += a;
; a start address is: 16 (R4)
LW	R2, 0(R26)
ADDU	R2, R2, R4
; a end address is: 16 (R4)
SW	R2, 0(R26)
;sha1_routines.c,279 :: 		h[1] += b;
ADDIU	R3, R26, 4
LW	R2, 0(R3)
ADDU	R2, R2, R8
; b end address is: 32 (R8)
SW	R2, 0(R3)
;sha1_routines.c,280 :: 		h[2] += c;
ADDIU	R3, R26, 8
LW	R2, 0(R3)
ADDU	R2, R2, R7
; c end address is: 28 (R7)
SW	R2, 0(R3)
;sha1_routines.c,281 :: 		h[3] += d;
ADDIU	R3, R26, 12
LW	R2, 0(R3)
ADDU	R2, R2, R9
; d end address is: 36 (R9)
SW	R2, 0(R3)
;sha1_routines.c,282 :: 		h[4] += e;
ADDIU	R3, R26, 16
LW	R2, 0(R3)
ADDU	R2, R2, R10
; e end address is: 40 (R10)
SW	R2, 0(R3)
;sha1_routines.c,295 :: 		}
L_end_shaEngine:
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _shaEngine
