__SECURE_HAL_SECURE_HAL_write:
;__SECURE_HAL.c,109 :: 		static int SECURE_HAL_write(uint8_t *pBuf, uint16_t count)
ADDIU	SP, SP, -24
SW	RA, 0(SP)
;__SECURE_HAL.c,111 :: 		int res = 0;
SW	R25, 4(SP)
MOVZ	R30, R0, R0
SH	R30, 20(SP)
;__SECURE_HAL.c,112 :: 		uint8_t *ptr = pBuf;
SW	R25, 16(SP)
;__SECURE_HAL.c,158 :: 		res |= fpStartI2C();
LW	R30, Offset(__SECURE_HAL_fpStartI2C+0)(GP)
SH	R26, 8(SP)
JALR	RA, R30
NOP	
LH	R3, 20(SP)
OR	R2, R3, R2
SH	R2, 20(SP)
;__SECURE_HAL.c,159 :: 		res |= fpWriteI2C( (i2cAddress << 1) | WRITE_BIT );
LBU	R2, Offset(__SECURE_HAL_i2cAddress+0)(GP)
SLL	R2, R2, 1
ANDI	R25, R2, 255
LW	R30, Offset(__SECURE_HAL_fpWriteI2C+0)(GP)
JALR	RA, R30
NOP	
LHU	R26, 8(SP)
LH	R3, 20(SP)
OR	R2, R3, R2
SH	R2, 20(SP)
;__SECURE_HAL.c,160 :: 		while(count--)
L___SECURE_HAL_SECURE_HAL_write0:
ANDI	R3, R26, 65535
ADDIU	R2, R26, -1
ANDI	R26, R2, 65535
BNE	R3, R0, L___SECURE_HAL_SECURE_HAL_write26
NOP	
J	L___SECURE_HAL_SECURE_HAL_write1
NOP	
L___SECURE_HAL_SECURE_HAL_write26:
;__SECURE_HAL.c,161 :: 		res |= fpWriteI2C(*( ptr++ ));
LW	R2, 16(SP)
SH	R26, 8(SP)
SW	R25, 12(SP)
LBU	R25, 0(R2)
LW	R30, Offset(__SECURE_HAL_fpWriteI2C+0)(GP)
JALR	RA, R30
NOP	
LW	R25, 12(SP)
LHU	R26, 8(SP)
LH	R3, 20(SP)
OR	R2, R3, R2
SH	R2, 20(SP)
LW	R2, 16(SP)
ADDIU	R2, R2, 1
SW	R2, 16(SP)
J	L___SECURE_HAL_SECURE_HAL_write0
NOP	
L___SECURE_HAL_SECURE_HAL_write1:
;__SECURE_HAL.c,162 :: 		fpStopI2C();
LW	R30, Offset(__SECURE_HAL_fpStopI2C+0)(GP)
SH	R26, 8(SP)
SW	R25, 12(SP)
JALR	RA, R30
NOP	
LW	R25, 12(SP)
LHU	R26, 8(SP)
;__SECURE_HAL.c,164 :: 		return res;
LH	R2, 20(SP)
;__SECURE_HAL.c,165 :: 		}
;__SECURE_HAL.c,164 :: 		return res;
;__SECURE_HAL.c,165 :: 		}
L_end_SECURE_HAL_write:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 24
JR	RA
NOP	
; end of __SECURE_HAL_SECURE_HAL_write
__SECURE_HAL_SECURE_HAL_read:
;__SECURE_HAL.c,167 :: 		static int SECURE_HAL_read(uint8_t *pBuf, uint16_t count)
ADDIU	SP, SP, -24
SW	RA, 0(SP)
;__SECURE_HAL.c,169 :: 		int res = 0;
SW	R25, 4(SP)
MOVZ	R30, R0, R0
SH	R30, 20(SP)
;__SECURE_HAL.c,170 :: 		uint8_t *ptr = pBuf;
SW	R25, 16(SP)
;__SECURE_HAL.c,222 :: 		res |= fpStartI2C();
LW	R30, Offset(__SECURE_HAL_fpStartI2C+0)(GP)
SH	R26, 8(SP)
JALR	RA, R30
NOP	
LH	R3, 20(SP)
OR	R2, R3, R2
SH	R2, 20(SP)
;__SECURE_HAL.c,223 :: 		res |= fpWriteI2C((i2cAddress << 1) | READ_BIT);
LBU	R2, Offset(__SECURE_HAL_i2cAddress+0)(GP)
SLL	R2, R2, 1
ORI	R2, R2, 1
ANDI	R25, R2, 255
LW	R30, Offset(__SECURE_HAL_fpWriteI2C+0)(GP)
JALR	RA, R30
NOP	
LHU	R26, 8(SP)
LH	R3, 20(SP)
OR	R2, R3, R2
SH	R2, 20(SP)
;__SECURE_HAL.c,224 :: 		while(--count)
L___SECURE_HAL_SECURE_HAL_read2:
ADDIU	R2, R26, -1
ANDI	R26, R2, 65535
BNE	R2, R0, L___SECURE_HAL_SECURE_HAL_read29
NOP	
J	L___SECURE_HAL_SECURE_HAL_read3
NOP	
L___SECURE_HAL_SECURE_HAL_read29:
;__SECURE_HAL.c,225 :: 		*ptr++ = fpReadI2C(ACK_BIT);
SH	R26, 8(SP)
SW	R25, 12(SP)
LBU	R25, Offset(__SECURE_HAL_ACK_BIT+0)(GP)
LW	R30, Offset(__SECURE_HAL_fpReadI2C+0)(GP)
JALR	RA, R30
NOP	
LW	R25, 12(SP)
LHU	R26, 8(SP)
LW	R3, 16(SP)
SB	R2, 0(R3)
LW	R2, 16(SP)
ADDIU	R2, R2, 1
SW	R2, 16(SP)
J	L___SECURE_HAL_SECURE_HAL_read2
NOP	
L___SECURE_HAL_SECURE_HAL_read3:
;__SECURE_HAL.c,226 :: 		*ptr = fpReadI2C(NACK_BIT);
SH	R26, 8(SP)
SW	R25, 12(SP)
LBU	R25, Offset(__SECURE_HAL_NACK_BIT+0)(GP)
LW	R30, Offset(__SECURE_HAL_fpReadI2C+0)(GP)
JALR	RA, R30
NOP	
LW	R3, 16(SP)
SB	R2, 0(R3)
;__SECURE_HAL.c,227 :: 		fpStopI2C();
LW	R30, Offset(__SECURE_HAL_fpStopI2C+0)(GP)
JALR	RA, R30
NOP	
LW	R25, 12(SP)
LHU	R26, 8(SP)
;__SECURE_HAL.c,229 :: 		return res;
LH	R2, 20(SP)
;__SECURE_HAL.c,230 :: 		}
;__SECURE_HAL.c,229 :: 		return res;
;__SECURE_HAL.c,230 :: 		}
L_end_SECURE_HAL_read:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 24
JR	RA
NOP	
; end of __SECURE_HAL_SECURE_HAL_read
_secure_4_hal_init:
;__SECURE_HAL.c,287 :: 		)
; fpRead start address is: 8 (R2)
LW	R2, 0(SP)
;__SECURE_HAL.c,314 :: 		fpStopI2C       = fpStop;
SW	R27, Offset(__SECURE_HAL_fpStopI2C+0)(GP)
;__SECURE_HAL.c,315 :: 		fpStartI2C      = fpStart;
SW	R26, Offset(__SECURE_HAL_fpStartI2C+0)(GP)
;__SECURE_HAL.c,316 :: 		fpWriteI2C      = fpWrite;
SW	R28, Offset(__SECURE_HAL_fpWriteI2C+0)(GP)
;__SECURE_HAL.c,317 :: 		fpReadI2C       = fpRead;
SW	R2, Offset(__SECURE_HAL_fpReadI2C+0)(GP)
; fpRead end address is: 8 (R2)
;__SECURE_HAL.c,332 :: 		i2cAddress        = slaveAddress;
SB	R25, Offset(__SECURE_HAL_i2cAddress+0)(GP)
;__SECURE_HAL.c,335 :: 		}
L_end_secure_4_hal_init:
JR	RA
NOP	
; end of _secure_4_hal_init
_hal_i2c_init:
;__SECURE_HAL.c,337 :: 		ATCA_STATUS hal_i2c_init(void *hal, ATCAIfaceCfg *cfg)
;__SECURE_HAL.c,339 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;__SECURE_HAL.c,340 :: 		}
L_end_hal_i2c_init:
JR	RA
NOP	
; end of _hal_i2c_init
_hal_i2c_post_init:
;__SECURE_HAL.c,342 :: 		ATCA_STATUS hal_i2c_post_init(ATCAIface iface)
;__SECURE_HAL.c,344 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;__SECURE_HAL.c,345 :: 		}
L_end_hal_i2c_post_init:
JR	RA
NOP	
; end of _hal_i2c_post_init
_hal_i2c_send:
;__SECURE_HAL.c,347 :: 		ATCA_STATUS hal_i2c_send(ATCAIface iface, uint8_t *txdata, int txlength)
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;__SECURE_HAL.c,349 :: 		ATCAIfaceCfg *cfg = atgetifacecfg(iface);
SW	R25, 4(SP)
SW	R26, 8(SP)
SH	R27, 12(SP)
SW	R26, 16(SP)
JAL	_atgetifacecfg+0
NOP	
LW	R26, 16(SP)
LH	R27, 12(SP)
;__SECURE_HAL.c,351 :: 		txdata[0] = 0x03;
ORI	R2, R0, 3
SB	R2, 0(R26)
;__SECURE_HAL.c,352 :: 		txlength++;
ADDIU	R2, R27, 1
SEH	R27, R2
;__SECURE_HAL.c,354 :: 		if( !SECURE_HAL_write( txdata, txlength ) )
MOVZ	R25, R26, R0
SEH	R26, R2
JAL	__SECURE_HAL_SECURE_HAL_write+0
NOP	
BEQ	R2, R0, L__hal_i2c_send34
NOP	
J	L_hal_i2c_send4
NOP	
L__hal_i2c_send34:
;__SECURE_HAL.c,355 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
J	L_end_hal_i2c_send
NOP	
L_hal_i2c_send4:
;__SECURE_HAL.c,357 :: 		return ATCA_COMM_FAIL;
ORI	R2, R0, 240
;__SECURE_HAL.c,358 :: 		}
;__SECURE_HAL.c,357 :: 		return ATCA_COMM_FAIL;
;__SECURE_HAL.c,358 :: 		}
L_end_hal_i2c_send:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _hal_i2c_send
_hal_i2c_receive:
;__SECURE_HAL.c,360 :: 		ATCA_STATUS hal_i2c_receive(ATCAIface iface, uint8_t *rxdata, uint16_t *rxlength)
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;__SECURE_HAL.c,362 :: 		ATCAIfaceCfg *cfg = atgetifacecfg(iface);
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
SW	R26, 16(SP)
JAL	_atgetifacecfg+0
NOP	
LW	R26, 16(SP)
LW	R27, 12(SP)
;__SECURE_HAL.c,364 :: 		if( !SECURE_HAL_read(rxdata,*rxlength) )
MOVZ	R25, R26, R0
LHU	R26, 0(R27)
JAL	__SECURE_HAL_SECURE_HAL_read+0
NOP	
BEQ	R2, R0, L__hal_i2c_receive36
NOP	
J	L_hal_i2c_receive6
NOP	
L__hal_i2c_receive36:
;__SECURE_HAL.c,365 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
J	L_end_hal_i2c_receive
NOP	
L_hal_i2c_receive6:
;__SECURE_HAL.c,367 :: 		return ATCA_COMM_FAIL;
ORI	R2, R0, 240
;__SECURE_HAL.c,368 :: 		}
;__SECURE_HAL.c,367 :: 		return ATCA_COMM_FAIL;
;__SECURE_HAL.c,368 :: 		}
L_end_hal_i2c_receive:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _hal_i2c_receive
_hal_i2c_wake:
;__SECURE_HAL.c,370 :: 		ATCA_STATUS hal_i2c_wake(ATCAIface iface)
ADDIU	SP, SP, -44
SW	RA, 0(SP)
;__SECURE_HAL.c,372 :: 		ATCAIfaceCfg *cfg   = atgetifacecfg(iface);
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
JAL	_atgetifacecfg+0
NOP	
SW	R2, 20(SP)
;__SECURE_HAL.c,373 :: 		int retries = cfg->rx_retries;
ADDIU	R3, R2, 38
LH	R3, 0(R3)
SH	R3, 24(SP)
;__SECURE_HAL.c,374 :: 		ATCADeviceType devType = cfg->devtype;
ADDIU	R2, R2, 1
LBU	R2, 0(R2)
SB	R2, 26(SP)
;__SECURE_HAL.c,375 :: 		uint8_t expected[4] = {0x04,0x11,0x33,0x43};
ORI	R30, R0, 4
SB	R30, 31(SP)
ORI	R30, R0, 17
SB	R30, 32(SP)
ORI	R30, R0, 51
SB	R30, 33(SP)
ORI	R30, R0, 67
SB	R30, 34(SP)
;__SECURE_HAL.c,381 :: 		memset(data_,0x00,4);
ADDIU	R2, SP, 27
ORI	R27, R0, 4
MOVZ	R26, R0, R0
MOVZ	R25, R2, R0
JAL	_memset+0
NOP	
;__SECURE_HAL.c,382 :: 		if( data_[0] != 0x00 )
ADDIU	R2, SP, 27
LBU	R2, 0(R2)
ANDI	R2, R2, 255
BNE	R2, R0, L__hal_i2c_wake39
NOP	
J	L_hal_i2c_wake8
NOP	
L__hal_i2c_wake39:
;__SECURE_HAL.c,383 :: 		return;
J	L_end_hal_i2c_wake
NOP	
L_hal_i2c_wake8:
;__SECURE_HAL.c,386 :: 		if (devType == ATECC508A)
LBU	R3, 26(SP)
ORI	R2, R0, 2
BEQ	R3, R2, L__hal_i2c_wake40
NOP	
J	L_hal_i2c_wake9
NOP	
L__hal_i2c_wake40:
;__SECURE_HAL.c,388 :: 		while( retries-- > 0 )
L_hal_i2c_wake10:
LH	R3, 24(SP)
LH	R2, 24(SP)
ADDIU	R2, R2, -1
SH	R2, 24(SP)
SEH	R2, R3
SLTI	R2, R2, 1
BEQ	R2, R0, L__hal_i2c_wake41
NOP	
J	L_hal_i2c_wake11
NOP	
L__hal_i2c_wake41:
;__SECURE_HAL.c,391 :: 		fpStartI2C();
LW	R30, Offset(__SECURE_HAL_fpStartI2C+0)(GP)
SW	R25, 16(SP)
JALR	RA, R30
NOP	
;__SECURE_HAL.c,392 :: 		fpWriteI2C( (i2cAddress << 1) | READ_BIT );
LBU	R2, Offset(__SECURE_HAL_i2cAddress+0)(GP)
SLL	R2, R2, 1
ORI	R2, R2, 1
ANDI	R25, R2, 255
LW	R30, Offset(__SECURE_HAL_fpWriteI2C+0)(GP)
JALR	RA, R30
NOP	
;__SECURE_HAL.c,393 :: 		fpStopI2C();
LW	R30, Offset(__SECURE_HAL_fpStopI2C+0)(GP)
JALR	RA, R30
NOP	
;__SECURE_HAL.c,396 :: 		atca_delay_ms( ((uint32_t)cfg->wake_delay + (1000 - 1)) / 1000 );
LW	R2, 20(SP)
ADDIU	R2, R2, 36
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
ADDIU	R3, R2, 999
ORI	R2, R0, 1000
DIVU	R3, R2
MFLO	R2
MOVZ	R25, R2, R0
JAL	_atca_delay_ms+0
NOP	
;__SECURE_HAL.c,399 :: 		fpStartI2C();
LW	R30, Offset(__SECURE_HAL_fpStartI2C+0)(GP)
JALR	RA, R30
NOP	
;__SECURE_HAL.c,400 :: 		fpWriteI2C( (i2cAddress << 1) | READ_BIT );
LBU	R2, Offset(__SECURE_HAL_i2cAddress+0)(GP)
SLL	R2, R2, 1
ORI	R2, R2, 1
ANDI	R25, R2, 255
LW	R30, Offset(__SECURE_HAL_fpWriteI2C+0)(GP)
JALR	RA, R30
NOP	
;__SECURE_HAL.c,401 :: 		data_[0] = fpReadI2C( ACK_BIT );
ADDIU	R2, SP, 27
SW	R2, 40(SP)
LBU	R25, Offset(__SECURE_HAL_ACK_BIT+0)(GP)
LW	R30, Offset(__SECURE_HAL_fpReadI2C+0)(GP)
JALR	RA, R30
NOP	
LW	R3, 40(SP)
SB	R2, 0(R3)
;__SECURE_HAL.c,402 :: 		data_[1] = fpReadI2C( ACK_BIT );
ADDIU	R2, SP, 27
ADDIU	R2, R2, 1
SW	R2, 40(SP)
LBU	R25, Offset(__SECURE_HAL_ACK_BIT+0)(GP)
LW	R30, Offset(__SECURE_HAL_fpReadI2C+0)(GP)
JALR	RA, R30
NOP	
LW	R3, 40(SP)
SB	R2, 0(R3)
;__SECURE_HAL.c,403 :: 		data_[2] = fpReadI2C( ACK_BIT );
ADDIU	R2, SP, 27
ADDIU	R2, R2, 2
SW	R2, 40(SP)
LBU	R25, Offset(__SECURE_HAL_ACK_BIT+0)(GP)
LW	R30, Offset(__SECURE_HAL_fpReadI2C+0)(GP)
JALR	RA, R30
NOP	
LW	R3, 40(SP)
SB	R2, 0(R3)
;__SECURE_HAL.c,404 :: 		data_[3] = fpReadI2C( NACK_BIT );
ADDIU	R2, SP, 27
ADDIU	R2, R2, 3
SW	R2, 40(SP)
LBU	R25, Offset(__SECURE_HAL_NACK_BIT+0)(GP)
LW	R30, Offset(__SECURE_HAL_fpReadI2C+0)(GP)
JALR	RA, R30
NOP	
LW	R3, 40(SP)
SB	R2, 0(R3)
;__SECURE_HAL.c,405 :: 		fpStopI2C();
LW	R30, Offset(__SECURE_HAL_fpStopI2C+0)(GP)
JALR	RA, R30
NOP	
;__SECURE_HAL.c,408 :: 		if(!memcmp(data_,expected,4))
ADDIU	R3, SP, 31
ADDIU	R2, SP, 27
ORI	R27, R0, 4
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_memcmp+0
NOP	
LW	R25, 16(SP)
BEQ	R2, R0, L__hal_i2c_wake42
NOP	
J	L_hal_i2c_wake12
NOP	
L__hal_i2c_wake42:
;__SECURE_HAL.c,409 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
J	L_end_hal_i2c_wake
NOP	
L_hal_i2c_wake12:
;__SECURE_HAL.c,411 :: 		}
J	L_hal_i2c_wake10
NOP	
L_hal_i2c_wake11:
;__SECURE_HAL.c,412 :: 		}
L_hal_i2c_wake9:
;__SECURE_HAL.c,414 :: 		if (devType == ATSHA204A)
LBU	R2, 26(SP)
BEQ	R2, R0, L__hal_i2c_wake43
NOP	
J	L_hal_i2c_wake13
NOP	
L__hal_i2c_wake43:
;__SECURE_HAL.c,416 :: 		while( retries-- > 0 )
LH	R2, 24(SP)
SEH	R2, R2
SLTI	R2, R2, 1
BEQ	R2, R0, L__hal_i2c_wake44
NOP	
J	L_hal_i2c_wake15
NOP	
L__hal_i2c_wake44:
;__SECURE_HAL.c,419 :: 		fpStartI2C();
LW	R30, Offset(__SECURE_HAL_fpStartI2C+0)(GP)
SW	R25, 16(SP)
JALR	RA, R30
NOP	
;__SECURE_HAL.c,420 :: 		fpWriteI2C( 0x00 );
MOVZ	R25, R0, R0
LW	R30, Offset(__SECURE_HAL_fpWriteI2C+0)(GP)
JALR	RA, R30
NOP	
;__SECURE_HAL.c,421 :: 		fpWriteI2C( 0x00 );
MOVZ	R25, R0, R0
LW	R30, Offset(__SECURE_HAL_fpWriteI2C+0)(GP)
JALR	RA, R30
NOP	
;__SECURE_HAL.c,422 :: 		fpStopI2C();
LW	R30, Offset(__SECURE_HAL_fpStopI2C+0)(GP)
JALR	RA, R30
NOP	
;__SECURE_HAL.c,425 :: 		atca_delay_ms( ((uint32_t)cfg->wake_delay + (1000 - 1)) / 1000 );
LW	R2, 20(SP)
ADDIU	R2, R2, 36
LHU	R2, 0(R2)
ANDI	R2, R2, 65535
ADDIU	R3, R2, 999
ORI	R2, R0, 1000
DIVU	R3, R2
MFLO	R2
MOVZ	R25, R2, R0
JAL	_atca_delay_ms+0
NOP	
LW	R25, 16(SP)
;__SECURE_HAL.c,429 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
J	L_end_hal_i2c_wake
NOP	
;__SECURE_HAL.c,431 :: 		}
L_hal_i2c_wake15:
;__SECURE_HAL.c,432 :: 		}
L_hal_i2c_wake13:
;__SECURE_HAL.c,434 :: 		return ATCA_COMM_FAIL;
ORI	R2, R0, 240
;__SECURE_HAL.c,435 :: 		}
;__SECURE_HAL.c,434 :: 		return ATCA_COMM_FAIL;
;__SECURE_HAL.c,435 :: 		}
L_end_hal_i2c_wake:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 44
JR	RA
NOP	
; end of _hal_i2c_wake
_hal_i2c_idle:
;__SECURE_HAL.c,437 :: 		ATCA_STATUS hal_i2c_idle(ATCAIface iface)
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;__SECURE_HAL.c,439 :: 		ATCAIfaceCfg *cfg = atgetifacecfg(iface);
SW	R25, 4(SP)
SW	R26, 8(SP)
JAL	_atgetifacecfg+0
NOP	
;__SECURE_HAL.c,442 :: 		data_[0] = 0x02;
ADDIU	R3, SP, 12
ORI	R2, R0, 2
SB	R2, 0(R3)
;__SECURE_HAL.c,443 :: 		if(SECURE_HAL_write(data_,1))
ORI	R26, R0, 1
MOVZ	R25, R3, R0
JAL	__SECURE_HAL_SECURE_HAL_write+0
NOP	
BNE	R2, R0, L__hal_i2c_idle47
NOP	
J	L_hal_i2c_idle16
NOP	
L__hal_i2c_idle47:
;__SECURE_HAL.c,444 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
J	L_end_hal_i2c_idle
NOP	
L_hal_i2c_idle16:
;__SECURE_HAL.c,445 :: 		return ATCA_COMM_FAIL;
ORI	R2, R0, 240
;__SECURE_HAL.c,447 :: 		}
;__SECURE_HAL.c,445 :: 		return ATCA_COMM_FAIL;
;__SECURE_HAL.c,447 :: 		}
L_end_hal_i2c_idle:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _hal_i2c_idle
_hal_i2c_sleep:
;__SECURE_HAL.c,449 :: 		ATCA_STATUS hal_i2c_sleep(ATCAIface iface)
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;__SECURE_HAL.c,451 :: 		ATCAIfaceCfg *cfg = atgetifacecfg(iface);
SW	R25, 4(SP)
SW	R26, 8(SP)
JAL	_atgetifacecfg+0
NOP	
;__SECURE_HAL.c,454 :: 		data_[0] = 0x01;
ADDIU	R3, SP, 12
ORI	R2, R0, 1
SB	R2, 0(R3)
;__SECURE_HAL.c,455 :: 		if(SECURE_HAL_write(data_,1))
ORI	R26, R0, 1
MOVZ	R25, R3, R0
JAL	__SECURE_HAL_SECURE_HAL_write+0
NOP	
BNE	R2, R0, L__hal_i2c_sleep50
NOP	
J	L_hal_i2c_sleep17
NOP	
L__hal_i2c_sleep50:
;__SECURE_HAL.c,456 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
J	L_end_hal_i2c_sleep
NOP	
L_hal_i2c_sleep17:
;__SECURE_HAL.c,457 :: 		return ATCA_COMM_FAIL;
ORI	R2, R0, 240
;__SECURE_HAL.c,458 :: 		}
;__SECURE_HAL.c,457 :: 		return ATCA_COMM_FAIL;
;__SECURE_HAL.c,458 :: 		}
L_end_hal_i2c_sleep:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _hal_i2c_sleep
_hal_i2c_release:
;__SECURE_HAL.c,460 :: 		ATCA_STATUS hal_i2c_release(void *hal_data)
;__SECURE_HAL.c,462 :: 		return ATCA_UNIMPLEMENTED;
ORI	R2, R0, 245
;__SECURE_HAL.c,463 :: 		}
L_end_hal_i2c_release:
JR	RA
NOP	
; end of _hal_i2c_release
_hal_i2c_discover_buses:
;__SECURE_HAL.c,465 :: 		ATCA_STATUS hal_i2c_discover_buses(int i2c_buses[], int max_buses)
;__SECURE_HAL.c,467 :: 		return ATCA_UNIMPLEMENTED;
ORI	R2, R0, 245
;__SECURE_HAL.c,468 :: 		}
L_end_hal_i2c_discover_buses:
JR	RA
NOP	
; end of _hal_i2c_discover_buses
_hal_i2c_discover_devices:
;__SECURE_HAL.c,470 :: 		ATCA_STATUS hal_i2c_discover_devices(int busNum, ATCAIfaceCfg *cfg, int *found)
;__SECURE_HAL.c,472 :: 		return ATCA_UNIMPLEMENTED;
ORI	R2, R0, 245
;__SECURE_HAL.c,473 :: 		}
L_end_hal_i2c_discover_devices:
JR	RA
NOP	
; end of _hal_i2c_discover_devices
_atca_delay_us:
;__SECURE_HAL.c,475 :: 		void atca_delay_us(uint32_t delay)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;__SECURE_HAL.c,484 :: 		while( delay-- )
L_atca_delay_us18:
MOVZ	R3, R25, R0
ADDIU	R2, R25, -1
MOVZ	R25, R2, R0
BNE	R3, R0, L__atca_delay_us56
NOP	
J	L_atca_delay_us19
NOP	
L__atca_delay_us56:
;__SECURE_HAL.c,485 :: 		Delay_1us();
JAL	_Delay_1us+0
NOP	
J	L_atca_delay_us18
NOP	
L_atca_delay_us19:
;__SECURE_HAL.c,487 :: 		}
L_end_atca_delay_us:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atca_delay_us
_atca_delay_10us:
;__SECURE_HAL.c,489 :: 		void atca_delay_10us(uint32_t delay)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;__SECURE_HAL.c,498 :: 		while( delay-- )
L_atca_delay_10us20:
MOVZ	R3, R25, R0
ADDIU	R2, R25, -1
MOVZ	R25, R2, R0
BNE	R3, R0, L__atca_delay_10us59
NOP	
J	L_atca_delay_10us21
NOP	
L__atca_delay_10us59:
;__SECURE_HAL.c,499 :: 		Delay_10us();
JAL	_Delay_10us+0
NOP	
J	L_atca_delay_10us20
NOP	
L_atca_delay_10us21:
;__SECURE_HAL.c,501 :: 		}
L_end_atca_delay_10us:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atca_delay_10us
_atca_delay_ms:
;__SECURE_HAL.c,503 :: 		void atca_delay_ms(uint32_t delay)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;__SECURE_HAL.c,512 :: 		while( delay-- )
L_atca_delay_ms22:
MOVZ	R3, R25, R0
ADDIU	R2, R25, -1
MOVZ	R25, R2, R0
BNE	R3, R0, L__atca_delay_ms62
NOP	
J	L_atca_delay_ms23
NOP	
L__atca_delay_ms62:
;__SECURE_HAL.c,513 :: 		Delay_1ms();
JAL	_Delay_1ms+0
NOP	
J	L_atca_delay_ms22
NOP	
L_atca_delay_ms23:
;__SECURE_HAL.c,515 :: 		}
L_end_atca_delay_ms:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atca_delay_ms
