_atcatls_config_default:
;atcatls.c,230 :: 		ATCA_STATUS atcatls_config_default()
ADDIU	SP, SP, -84
SW	RA, 0(SP)
;atcatls.c,232 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R25, 4(SP)
SW	R26, 8(SP)
;atcatls.c,233 :: 		bool isLocked = false;
ADDIU	R23, SP, 12
ADDIU	R22, R23, 70
LUI	R24, hi_addr(?ICSatcatls_config_default_isLocked_L0+0)
ORI	R24, R24, lo_addr(?ICSatcatls_config_default_isLocked_L0+0)
JAL	___CC2DW+0
NOP	
;atcatls.c,234 :: 		bool sameConfig = false;
;atcatls.c,235 :: 		uint8_t lockRsp[LOCK_RSP_SIZE] = { 0 };
;atcatls.c,236 :: 		uint8_t pubkey[ATCA_PUB_KEY_SIZE] = { 0 };
;atcatls.c,240 :: 		if ((status = atcab_is_locked(LOCK_ZONE_CONFIG, &isLocked)) != ATCA_SUCCESS) BREAK(status, "Read of lock byte failed");
ADDIU	R2, SP, 12
MOVZ	R26, R2, R0
MOVZ	R25, R0, R0
JAL	_atcab_is_locked+0
NOP	
SB	R2, 82(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_config_default214
NOP	
J	L_atcatls_config_default3
NOP	
L__atcatls_config_default214:
J	L_atcatls_config_default1
NOP	
L_atcatls_config_default3:
;atcatls.c,242 :: 		if (isLocked == false) {
LBU	R2, 12(SP)
BEQ	R2, R0, L__atcatls_config_default215
NOP	
J	L_atcatls_config_default4
NOP	
L__atcatls_config_default215:
;atcatls.c,244 :: 		if ((status = atcab_write_ecc_config_zone(config_data_default)) != ATCA_SUCCESS) BREAK(status, "Write config zone failed");
LUI	R25, hi_addr(_config_data_default+0)
ORI	R25, R25, lo_addr(_config_data_default+0)
JAL	_atcab_write_ecc_config_zone+0
NOP	
SB	R2, 82(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_config_default217
NOP	
J	L_atcatls_config_default5
NOP	
L__atcatls_config_default217:
J	L_atcatls_config_default1
NOP	
L_atcatls_config_default5:
;atcatls.c,247 :: 		if ((status = atcab_lock_config_zone(lockRsp) != ATCA_SUCCESS)) BREAK(status, "Lock config zone failed");
ADDIU	R2, SP, 14
MOVZ	R25, R2, R0
JAL	_atcab_lock_config_zone+0
NOP	
ANDI	R2, R2, 255
XORI	R2, R2, 0
SLTU	R2, R0, R2
SB	R2, 82(SP)
BNE	R2, R0, L__atcatls_config_default220
NOP	
J	L_atcatls_config_default6
NOP	
L__atcatls_config_default220:
J	L_atcatls_config_default1
NOP	
L_atcatls_config_default6:
;atcatls.c,251 :: 		if ((status = atcab_genkey(TLS_SLOT_AUTH_PRIV, pubkey)) != ATCA_SUCCESS) BREAK(status, "Genkey failed:AUTH_PRIV_SLOT");
ADDIU	R2, SP, 18
MOVZ	R26, R2, R0
MOVZ	R25, R0, R0
JAL	_atcab_genkey+0
NOP	
SB	R2, 82(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_config_default222
NOP	
J	L_atcatls_config_default7
NOP	
L__atcatls_config_default222:
J	L_atcatls_config_default1
NOP	
L_atcatls_config_default7:
;atcatls.c,252 :: 		if ((status = atcab_genkey(TLS_SLOT_ECDH_PRIV, pubkey)) != ATCA_SUCCESS) BREAK(status, "Genkey failed:ECDH_PRIV_SLOT");
ADDIU	R2, SP, 18
MOVZ	R26, R2, R0
ORI	R25, R0, 2
JAL	_atcab_genkey+0
NOP	
SB	R2, 82(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_config_default224
NOP	
J	L_atcatls_config_default8
NOP	
L__atcatls_config_default224:
J	L_atcatls_config_default1
NOP	
L_atcatls_config_default8:
;atcatls.c,253 :: 		if ((status = atcab_genkey(TLS_SLOT_FEATURE_PRIV, pubkey)) != ATCA_SUCCESS) BREAK(status, "Genkey failed:FEATURE_PRIV_SLOT");
ADDIU	R2, SP, 18
MOVZ	R26, R2, R0
ORI	R25, R0, 7
JAL	_atcab_genkey+0
NOP	
SB	R2, 82(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_config_default226
NOP	
J	L_atcatls_config_default9
NOP	
L__atcatls_config_default226:
J	L_atcatls_config_default1
NOP	
L_atcatls_config_default9:
;atcatls.c,254 :: 		}else {
J	L_atcatls_config_default10
NOP	
L_atcatls_config_default4:
;atcatls.c,256 :: 		if ((status = atcab_cmp_config_zone(config_data_default, &sameConfig)) != ATCA_SUCCESS) BREAK(status, "Config compare failed");
ADDIU	R2, SP, 13
MOVZ	R26, R2, R0
LUI	R25, hi_addr(_config_data_default+0)
ORI	R25, R25, lo_addr(_config_data_default+0)
JAL	_atcab_cmp_config_zone+0
NOP	
SB	R2, 82(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_config_default228
NOP	
J	L_atcatls_config_default11
NOP	
L__atcatls_config_default228:
J	L_atcatls_config_default1
NOP	
L_atcatls_config_default11:
;atcatls.c,257 :: 		if (sameConfig == false) {
LBU	R2, 13(SP)
BEQ	R2, R0, L__atcatls_config_default229
NOP	
J	L_atcatls_config_default12
NOP	
L__atcatls_config_default229:
;atcatls.c,259 :: 		status = ATCA_GEN_FAIL;
ORI	R2, R0, 225
SB	R2, 82(SP)
;atcatls.c,260 :: 		BREAK(status, "The device is locked with the wrong configuration");
J	L_atcatls_config_default1
NOP	
;atcatls.c,261 :: 		}
L_atcatls_config_default12:
;atcatls.c,262 :: 		}
L_atcatls_config_default10:
;atcatls.c,265 :: 		atcab_lock_data_zone(lockRsp);
ADDIU	R2, SP, 14
MOVZ	R25, R2, R0
JAL	_atcab_lock_data_zone+0
NOP	
;atcatls.c,267 :: 		} while (0);
L_atcatls_config_default1:
;atcatls.c,269 :: 		return status;
LBU	R2, 82(SP)
;atcatls.c,270 :: 		}
;atcatls.c,269 :: 		return status;
;atcatls.c,270 :: 		}
L_end_atcatls_config_default:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 84
JR	RA
NOP	
; end of _atcatls_config_default
_atcatls_init:
;atcatls.c,276 :: 		ATCA_STATUS atcatls_init(ATCAIfaceCfg* pCfg)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atcatls.c,278 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,281 :: 		status = atcab_init(pCfg);
JAL	_atcab_init+0
NOP	
;atcatls.c,282 :: 		return status;
;atcatls.c,283 :: 		}
L_end_atcatls_init:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcatls_init
_atcatls_finish:
;atcatls.c,288 :: 		ATCA_STATUS atcatls_finish()
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atcatls.c,290 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,293 :: 		status = atcab_release();
JAL	_atcab_release+0
NOP	
;atcatls.c,294 :: 		return status;
;atcatls.c,295 :: 		}
L_end_atcatls_finish:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcatls_finish
_atcatls_get_sn:
;atcatls.c,301 :: 		ATCA_STATUS atcatls_get_sn(uint8_t sn_out[ATCA_SERIAL_NUM_SIZE])
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atcatls.c,303 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,307 :: 		if ((status = atcab_read_serial_number(sn_out)) != ATCA_SUCCESS) BREAK(status, "Get serial number failed");
JAL	_atcab_read_serial_number+0
NOP	
; status start address is: 12 (R3)
ANDI	R3, R2, 255
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_get_sn234
NOP	
J	L_atcatls_get_sn16
NOP	
L__atcatls_get_sn234:
J	L_atcatls_get_sn14
NOP	
L_atcatls_get_sn16:
;atcatls.c,309 :: 		} while (0);
L_atcatls_get_sn14:
;atcatls.c,311 :: 		return status;
ANDI	R2, R3, 255
; status end address is: 12 (R3)
;atcatls.c,312 :: 		}
L_end_atcatls_get_sn:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcatls_get_sn
_atcatls_sign:
;atcatls.c,320 :: 		ATCA_STATUS atcatls_sign(uint8_t slotid, uint8_t *message, uint8_t *signature)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atcatls.c,322 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,326 :: 		if (message == NULL || signature == NULL) {
BNE	R26, R0, L__atcatls_sign237
NOP	
J	L__atcatls_sign173
NOP	
L__atcatls_sign237:
BNE	R27, R0, L__atcatls_sign239
NOP	
J	L__atcatls_sign172
NOP	
L__atcatls_sign239:
J	L_atcatls_sign22
NOP	
L__atcatls_sign173:
L__atcatls_sign172:
;atcatls.c,327 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,328 :: 		BREAK(status, "Bad input parameters");
; status end address is: 8 (R2)
J	L_atcatls_sign18
NOP	
;atcatls.c,329 :: 		}
L_atcatls_sign22:
;atcatls.c,331 :: 		if ((status = atcab_sign(slotid, message, signature)) != ATCA_SUCCESS) BREAK(status, "Sign Failed");
ANDI	R25, R25, 255
JAL	_atcab_sign+0
NOP	
; status start address is: 12 (R3)
ANDI	R3, R2, 255
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_sign241
NOP	
J	L_atcatls_sign23
NOP	
L__atcatls_sign241:
ANDI	R2, R3, 255
J	L_atcatls_sign18
NOP	
L_atcatls_sign23:
;atcatls.c,333 :: 		} while (0);
ANDI	R2, R3, 255
L_atcatls_sign18:
; status end address is: 12 (R3)
;atcatls.c,335 :: 		return status;
; status start address is: 8 (R2)
; status end address is: 8 (R2)
;atcatls.c,336 :: 		}
L_end_atcatls_sign:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcatls_sign
_atcatls_verify:
;atcatls.c,345 :: 		ATCA_STATUS atcatls_verify ( uint8_t *message, uint8_t *signature, uint8_t *pubkey, bool *verified)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atcatls.c,347 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,351 :: 		if (message == NULL || signature == NULL || pubkey == NULL || verified == NULL) {
BNE	R25, R0, L__atcatls_verify244
NOP	
J	L__atcatls_verify178
NOP	
L__atcatls_verify244:
BNE	R26, R0, L__atcatls_verify246
NOP	
J	L__atcatls_verify177
NOP	
L__atcatls_verify246:
BNE	R27, R0, L__atcatls_verify248
NOP	
J	L__atcatls_verify176
NOP	
L__atcatls_verify248:
BNE	R28, R0, L__atcatls_verify250
NOP	
J	L__atcatls_verify175
NOP	
L__atcatls_verify250:
J	L_atcatls_verify29
NOP	
L__atcatls_verify178:
L__atcatls_verify177:
L__atcatls_verify176:
L__atcatls_verify175:
;atcatls.c,352 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,353 :: 		BREAK(status, "Bad input parameters");
; status end address is: 8 (R2)
J	L_atcatls_verify25
NOP	
;atcatls.c,354 :: 		}
L_atcatls_verify29:
;atcatls.c,356 :: 		if ((status = atcab_verify_extern(message, signature, pubkey, verified)) != ATCA_SUCCESS) BREAK(status, "Verify Failed");
JAL	_atcab_verify_extern+0
NOP	
; status start address is: 12 (R3)
ANDI	R3, R2, 255
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_verify252
NOP	
J	L_atcatls_verify30
NOP	
L__atcatls_verify252:
ANDI	R2, R3, 255
J	L_atcatls_verify25
NOP	
L_atcatls_verify30:
;atcatls.c,358 :: 		} while (0);
ANDI	R2, R3, 255
L_atcatls_verify25:
; status end address is: 12 (R3)
;atcatls.c,360 :: 		return status;
; status start address is: 8 (R2)
; status end address is: 8 (R2)
;atcatls.c,361 :: 		}
L_end_atcatls_verify:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcatls_verify
_atcatls_verify_cert:
;atcatls.c,373 :: 		ATCA_STATUS atcatls_verify_cert( atcacert_def_t* cert_def,  uint8_t* cert, size_t cert_size,  uint8_t* ca_public_key)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atcatls.c,375 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,379 :: 		if (cert_def == NULL || cert == NULL || ca_public_key == NULL) {
BNE	R25, R0, L__atcatls_verify_cert255
NOP	
J	L__atcatls_verify_cert182
NOP	
L__atcatls_verify_cert255:
BNE	R26, R0, L__atcatls_verify_cert257
NOP	
J	L__atcatls_verify_cert181
NOP	
L__atcatls_verify_cert257:
BNE	R28, R0, L__atcatls_verify_cert259
NOP	
J	L__atcatls_verify_cert180
NOP	
L__atcatls_verify_cert259:
J	L_atcatls_verify_cert36
NOP	
L__atcatls_verify_cert182:
L__atcatls_verify_cert181:
L__atcatls_verify_cert180:
;atcatls.c,380 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,381 :: 		BREAK(status, "Bad input parameters");
; status end address is: 8 (R2)
J	L_atcatls_verify_cert32
NOP	
;atcatls.c,382 :: 		}
L_atcatls_verify_cert36:
;atcatls.c,384 :: 		status = atcacert_verify_cert_hw(cert_def, cert, cert_size, ca_public_key);
JAL	_atcacert_verify_cert_hw+0
NOP	
; status start address is: 12 (R3)
SEH	R3, R2
;atcatls.c,385 :: 		if (status != ATCA_SUCCESS) BREAK(status, "Verify Failed");
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_verify_cert261
NOP	
J	L_atcatls_verify_cert37
NOP	
L__atcatls_verify_cert261:
ANDI	R2, R3, 255
J	L_atcatls_verify_cert32
NOP	
L_atcatls_verify_cert37:
;atcatls.c,387 :: 		} while (0);
ANDI	R2, R3, 255
L_atcatls_verify_cert32:
; status end address is: 12 (R3)
;atcatls.c,389 :: 		return status;
; status start address is: 8 (R2)
; status end address is: 8 (R2)
;atcatls.c,390 :: 		}
L_end_atcatls_verify_cert:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcatls_verify_cert
_atcatls_ecdh:
;atcatls.c,398 :: 		ATCA_STATUS atcatls_ecdh(uint8_t slotid, uint8_t* pubkey, uint8_t* pmk)
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;atcatls.c,400 :: 		return atcatls_ecdh_enc(slotid, TLS_SLOT_ENC_PARENT, pubkey, pmk);
SW	R26, 4(SP)
SW	R27, 8(SP)
SW	R28, 12(SP)
MOVZ	R28, R27, R0
MOVZ	R27, R26, R0
ORI	R26, R0, 4
JAL	_atcatls_ecdh_enc+0
NOP	
;atcatls.c,401 :: 		}
;atcatls.c,400 :: 		return atcatls_ecdh_enc(slotid, TLS_SLOT_ENC_PARENT, pubkey, pmk);
;atcatls.c,401 :: 		}
L_end_atcatls_ecdh:
LW	R28, 12(SP)
LW	R27, 8(SP)
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _atcatls_ecdh
_atcatls_ecdh_enc:
;atcatls.c,411 :: 		ATCA_STATUS atcatls_ecdh_enc(uint8_t slotid, uint8_t enckeyId, uint8_t* pubkey, uint8_t* pmk)
ADDIU	SP, SP, -60
SW	RA, 0(SP)
;atcatls.c,413 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R26, 4(SP)
SW	R27, 8(SP)
SW	R28, 12(SP)
;atcatls.c,414 :: 		uint8_t encKey[ECDH_KEY_SIZE] = { 0 };
ADDIU	R23, SP, 26
ADDIU	R22, R23, 32
LUI	R24, hi_addr(?ICSatcatls_ecdh_enc_encKey_L0+0)
ORI	R24, R24, lo_addr(?ICSatcatls_ecdh_enc_encKey_L0+0)
JAL	___CC2DW+0
NOP	
;atcatls.c,418 :: 		if (pubkey == NULL || pmk == NULL) {
BNE	R27, R0, L__atcatls_ecdh_enc265
NOP	
J	L__atcatls_ecdh_enc185
NOP	
L__atcatls_ecdh_enc265:
BNE	R28, R0, L__atcatls_ecdh_enc267
NOP	
J	L__atcatls_ecdh_enc184
NOP	
L__atcatls_ecdh_enc267:
J	L_atcatls_ecdh_enc43
NOP	
L__atcatls_ecdh_enc185:
L__atcatls_ecdh_enc184:
;atcatls.c,419 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 58(SP)
;atcatls.c,420 :: 		BREAK(status, "Bad input parameters");
J	L_atcatls_ecdh_enc39
NOP	
;atcatls.c,421 :: 		}
L_atcatls_ecdh_enc43:
;atcatls.c,423 :: 		if ((status = atcatls_get_enckey(encKey)) != ATCA_SUCCESS) BREAK(status, "Get enckey Failed");
ADDIU	R2, SP, 26
SW	R28, 16(SP)
SW	R27, 20(SP)
SB	R26, 24(SP)
SB	R25, 25(SP)
MOVZ	R25, R2, R0
JAL	_atcatls_get_enckey+0
NOP	
LBU	R25, 25(SP)
LBU	R26, 24(SP)
LW	R27, 20(SP)
LW	R28, 16(SP)
SB	R2, 58(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_ecdh_enc269
NOP	
J	L_atcatls_ecdh_enc44
NOP	
L__atcatls_ecdh_enc269:
J	L_atcatls_ecdh_enc39
NOP	
L_atcatls_ecdh_enc44:
;atcatls.c,426 :: 		if ((status = atcab_ecdh_enc(slotid, pubkey, pmk, encKey, enckeyId)) != ATCA_SUCCESS) BREAK(status, "ECDH Failed");
ADDIU	R2, SP, 26
ADDIU	SP, SP, -4
SB	R26, 0(SP)
ANDI	R25, R25, 255
MOVZ	R26, R27, R0
MOVZ	R27, R28, R0
MOVZ	R28, R2, R0
JAL	_atcab_ecdh_enc+0
NOP	
ADDIU	SP, SP, 4
SB	R2, 58(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_ecdh_enc271
NOP	
J	L_atcatls_ecdh_enc45
NOP	
L__atcatls_ecdh_enc271:
J	L_atcatls_ecdh_enc39
NOP	
L_atcatls_ecdh_enc45:
;atcatls.c,428 :: 		} while (0);
L_atcatls_ecdh_enc39:
;atcatls.c,430 :: 		return status;
LBU	R2, 58(SP)
;atcatls.c,431 :: 		}
;atcatls.c,430 :: 		return status;
;atcatls.c,431 :: 		}
L_end_atcatls_ecdh_enc:
LW	R28, 12(SP)
LW	R27, 8(SP)
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 60
JR	RA
NOP	
; end of _atcatls_ecdh_enc
_atcatls_ecdhe:
;atcatls.c,440 :: 		ATCA_STATUS atcatls_ecdhe(uint8_t slotid, uint8_t* pubkey, uint8_t* pubkeyret, uint8_t* pmk)
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;atcatls.c,442 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R27, 4(SP)
;atcatls.c,446 :: 		if ((pubkey == NULL) || (pubkeyret == NULL) || (pmk == NULL)) {
BNE	R26, R0, L__atcatls_ecdhe274
NOP	
J	L__atcatls_ecdhe189
NOP	
L__atcatls_ecdhe274:
BNE	R27, R0, L__atcatls_ecdhe276
NOP	
J	L__atcatls_ecdhe188
NOP	
L__atcatls_ecdhe276:
BNE	R28, R0, L__atcatls_ecdhe278
NOP	
J	L__atcatls_ecdhe187
NOP	
L__atcatls_ecdhe278:
J	L_atcatls_ecdhe51
NOP	
L__atcatls_ecdhe189:
L__atcatls_ecdhe188:
L__atcatls_ecdhe187:
;atcatls.c,447 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 17(SP)
;atcatls.c,448 :: 		BREAK(status, "Bad input parameters");
J	L_atcatls_ecdhe47
NOP	
;atcatls.c,449 :: 		}
L_atcatls_ecdhe51:
;atcatls.c,451 :: 		if ((status = atcab_genkey(slotid, pubkeyret)) != ATCA_SUCCESS) BREAK(status, "Create key failed");
SW	R28, 8(SP)
SW	R26, 12(SP)
SB	R25, 16(SP)
MOVZ	R26, R27, R0
ANDI	R25, R25, 255
JAL	_atcab_genkey+0
NOP	
LBU	R25, 16(SP)
LW	R26, 12(SP)
LW	R28, 8(SP)
SB	R2, 17(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_ecdhe280
NOP	
J	L_atcatls_ecdhe52
NOP	
L__atcatls_ecdhe280:
J	L_atcatls_ecdhe47
NOP	
L_atcatls_ecdhe52:
;atcatls.c,454 :: 		if ((status = atcab_ecdh(slotid, pubkey, pmk)) != ATCA_SUCCESS) BREAK(status, "ECDH failed");
MOVZ	R27, R28, R0
ANDI	R25, R25, 255
JAL	_atcab_ecdh+0
NOP	
SB	R2, 17(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_ecdhe282
NOP	
J	L_atcatls_ecdhe53
NOP	
L__atcatls_ecdhe282:
J	L_atcatls_ecdhe47
NOP	
L_atcatls_ecdhe53:
;atcatls.c,457 :: 		} while (0);
L_atcatls_ecdhe47:
;atcatls.c,459 :: 		return status;
LBU	R2, 17(SP)
;atcatls.c,460 :: 		}
;atcatls.c,459 :: 		return status;
;atcatls.c,460 :: 		}
L_end_atcatls_ecdhe:
LW	R27, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _atcatls_ecdhe
_atcatls_create_key:
;atcatls.c,467 :: 		ATCA_STATUS atcatls_create_key(uint8_t slotid, uint8_t* pubkey)
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atcatls.c,469 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,473 :: 		if (pubkey == NULL) {
BEQ	R26, R0, L__atcatls_create_key284
NOP	
J	L_atcatls_create_key57
NOP	
L__atcatls_create_key284:
;atcatls.c,474 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 4(SP)
;atcatls.c,475 :: 		BREAK(status, "NULL inputs");
J	L_atcatls_create_key55
NOP	
;atcatls.c,476 :: 		}
L_atcatls_create_key57:
;atcatls.c,478 :: 		if ((status = atcab_genkey(slotid, pubkey)) != ATCA_SUCCESS) BREAK(status, "Create key failed");
ANDI	R25, R25, 255
JAL	_atcab_genkey+0
NOP	
SB	R2, 4(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_create_key286
NOP	
J	L_atcatls_create_key58
NOP	
L__atcatls_create_key286:
J	L_atcatls_create_key55
NOP	
L_atcatls_create_key58:
;atcatls.c,480 :: 		} while (0);
L_atcatls_create_key55:
;atcatls.c,482 :: 		return status;
LBU	R2, 4(SP)
;atcatls.c,483 :: 		}
L_end_atcatls_create_key:
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atcatls_create_key
_atcatls_calc_pubkey:
;atcatls.c,490 :: 		ATCA_STATUS atcatls_calc_pubkey(uint8_t slotid, uint8_t *pubkey)
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atcatls.c,492 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,496 :: 		if (pubkey == NULL) {
BEQ	R26, R0, L__atcatls_calc_pubkey288
NOP	
J	L_atcatls_calc_pubkey62
NOP	
L__atcatls_calc_pubkey288:
;atcatls.c,497 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 4(SP)
;atcatls.c,498 :: 		BREAK(status, "NULL inputs");
J	L_atcatls_calc_pubkey60
NOP	
;atcatls.c,499 :: 		}
L_atcatls_calc_pubkey62:
;atcatls.c,501 :: 		if ((status = atcab_get_pubkey(slotid, pubkey)) != ATCA_SUCCESS) BREAK(status, "Gen public key failed");
JAL	_atcab_get_pubkey+0
NOP	
SB	R2, 4(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_calc_pubkey290
NOP	
J	L_atcatls_calc_pubkey63
NOP	
L__atcatls_calc_pubkey290:
J	L_atcatls_calc_pubkey60
NOP	
L_atcatls_calc_pubkey63:
;atcatls.c,503 :: 		} while (0);
L_atcatls_calc_pubkey60:
;atcatls.c,505 :: 		return status;
LBU	R2, 4(SP)
;atcatls.c,506 :: 		}
L_end_atcatls_calc_pubkey:
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atcatls_calc_pubkey
_atcatls_read_pubkey:
;atcatls.c,513 :: 		ATCA_STATUS atcatls_read_pubkey(uint8_t slotid, uint8_t *pubkey)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atcatls.c,515 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,519 :: 		if (pubkey == NULL || slotid < 8 || slotid > 0xF) {
BNE	R26, R0, L__atcatls_read_pubkey293
NOP	
J	L__atcatls_read_pubkey193
NOP	
L__atcatls_read_pubkey293:
ANDI	R2, R25, 255
SLTIU	R2, R2, 8
BEQ	R2, R0, L__atcatls_read_pubkey294
NOP	
J	L__atcatls_read_pubkey192
NOP	
L__atcatls_read_pubkey294:
ANDI	R2, R25, 255
SLTIU	R2, R2, 16
BNE	R2, R0, L__atcatls_read_pubkey295
NOP	
J	L__atcatls_read_pubkey191
NOP	
L__atcatls_read_pubkey295:
J	L_atcatls_read_pubkey69
NOP	
L__atcatls_read_pubkey193:
L__atcatls_read_pubkey192:
L__atcatls_read_pubkey191:
;atcatls.c,520 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,521 :: 		BREAK(status, "Bad atcatls_read_pubkey() input parameters");
; status end address is: 8 (R2)
J	L_atcatls_read_pubkey65
NOP	
;atcatls.c,522 :: 		}
L_atcatls_read_pubkey69:
;atcatls.c,524 :: 		if ((status = atcab_read_pubkey(slotid, pubkey)) != ATCA_SUCCESS) BREAK(status, "Read public key failed");
JAL	_atcab_read_pubkey+0
NOP	
; status start address is: 12 (R3)
ANDI	R3, R2, 255
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_read_pubkey297
NOP	
J	L_atcatls_read_pubkey70
NOP	
L__atcatls_read_pubkey297:
ANDI	R2, R3, 255
J	L_atcatls_read_pubkey65
NOP	
L_atcatls_read_pubkey70:
;atcatls.c,526 :: 		} while (0);
ANDI	R2, R3, 255
L_atcatls_read_pubkey65:
; status end address is: 12 (R3)
;atcatls.c,528 :: 		return status;
; status start address is: 8 (R2)
; status end address is: 8 (R2)
;atcatls.c,529 :: 		}
L_end_atcatls_read_pubkey:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcatls_read_pubkey
_atcatls_random:
;atcatls.c,535 :: 		ATCA_STATUS atcatls_random(uint8_t* randout)
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;atcatls.c,537 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,541 :: 		if (randout == NULL) {
BEQ	R25, R0, L__atcatls_random299
NOP	
J	L_atcatls_random74
NOP	
L__atcatls_random299:
;atcatls.c,542 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 4(SP)
;atcatls.c,543 :: 		BREAK(status, "NULL inputs");
J	L_atcatls_random72
NOP	
;atcatls.c,544 :: 		}
L_atcatls_random74:
;atcatls.c,546 :: 		if ((status = atcab_random(randout)) != ATCA_SUCCESS) BREAK(status, "Random command failed");
JAL	_atcab_random+0
NOP	
SB	R2, 4(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_random301
NOP	
J	L_atcatls_random75
NOP	
L__atcatls_random301:
J	L_atcatls_random72
NOP	
L_atcatls_random75:
;atcatls.c,548 :: 		} while (0);
L_atcatls_random72:
;atcatls.c,550 :: 		return status;
LBU	R2, 4(SP)
;atcatls.c,551 :: 		}
L_end_atcatls_random:
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _atcatls_random
_atcatlsfn_set_get_enckey:
;atcatls.c,557 :: 		ATCA_STATUS atcatlsfn_set_get_enckey(atcatlsfn_get_enckey* fn_get_enckey)
;atcatls.c,559 :: 		ATCA_STATUS status = ATCA_SUCCESS;
; status start address is: 8 (R2)
MOVZ	R2, R0, R0
;atcatls.c,563 :: 		if (fn_get_enckey == NULL) {
BEQ	R25, R0, L__atcatlsfn_set_get_enckey303
NOP	
J	L_atcatlsfn_set_get_enckey79
NOP	
L__atcatlsfn_set_get_enckey303:
;atcatls.c,564 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
;atcatls.c,565 :: 		BREAK(status, "NULL inputs");
J	L_atcatlsfn_set_get_enckey77
NOP	
;atcatls.c,566 :: 		}
L_atcatlsfn_set_get_enckey79:
;atcatls.c,568 :: 		_fn_get_enckey = fn_get_enckey;
SW	R25, Offset(__fn_get_enckey+0)(GP)
; status end address is: 8 (R2)
;atcatls.c,570 :: 		} while (0);
L_atcatlsfn_set_get_enckey77:
;atcatls.c,572 :: 		return status;
; status start address is: 8 (R2)
; status end address is: 8 (R2)
;atcatls.c,573 :: 		}
L_end_atcatlsfn_set_get_enckey:
JR	RA
NOP	
; end of _atcatlsfn_set_get_enckey
_atcatls_init_enckey:
;atcatls.c,583 :: 		ATCA_STATUS atcatls_init_enckey(uint8_t* enckeyout, uint8_t enckeyId, bool lock)
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;atcatls.c,585 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,589 :: 		if (enckeyout == NULL) {
BEQ	R25, R0, L__atcatls_init_enckey305
NOP	
J	L_atcatls_init_enckey83
NOP	
L__atcatls_init_enckey305:
;atcatls.c,590 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 12(SP)
;atcatls.c,591 :: 		BREAK(status, "NULL inputs");
J	L_atcatls_init_enckey81
NOP	
;atcatls.c,592 :: 		}
L_atcatls_init_enckey83:
;atcatls.c,594 :: 		if ((status = atcatls_random(enckeyout)) != ATCA_SUCCESS) BREAK(status, "Random command failed");
SB	R27, 4(SP)
SB	R26, 5(SP)
SW	R25, 8(SP)
JAL	_atcatls_random+0
NOP	
LW	R25, 8(SP)
LBU	R26, 5(SP)
LBU	R27, 4(SP)
SB	R2, 12(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_init_enckey307
NOP	
J	L_atcatls_init_enckey84
NOP	
L__atcatls_init_enckey307:
J	L_atcatls_init_enckey81
NOP	
L_atcatls_init_enckey84:
;atcatls.c,597 :: 		atcatls_set_enckey(enckeyout, enckeyId, lock);
JAL	_atcatls_set_enckey+0
NOP	
;atcatls.c,599 :: 		} while (0);
L_atcatls_init_enckey81:
;atcatls.c,601 :: 		return status;
LBU	R2, 12(SP)
;atcatls.c,602 :: 		}
L_end_atcatls_init_enckey:
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _atcatls_init_enckey
_atcatls_set_enckey:
;atcatls.c,612 :: 		ATCA_STATUS atcatls_set_enckey(uint8_t* enckeyin, uint8_t enckeyId, bool lock)
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;atcatls.c,614 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R28, 12(SP)
;atcatls.c,615 :: 		uint8_t block = 0;
; block start address is: 8 (R2)
MOVZ	R2, R0, R0
;atcatls.c,616 :: 		uint8_t offset = 0;
; offset start address is: 16 (R4)
MOVZ	R4, R0, R0
;atcatls.c,617 :: 		uint8_t lockSuccess = 0;
MOVZ	R30, R0, R0
SB	R30, 18(SP)
;atcatls.c,618 :: 		uint8_t enckeyIdByte = (uint8_t)enckeyId;
; enckeyIdByte start address is: 12 (R3)
ANDI	R3, R26, 255
;atcatls.c,622 :: 		if (enckeyin == NULL) {
BEQ	R25, R0, L__atcatls_set_enckey309
NOP	
J	L_atcatls_set_enckey88
NOP	
L__atcatls_set_enckey309:
; block end address is: 8 (R2)
; offset end address is: 16 (R4)
; enckeyIdByte end address is: 12 (R3)
;atcatls.c,623 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 19(SP)
;atcatls.c,624 :: 		BREAK(status, "NULL inputs");
J	L_atcatls_set_enckey86
NOP	
;atcatls.c,625 :: 		}
L_atcatls_set_enckey88:
;atcatls.c,627 :: 		if ((status = atcab_write_zone(ATCA_ZONE_DATA, enckeyIdByte, block, offset, enckeyin, ATCA_BLOCK_SIZE)) != ATCA_SUCCESS)
; enckeyIdByte start address is: 12 (R3)
; offset start address is: 16 (R4)
; block start address is: 8 (R2)
SB	R3, 16(SP)
; offset end address is: 16 (R4)
SB	R27, 17(SP)
ORI	R5, R0, 32
ADDIU	SP, SP, -8
SB	R5, 4(SP)
SW	R25, 0(SP)
ANDI	R28, R4, 255
ANDI	R27, R2, 255
; block end address is: 8 (R2)
ANDI	R26, R3, 255
ORI	R25, R0, 2
JAL	_atcab_write_zone+0
NOP	
ADDIU	SP, SP, 8
LBU	R27, 17(SP)
LBU	R3, 16(SP)
SB	R2, 19(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_set_enckey311
NOP	
J	L_atcatls_set_enckey89
NOP	
L__atcatls_set_enckey311:
; enckeyIdByte end address is: 12 (R3)
;atcatls.c,628 :: 		BREAK(status, "Write parent encryption key failed");
J	L_atcatls_set_enckey86
NOP	
L_atcatls_set_enckey89:
;atcatls.c,631 :: 		if (lock)
; enckeyIdByte start address is: 12 (R3)
BNE	R27, R0, L__atcatls_set_enckey313
NOP	
J	L_atcatls_set_enckey90
NOP	
L__atcatls_set_enckey313:
;atcatls.c,633 :: 		atcab_lock_data_slot(enckeyIdByte, &lockSuccess);
ADDIU	R2, SP, 18
MOVZ	R26, R2, R0
ANDI	R25, R3, 255
; enckeyIdByte end address is: 12 (R3)
JAL	_atcab_lock_data_slot+0
NOP	
L_atcatls_set_enckey90:
;atcatls.c,635 :: 		} while (0);
L_atcatls_set_enckey86:
;atcatls.c,637 :: 		return status;
LBU	R2, 19(SP)
;atcatls.c,638 :: 		}
;atcatls.c,637 :: 		return status;
;atcatls.c,638 :: 		}
L_end_atcatls_set_enckey:
LW	R28, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _atcatls_set_enckey
_atcatls_get_enckey:
;atcatls.c,646 :: 		ATCA_STATUS atcatls_get_enckey(uint8_t* enckeyout)
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;atcatls.c,648 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R26, 4(SP)
SW	R27, 8(SP)
MOVZ	R30, R0, R0
SB	R30, 12(SP)
;atcatls.c,652 :: 		if (enckeyout == NULL) {
BEQ	R25, R0, L__atcatls_get_enckey315
NOP	
J	L_atcatls_get_enckey94
NOP	
L__atcatls_get_enckey315:
;atcatls.c,653 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 12(SP)
;atcatls.c,654 :: 		BREAK(status, "NULL inputs");
J	L_atcatls_get_enckey92
NOP	
;atcatls.c,655 :: 		}
L_atcatls_get_enckey94:
;atcatls.c,657 :: 		memset(enckeyout, 0x00, ATCA_KEY_SIZE);
ORI	R27, R0, 32
MOVZ	R26, R0, R0
JAL	_memset+0
NOP	
;atcatls.c,660 :: 		if (_fn_get_enckey != NULL)
LW	R2, Offset(__fn_get_enckey+0)(GP)
BNE	R2, R0, L__atcatls_get_enckey317
NOP	
J	L_atcatls_get_enckey95
NOP	
L__atcatls_get_enckey317:
;atcatls.c,661 :: 		_fn_get_enckey(enckeyout, ATCA_KEY_SIZE);
ORI	R26, R0, 32
LW	R30, Offset(__fn_get_enckey+0)(GP)
JALR	RA, R30
NOP	
J	L_atcatls_get_enckey96
NOP	
L_atcatls_get_enckey95:
;atcatls.c,664 :: 		status = ATCA_FUNC_FAIL;
ORI	R2, R0, 224
SB	R2, 12(SP)
L_atcatls_get_enckey96:
;atcatls.c,665 :: 		} while (0);
L_atcatls_get_enckey92:
;atcatls.c,667 :: 		return status;
LBU	R2, 12(SP)
;atcatls.c,668 :: 		}
;atcatls.c,667 :: 		return status;
;atcatls.c,668 :: 		}
L_end_atcatls_get_enckey:
LW	R27, 8(SP)
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _atcatls_get_enckey
_atcatls_enc_read:
;atcatls.c,678 :: 		ATCA_STATUS atcatls_enc_read(uint8_t slotid, uint8_t block, uint8_t enckeyId, uint8_t* data, int16_t* bufsize)
ADDIU	SP, SP, -56
SW	RA, 0(SP)
SW	R27, 4(SP)
SW	R28, 8(SP)
; bufsize start address is: 12 (R3)
LW	R3, 56(SP)
;atcatls.c,680 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,681 :: 		uint8_t enckey[ATCA_KEY_SIZE] = { 0 };
ADDIU	R23, SP, 23
ADDIU	R22, R23, 32
LUI	R24, hi_addr(?ICSatcatls_enc_read_enckey_L0+0)
ORI	R24, R24, lo_addr(?ICSatcatls_enc_read_enckey_L0+0)
JAL	___CC2DW+0
NOP	
;atcatls.c,685 :: 		if (data == NULL || bufsize == NULL) {
BNE	R28, R0, L__atcatls_enc_read320
NOP	
J	L__atcatls_enc_read196
NOP	
L__atcatls_enc_read320:
BNE	R3, R0, L__atcatls_enc_read322
NOP	
J	L__atcatls_enc_read195
NOP	
L__atcatls_enc_read322:
J	L_atcatls_enc_read102
NOP	
; bufsize end address is: 12 (R3)
L__atcatls_enc_read196:
L__atcatls_enc_read195:
;atcatls.c,686 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,687 :: 		BREAK(status, "NULL inputs");
; status end address is: 8 (R2)
J	L_atcatls_enc_read98
NOP	
;atcatls.c,688 :: 		}
L_atcatls_enc_read102:
;atcatls.c,690 :: 		if ((status = atcatls_get_enckey(enckey)) != ATCA_SUCCESS) BREAK(status, "Get encryption key failed");
; bufsize start address is: 12 (R3)
ADDIU	R2, SP, 23
SW	R3, 12(SP)
SW	R28, 16(SP)
SB	R27, 20(SP)
SB	R26, 21(SP)
SB	R25, 22(SP)
MOVZ	R25, R2, R0
JAL	_atcatls_get_enckey+0
NOP	
LBU	R25, 22(SP)
LBU	R26, 21(SP)
LBU	R27, 20(SP)
LW	R28, 16(SP)
LW	R3, 12(SP)
; status start address is: 16 (R4)
ANDI	R4, R2, 255
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_enc_read324
NOP	
J	L_atcatls_enc_read103
NOP	
L__atcatls_enc_read324:
; bufsize end address is: 12 (R3)
ANDI	R2, R4, 255
; status end address is: 16 (R4)
J	L_atcatls_enc_read98
NOP	
L_atcatls_enc_read103:
;atcatls.c,693 :: 		memset(data, 0x00, *bufsize);
; bufsize start address is: 12 (R3)
SB	R27, 12(SP)
; bufsize end address is: 12 (R3)
SB	R26, 13(SP)
SB	R25, 14(SP)
LH	R27, 0(R3)
MOVZ	R26, R0, R0
MOVZ	R25, R28, R0
JAL	_memset+0
NOP	
LBU	R25, 14(SP)
LBU	R26, 13(SP)
LBU	R27, 12(SP)
;atcatls.c,696 :: 		if ((status = atcab_read_enc(slotid, block, data, enckey, enckeyId)) != ATCA_SUCCESS) BREAK(status, "Read encrypted failed");
ANDI	R3, R27, 255
ADDIU	R2, SP, 23
MOVZ	R27, R28, R0
MOVZ	R28, R2, R0
ADDIU	SP, SP, -4
SH	R3, 0(SP)
JAL	_atcab_read_enc+0
NOP	
ADDIU	SP, SP, 4
; status start address is: 12 (R3)
ANDI	R3, R2, 255
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_enc_read326
NOP	
J	L_atcatls_enc_read104
NOP	
L__atcatls_enc_read326:
ANDI	R2, R3, 255
J	L_atcatls_enc_read98
NOP	
L_atcatls_enc_read104:
;atcatls.c,698 :: 		} while (0);
ANDI	R2, R3, 255
L_atcatls_enc_read98:
; status end address is: 12 (R3)
;atcatls.c,700 :: 		return status;
; status start address is: 8 (R2)
; status end address is: 8 (R2)
;atcatls.c,701 :: 		}
;atcatls.c,700 :: 		return status;
;atcatls.c,701 :: 		}
L_end_atcatls_enc_read:
LW	R28, 8(SP)
LW	R27, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 56
JR	RA
NOP	
; end of _atcatls_enc_read
_atcatls_enc_write:
;atcatls.c,711 :: 		ATCA_STATUS atcatls_enc_write(uint8_t slotid, uint8_t block, uint8_t enckeyId, uint8_t* data, int16_t bufsize)
ADDIU	SP, SP, -52
SW	RA, 0(SP)
SW	R27, 4(SP)
SW	R28, 8(SP)
; bufsize start address is: 8 (R2)
LH	R2, 52(SP)
; bufsize end address is: 8 (R2)
;atcatls.c,713 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,714 :: 		uint8_t enckey[ATCA_KEY_SIZE] = { 0 };
ADDIU	R23, SP, 19
ADDIU	R22, R23, 32
LUI	R24, hi_addr(?ICSatcatls_enc_write_enckey_L0+0)
ORI	R24, R24, lo_addr(?ICSatcatls_enc_write_enckey_L0+0)
JAL	___CC2DW+0
NOP	
;atcatls.c,718 :: 		if (data == NULL) {
BEQ	R28, R0, L__atcatls_enc_write328
NOP	
J	L_atcatls_enc_write108
NOP	
L__atcatls_enc_write328:
;atcatls.c,719 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 51(SP)
;atcatls.c,720 :: 		BREAK(status, "NULL inputs");
J	L_atcatls_enc_write106
NOP	
;atcatls.c,721 :: 		}
L_atcatls_enc_write108:
;atcatls.c,723 :: 		if ((status = atcatls_get_enckey(enckey)) != ATCA_SUCCESS) BREAK(status, "Get encryption key failed");
ADDIU	R2, SP, 19
SW	R28, 12(SP)
SB	R27, 16(SP)
SB	R26, 17(SP)
SB	R25, 18(SP)
MOVZ	R25, R2, R0
JAL	_atcatls_get_enckey+0
NOP	
LBU	R25, 18(SP)
LBU	R26, 17(SP)
LBU	R27, 16(SP)
LW	R28, 12(SP)
SB	R2, 51(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_enc_write330
NOP	
J	L_atcatls_enc_write109
NOP	
L__atcatls_enc_write330:
J	L_atcatls_enc_write106
NOP	
L_atcatls_enc_write109:
;atcatls.c,726 :: 		if ((status = atcab_write_enc(slotid, block, data, enckey, enckeyId)) != ATCA_SUCCESS) BREAK(status, "Write encrypted failed");
ANDI	R3, R27, 255
ADDIU	R2, SP, 19
MOVZ	R27, R28, R0
MOVZ	R28, R2, R0
ADDIU	SP, SP, -4
SH	R3, 0(SP)
JAL	_atcab_write_enc+0
NOP	
ADDIU	SP, SP, 4
SB	R2, 51(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_enc_write332
NOP	
J	L_atcatls_enc_write110
NOP	
L__atcatls_enc_write332:
J	L_atcatls_enc_write106
NOP	
L_atcatls_enc_write110:
;atcatls.c,728 :: 		} while (0);
L_atcatls_enc_write106:
;atcatls.c,730 :: 		return status;
LBU	R2, 51(SP)
;atcatls.c,731 :: 		}
;atcatls.c,730 :: 		return status;
;atcatls.c,731 :: 		}
L_end_atcatls_enc_write:
LW	R28, 8(SP)
LW	R27, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 52
JR	RA
NOP	
; end of _atcatls_enc_write
_atcatls_enc_rsakey_read:
;atcatls.c,739 :: 		ATCA_STATUS atcatls_enc_rsakey_read(uint8_t enckeyId, uint8_t* rsakey, int16_t* keysize)
ADDIU	SP, SP, -60
SW	RA, 0(SP)
;atcatls.c,741 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R28, 4(SP)
;atcatls.c,742 :: 		uint8_t enckey[ATCA_KEY_SIZE] = { 0 };
ADDIU	R23, SP, 21
ADDIU	R22, R23, 35
LUI	R24, hi_addr(?ICSatcatls_enc_rsakey_read_enckey_L0+0)
ORI	R24, R24, lo_addr(?ICSatcatls_enc_rsakey_read_enckey_L0+0)
JAL	___CC2DW+0
NOP	
;atcatls.c,743 :: 		uint8_t slotid = RSA_KEY_SLOT;
;atcatls.c,744 :: 		uint8_t startBlock = RSA_KEY_START_BLOCK;
;atcatls.c,745 :: 		uint8_t memBlock = 0;
;atcatls.c,746 :: 		uint8_t numKeyBlocks = RSA2048_KEY_SIZE / ATCA_BLOCK_SIZE;
;atcatls.c,747 :: 		uint8_t block = 0;
;atcatls.c,748 :: 		uint8_t memLoc = 0;
;atcatls.c,752 :: 		if (rsakey == NULL || keysize == NULL) {
BNE	R26, R0, L__atcatls_enc_rsakey_read335
NOP	
J	L__atcatls_enc_rsakey_read199
NOP	
L__atcatls_enc_rsakey_read335:
BNE	R27, R0, L__atcatls_enc_rsakey_read337
NOP	
J	L__atcatls_enc_rsakey_read198
NOP	
L__atcatls_enc_rsakey_read337:
J	L_atcatls_enc_rsakey_read116
NOP	
L__atcatls_enc_rsakey_read199:
L__atcatls_enc_rsakey_read198:
;atcatls.c,753 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 56(SP)
;atcatls.c,754 :: 		BREAK(status, "NULL inputs");
J	L_atcatls_enc_rsakey_read112
NOP	
;atcatls.c,755 :: 		}
L_atcatls_enc_rsakey_read116:
;atcatls.c,756 :: 		if (*keysize < RSA2048_KEY_SIZE) {
LH	R2, 0(R27)
SEH	R2, R2
SLTI	R2, R2, 256
BNE	R2, R0, L__atcatls_enc_rsakey_read338
NOP	
J	L_atcatls_enc_rsakey_read117
NOP	
L__atcatls_enc_rsakey_read338:
;atcatls.c,757 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 56(SP)
;atcatls.c,758 :: 		BREAK(status, "RSA key buffer too small");
J	L_atcatls_enc_rsakey_read112
NOP	
;atcatls.c,759 :: 		}
L_atcatls_enc_rsakey_read117:
;atcatls.c,762 :: 		if ((status = atcatls_get_enckey(enckey)) != ATCA_SUCCESS) BREAK(status, "Get encryption key failed");
ADDIU	R2, SP, 21
SW	R27, 8(SP)
SW	R26, 12(SP)
SB	R25, 16(SP)
MOVZ	R25, R2, R0
JAL	_atcatls_get_enckey+0
NOP	
LBU	R25, 16(SP)
LW	R26, 12(SP)
LW	R27, 8(SP)
SB	R2, 56(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_enc_rsakey_read340
NOP	
J	L_atcatls_enc_rsakey_read118
NOP	
L__atcatls_enc_rsakey_read340:
J	L_atcatls_enc_rsakey_read112
NOP	
L_atcatls_enc_rsakey_read118:
;atcatls.c,765 :: 		for (memBlock = 0; memBlock < numKeyBlocks; memBlock++) {
; memBlock start address is: 36 (R9)
MOVZ	R9, R0, R0
; memBlock end address is: 36 (R9)
ANDI	R6, R9, 255
L_atcatls_enc_rsakey_read119:
; memBlock start address is: 24 (R6)
ANDI	R3, R6, 255
LBU	R2, 55(SP)
SLTU	R2, R3, R2
BNE	R2, R0, L__atcatls_enc_rsakey_read341
NOP	
J	L_atcatls_enc_rsakey_read120
NOP	
L__atcatls_enc_rsakey_read341:
;atcatls.c,766 :: 		block = startBlock + memBlock;
LBU	R2, 54(SP)
ADDU	R5, R2, R6
;atcatls.c,767 :: 		memLoc = ATCA_BLOCK_SIZE * memBlock;
ANDI	R2, R6, 255
SLL	R2, R2, 5
;atcatls.c,768 :: 		if ((status = atcab_read_enc(slotid, block, &rsakey[memLoc], enckey, enckeyId)) != ATCA_SUCCESS) BREAK(status, "Read RSA failed");
ANDI	R4, R25, 255
ADDIU	R3, SP, 21
ANDI	R2, R2, 255
ADDU	R2, R26, R2
SB	R6, 8(SP)
SW	R27, 12(SP)
SW	R26, 16(SP)
SB	R25, 20(SP)
MOVZ	R28, R3, R0
MOVZ	R27, R2, R0
ANDI	R26, R5, 255
LBU	R25, 53(SP)
ADDIU	SP, SP, -4
SH	R4, 0(SP)
JAL	_atcab_read_enc+0
NOP	
ADDIU	SP, SP, 4
LBU	R25, 20(SP)
LW	R26, 16(SP)
LW	R27, 12(SP)
LBU	R6, 8(SP)
SB	R2, 56(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_enc_rsakey_read343
NOP	
J	L_atcatls_enc_rsakey_read122
NOP	
L__atcatls_enc_rsakey_read343:
; memBlock end address is: 24 (R6)
J	L_atcatls_enc_rsakey_read120
NOP	
L_atcatls_enc_rsakey_read122:
;atcatls.c,765 :: 		for (memBlock = 0; memBlock < numKeyBlocks; memBlock++) {
; memBlock start address is: 24 (R6)
ADDIU	R2, R6, 1
; memBlock end address is: 24 (R6)
; memBlock start address is: 36 (R9)
ANDI	R9, R2, 255
;atcatls.c,769 :: 		}
ANDI	R6, R9, 255
; memBlock end address is: 36 (R9)
J	L_atcatls_enc_rsakey_read119
NOP	
L_atcatls_enc_rsakey_read120:
;atcatls.c,770 :: 		*keysize = RSA2048_KEY_SIZE;
ORI	R2, R0, 256
SH	R2, 0(R27)
;atcatls.c,772 :: 		} while (0);
L_atcatls_enc_rsakey_read112:
;atcatls.c,774 :: 		return status;
LBU	R2, 56(SP)
;atcatls.c,775 :: 		}
;atcatls.c,774 :: 		return status;
;atcatls.c,775 :: 		}
L_end_atcatls_enc_rsakey_read:
LW	R28, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 60
JR	RA
NOP	
; end of _atcatls_enc_rsakey_read
_atcatls_enc_rsakey_write:
;atcatls.c,783 :: 		ATCA_STATUS atcatls_enc_rsakey_write(uint8_t enckeyId, uint8_t* rsakey, int16_t keysize)
ADDIU	SP, SP, -56
SW	RA, 0(SP)
;atcatls.c,785 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R28, 4(SP)
;atcatls.c,786 :: 		uint8_t enckey[ATCA_KEY_SIZE] = { 0 };
ADDIU	R23, SP, 17
ADDIU	R22, R23, 35
LUI	R24, hi_addr(?ICSatcatls_enc_rsakey_write_enckey_L0+0)
ORI	R24, R24, lo_addr(?ICSatcatls_enc_rsakey_write_enckey_L0+0)
JAL	___CC2DW+0
NOP	
;atcatls.c,787 :: 		uint8_t slotid = RSA_KEY_SLOT;
;atcatls.c,788 :: 		uint8_t startBlock = RSA_KEY_START_BLOCK;
;atcatls.c,789 :: 		uint8_t memBlock = 0;
;atcatls.c,790 :: 		uint8_t numKeyBlocks = RSA2048_KEY_SIZE / ATCA_BLOCK_SIZE;
;atcatls.c,791 :: 		uint8_t block = 0;
;atcatls.c,792 :: 		uint8_t memLoc = 0;
;atcatls.c,796 :: 		if (rsakey == NULL ) {
BEQ	R26, R0, L__atcatls_enc_rsakey_write345
NOP	
J	L_atcatls_enc_rsakey_write126
NOP	
L__atcatls_enc_rsakey_write345:
;atcatls.c,797 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 52(SP)
;atcatls.c,798 :: 		BREAK(status, "NULL inputs");
J	L_atcatls_enc_rsakey_write124
NOP	
;atcatls.c,799 :: 		}
L_atcatls_enc_rsakey_write126:
;atcatls.c,800 :: 		if (keysize < RSA2048_KEY_SIZE) {
SEH	R2, R27
SLTI	R2, R2, 256
BNE	R2, R0, L__atcatls_enc_rsakey_write346
NOP	
J	L_atcatls_enc_rsakey_write127
NOP	
L__atcatls_enc_rsakey_write346:
;atcatls.c,801 :: 		status = ATCA_BAD_PARAM;
ORI	R2, R0, 226
SB	R2, 52(SP)
;atcatls.c,802 :: 		BREAK(status, "RSA key buffer too small");
J	L_atcatls_enc_rsakey_write124
NOP	
;atcatls.c,803 :: 		}
L_atcatls_enc_rsakey_write127:
;atcatls.c,806 :: 		if ((status = atcatls_get_enckey(enckey)) != ATCA_SUCCESS) BREAK(status, "Get encryption key failed");
ADDIU	R2, SP, 17
SW	R26, 8(SP)
SB	R25, 12(SP)
MOVZ	R25, R2, R0
JAL	_atcatls_get_enckey+0
NOP	
LBU	R25, 12(SP)
LW	R26, 8(SP)
SB	R2, 52(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_enc_rsakey_write348
NOP	
J	L_atcatls_enc_rsakey_write128
NOP	
L__atcatls_enc_rsakey_write348:
J	L_atcatls_enc_rsakey_write124
NOP	
L_atcatls_enc_rsakey_write128:
;atcatls.c,809 :: 		for (memBlock = 0; memBlock < numKeyBlocks; memBlock++) {
; memBlock start address is: 36 (R9)
MOVZ	R9, R0, R0
; memBlock end address is: 36 (R9)
ANDI	R6, R9, 255
L_atcatls_enc_rsakey_write129:
; memBlock start address is: 24 (R6)
ANDI	R3, R6, 255
LBU	R2, 51(SP)
SLTU	R2, R3, R2
BNE	R2, R0, L__atcatls_enc_rsakey_write349
NOP	
J	L_atcatls_enc_rsakey_write130
NOP	
L__atcatls_enc_rsakey_write349:
;atcatls.c,810 :: 		block = startBlock + memBlock;
LBU	R2, 50(SP)
ADDU	R5, R2, R6
;atcatls.c,811 :: 		memLoc = ATCA_BLOCK_SIZE * memBlock;
ANDI	R2, R6, 255
SLL	R2, R2, 5
;atcatls.c,812 :: 		if ((status = atcab_write_enc(slotid, block, &rsakey[memLoc], enckey, enckeyId)) != ATCA_SUCCESS) BREAK(status, "Read RSA failed");
ANDI	R4, R25, 255
ADDIU	R3, SP, 17
ANDI	R2, R2, 255
ADDU	R2, R26, R2
SB	R6, 8(SP)
SH	R27, 10(SP)
SW	R26, 12(SP)
SB	R25, 16(SP)
MOVZ	R28, R3, R0
MOVZ	R27, R2, R0
ANDI	R26, R5, 255
LBU	R25, 49(SP)
ADDIU	SP, SP, -4
SH	R4, 0(SP)
JAL	_atcab_write_enc+0
NOP	
ADDIU	SP, SP, 4
LBU	R25, 16(SP)
LW	R26, 12(SP)
LH	R27, 10(SP)
LBU	R6, 8(SP)
SB	R2, 52(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_enc_rsakey_write351
NOP	
J	L_atcatls_enc_rsakey_write132
NOP	
L__atcatls_enc_rsakey_write351:
; memBlock end address is: 24 (R6)
J	L_atcatls_enc_rsakey_write130
NOP	
L_atcatls_enc_rsakey_write132:
;atcatls.c,809 :: 		for (memBlock = 0; memBlock < numKeyBlocks; memBlock++) {
; memBlock start address is: 24 (R6)
ADDIU	R2, R6, 1
; memBlock end address is: 24 (R6)
; memBlock start address is: 36 (R9)
ANDI	R9, R2, 255
;atcatls.c,813 :: 		}
ANDI	R6, R9, 255
; memBlock end address is: 36 (R9)
J	L_atcatls_enc_rsakey_write129
NOP	
L_atcatls_enc_rsakey_write130:
;atcatls.c,815 :: 		} while (0);
L_atcatls_enc_rsakey_write124:
;atcatls.c,817 :: 		return status;
LBU	R2, 52(SP)
;atcatls.c,818 :: 		}
;atcatls.c,817 :: 		return status;
;atcatls.c,818 :: 		}
L_end_atcatls_enc_rsakey_write:
LW	R28, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 56
JR	RA
NOP	
; end of _atcatls_enc_rsakey_write
_atcatls_get_signer_cert:
;atcatls.c,824 :: 		ATCA_STATUS atcatls_get_signer_cert(uint8_t *certout, size_t* certsize)
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;atcatls.c,826 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R27, 4(SP)
; status start address is: 24 (R6)
MOVZ	R6, R0, R0
;atcatls.c,827 :: 		size_t sigCertSize = 0;
;atcatls.c,831 :: 		if (certout == NULL || certsize == NULL) {
BNE	R25, R0, L__atcatls_get_signer_cert354
NOP	
J	L__atcatls_get_signer_cert202
NOP	
L__atcatls_get_signer_cert354:
BNE	R26, R0, L__atcatls_get_signer_cert356
NOP	
J	L__atcatls_get_signer_cert201
NOP	
L__atcatls_get_signer_cert356:
J	L_atcatls_get_signer_cert138
NOP	
; status end address is: 24 (R6)
L__atcatls_get_signer_cert202:
L__atcatls_get_signer_cert201:
;atcatls.c,832 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,833 :: 		BREAK(status, "NULL inputs");
; status end address is: 8 (R2)
J	L_atcatls_get_signer_cert134
NOP	
;atcatls.c,834 :: 		}
L_atcatls_get_signer_cert138:
;atcatls.c,836 :: 		sigCertSize = sizeof(g_SignerCert);
; sigCertSize start address is: 28 (R7)
; status start address is: 24 (R6)
ORI	R7, R0, 454
;atcatls.c,837 :: 		if (*certsize < sigCertSize) {
LW	R2, 0(R26)
SLTIU	R2, R2, 454
BNE	R2, R0, L__atcatls_get_signer_cert357
NOP	
J	L_atcatls_get_signer_cert139
NOP	
L__atcatls_get_signer_cert357:
; status end address is: 24 (R6)
; sigCertSize end address is: 28 (R7)
;atcatls.c,838 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,839 :: 		BREAK(status, "Buffer not big enough for memcpy");
; status end address is: 8 (R2)
J	L_atcatls_get_signer_cert134
NOP	
;atcatls.c,840 :: 		}
L_atcatls_get_signer_cert139:
;atcatls.c,841 :: 		memcpy(certout, g_SignerCert, sigCertSize);
; sigCertSize start address is: 28 (R7)
; status start address is: 24 (R6)
SW	R26, 8(SP)
MOVZ	R27, R7, R0
LUI	R26, hi_addr(_g_SignerCert+0)
ORI	R26, R26, lo_addr(_g_SignerCert+0)
JAL	_memcpy+0
NOP	
LW	R26, 8(SP)
;atcatls.c,842 :: 		*certsize = sigCertSize;
SW	R7, 0(R26)
; status end address is: 24 (R6)
; sigCertSize end address is: 28 (R7)
ANDI	R2, R6, 255
;atcatls.c,844 :: 		} while (0);
L_atcatls_get_signer_cert134:
;atcatls.c,846 :: 		return status;
; status start address is: 8 (R2)
; status end address is: 8 (R2)
;atcatls.c,847 :: 		}
;atcatls.c,846 :: 		return status;
;atcatls.c,847 :: 		}
L_end_atcatls_get_signer_cert:
LW	R27, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _atcatls_get_signer_cert
_atcatls_get_device_cert:
;atcatls.c,853 :: 		ATCA_STATUS atcatls_get_device_cert(uint8_t *certout, size_t* certsize)
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;atcatls.c,855 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R27, 4(SP)
; status start address is: 24 (R6)
MOVZ	R6, R0, R0
;atcatls.c,856 :: 		size_t devCertSize = 0;
;atcatls.c,860 :: 		if (certout == NULL || certsize == NULL) {
BNE	R25, R0, L__atcatls_get_device_cert360
NOP	
J	L__atcatls_get_device_cert205
NOP	
L__atcatls_get_device_cert360:
BNE	R26, R0, L__atcatls_get_device_cert362
NOP	
J	L__atcatls_get_device_cert204
NOP	
L__atcatls_get_device_cert362:
J	L_atcatls_get_device_cert145
NOP	
; status end address is: 24 (R6)
L__atcatls_get_device_cert205:
L__atcatls_get_device_cert204:
;atcatls.c,861 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,862 :: 		BREAK(status, "NULL inputs");
; status end address is: 8 (R2)
J	L_atcatls_get_device_cert141
NOP	
;atcatls.c,863 :: 		}
L_atcatls_get_device_cert145:
;atcatls.c,865 :: 		devCertSize = sizeof(g_DeviceCert);
; devCertSize start address is: 28 (R7)
; status start address is: 24 (R6)
ORI	R7, R0, 428
;atcatls.c,866 :: 		if (*certsize < devCertSize) {
LW	R2, 0(R26)
SLTIU	R2, R2, 428
BNE	R2, R0, L__atcatls_get_device_cert363
NOP	
J	L_atcatls_get_device_cert146
NOP	
L__atcatls_get_device_cert363:
; status end address is: 24 (R6)
; devCertSize end address is: 28 (R7)
;atcatls.c,867 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,868 :: 		BREAK(status, "Buffer not big enough for memcpy");
; status end address is: 8 (R2)
J	L_atcatls_get_device_cert141
NOP	
;atcatls.c,869 :: 		}
L_atcatls_get_device_cert146:
;atcatls.c,870 :: 		memcpy(certout, g_DeviceCert, devCertSize);
; devCertSize start address is: 28 (R7)
; status start address is: 24 (R6)
SW	R26, 8(SP)
MOVZ	R27, R7, R0
LUI	R26, hi_addr(_g_DeviceCert+0)
ORI	R26, R26, lo_addr(_g_DeviceCert+0)
JAL	_memcpy+0
NOP	
LW	R26, 8(SP)
;atcatls.c,871 :: 		*certsize = devCertSize;
SW	R7, 0(R26)
; status end address is: 24 (R6)
; devCertSize end address is: 28 (R7)
ANDI	R2, R6, 255
;atcatls.c,873 :: 		} while (0);
L_atcatls_get_device_cert141:
;atcatls.c,875 :: 		return status;
; status start address is: 8 (R2)
; status end address is: 8 (R2)
;atcatls.c,876 :: 		}
;atcatls.c,875 :: 		return status;
;atcatls.c,876 :: 		}
L_end_atcatls_get_device_cert:
LW	R27, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _atcatls_get_device_cert
_atcatls_get_ca_cert:
;atcatls.c,882 :: 		ATCA_STATUS atcatls_get_ca_cert(uint8_t *certout, size_t* certsize)
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;atcatls.c,884 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R27, 4(SP)
; status start address is: 24 (R6)
MOVZ	R6, R0, R0
;atcatls.c,885 :: 		size_t caCertSize = 0;
;atcatls.c,889 :: 		if (certout == NULL || certsize == NULL) {
BNE	R25, R0, L__atcatls_get_ca_cert366
NOP	
J	L__atcatls_get_ca_cert208
NOP	
L__atcatls_get_ca_cert366:
BNE	R26, R0, L__atcatls_get_ca_cert368
NOP	
J	L__atcatls_get_ca_cert207
NOP	
L__atcatls_get_ca_cert368:
J	L_atcatls_get_ca_cert152
NOP	
; status end address is: 24 (R6)
L__atcatls_get_ca_cert208:
L__atcatls_get_ca_cert207:
;atcatls.c,890 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,891 :: 		BREAK(status, "NULL inputs");
; status end address is: 8 (R2)
J	L_atcatls_get_ca_cert148
NOP	
;atcatls.c,892 :: 		}
L_atcatls_get_ca_cert152:
;atcatls.c,894 :: 		caCertSize = sizeof(g_CaCert);
; caCertSize start address is: 28 (R7)
; status start address is: 24 (R6)
ORI	R7, R0, 451
;atcatls.c,895 :: 		if (*certsize < caCertSize) {
LW	R2, 0(R26)
SLTIU	R2, R2, 451
BNE	R2, R0, L__atcatls_get_ca_cert369
NOP	
J	L_atcatls_get_ca_cert153
NOP	
L__atcatls_get_ca_cert369:
; status end address is: 24 (R6)
; caCertSize end address is: 28 (R7)
;atcatls.c,896 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,897 :: 		BREAK(status, "Buffer not big enough for memcpy");
; status end address is: 8 (R2)
J	L_atcatls_get_ca_cert148
NOP	
;atcatls.c,898 :: 		}
L_atcatls_get_ca_cert153:
;atcatls.c,899 :: 		memcpy(certout, g_CaCert, caCertSize);
; caCertSize start address is: 28 (R7)
; status start address is: 24 (R6)
SW	R26, 8(SP)
MOVZ	R27, R7, R0
LUI	R26, hi_addr(_g_CaCert+0)
ORI	R26, R26, lo_addr(_g_CaCert+0)
JAL	_memcpy+0
NOP	
LW	R26, 8(SP)
;atcatls.c,900 :: 		*certsize = caCertSize;
SW	R7, 0(R26)
; status end address is: 24 (R6)
; caCertSize end address is: 28 (R7)
ANDI	R2, R6, 255
;atcatls.c,902 :: 		} while (0);
L_atcatls_get_ca_cert148:
;atcatls.c,904 :: 		return status;
; status start address is: 8 (R2)
; status end address is: 8 (R2)
;atcatls.c,905 :: 		}
;atcatls.c,904 :: 		return status;
;atcatls.c,905 :: 		}
L_end_atcatls_get_ca_cert:
LW	R27, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _atcatls_get_ca_cert
_atcatls_write_pubkey:
;atcatls.c,913 :: 		ATCA_STATUS atcatls_write_pubkey(uint8_t slotid, uint8_t pubkey[PUB_KEY_SIZE], bool lock)
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;atcatls.c,915 :: 		ATCA_STATUS status = ATCA_SUCCESS;
SW	R26, 4(SP)
;atcatls.c,916 :: 		uint8_t lock_response = 0x00;
MOVZ	R30, R0, R0
SB	R30, 10(SP)
;atcatls.c,920 :: 		if ((status = atcab_write_pubkey(slotid, pubkey)) != ATCA_SUCCESS) BREAK(status, "Write of public key slot failed");
SB	R27, 8(SP)
SB	R25, 9(SP)
JAL	_atcab_write_pubkey+0
NOP	
LBU	R25, 9(SP)
LBU	R27, 8(SP)
SB	R2, 11(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_write_pubkey372
NOP	
J	L_atcatls_write_pubkey157
NOP	
L__atcatls_write_pubkey372:
J	L_atcatls_write_pubkey155
NOP	
L_atcatls_write_pubkey157:
;atcatls.c,924 :: 		if (lock == true)
ANDI	R3, R27, 255
ORI	R2, R0, 1
BEQ	R3, R2, L__atcatls_write_pubkey373
NOP	
J	L_atcatls_write_pubkey158
NOP	
L__atcatls_write_pubkey373:
;atcatls.c,925 :: 		if ((status = atcab_lock_data_slot(slotid, &lock_response)) != ATCA_SUCCESS) BREAK(status, "Lock public key slot failed");
ADDIU	R2, SP, 10
MOVZ	R26, R2, R0
JAL	_atcab_lock_data_slot+0
NOP	
SB	R2, 11(SP)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_write_pubkey375
NOP	
J	L_atcatls_write_pubkey159
NOP	
L__atcatls_write_pubkey375:
J	L_atcatls_write_pubkey155
NOP	
L_atcatls_write_pubkey159:
L_atcatls_write_pubkey158:
;atcatls.c,927 :: 		} while (0);
L_atcatls_write_pubkey155:
;atcatls.c,929 :: 		return status;
LBU	R2, 11(SP)
;atcatls.c,931 :: 		}
;atcatls.c,929 :: 		return status;
;atcatls.c,931 :: 		}
L_end_atcatls_write_pubkey:
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _atcatls_write_pubkey
_atcatls_read_ca_pubkey:
;atcatls.c,938 :: 		ATCA_STATUS atcatls_read_ca_pubkey(uint8_t slotid, uint8_t caPubkey[PUB_KEY_SIZE])
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atcatls.c,940 :: 		ATCA_STATUS status = ATCA_GEN_FAIL;
;atcatls.c,944 :: 		if ((status = atcab_read_pubkey(slotid, caPubkey)) != ATCA_SUCCESS) BREAK(status, "Read of public key slot failed");
JAL	_atcab_read_pubkey+0
NOP	
; status start address is: 12 (R3)
ANDI	R3, R2, 255
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_read_ca_pubkey378
NOP	
J	L_atcatls_read_ca_pubkey163
NOP	
L__atcatls_read_ca_pubkey378:
J	L_atcatls_read_ca_pubkey161
NOP	
L_atcatls_read_ca_pubkey163:
;atcatls.c,947 :: 		} while (0);
L_atcatls_read_ca_pubkey161:
;atcatls.c,949 :: 		return status;
ANDI	R2, R3, 255
; status end address is: 12 (R3)
;atcatls.c,950 :: 		}
L_end_atcatls_read_ca_pubkey:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcatls_read_ca_pubkey
_atcatls_get_cert:
;atcatls.c,965 :: 		ATCA_STATUS atcatls_get_cert( atcacert_def_t* cert_def, uint8_t *ca_public_key, uint8_t *certout, size_t* certsize)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atcatls.c,967 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,971 :: 		if (certout == NULL || certsize == NULL) {
BNE	R27, R0, L__atcatls_get_cert381
NOP	
J	L__atcatls_get_cert211
NOP	
L__atcatls_get_cert381:
BNE	R28, R0, L__atcatls_get_cert383
NOP	
J	L__atcatls_get_cert210
NOP	
L__atcatls_get_cert383:
J	L_atcatls_get_cert169
NOP	
L__atcatls_get_cert211:
L__atcatls_get_cert210:
;atcatls.c,972 :: 		status = ATCA_BAD_PARAM;
; status start address is: 8 (R2)
ORI	R2, R0, 226
;atcatls.c,973 :: 		BREAK(status, "NULL inputs");
; status end address is: 8 (R2)
J	L_atcatls_get_cert165
NOP	
;atcatls.c,974 :: 		}
L_atcatls_get_cert169:
;atcatls.c,977 :: 		status = atcacert_read_cert(cert_def, ca_public_key, certout, certsize);
JAL	_atcacert_read_cert+0
NOP	
; status start address is: 12 (R3)
SEH	R3, R2
;atcatls.c,978 :: 		if (status != ATCACERT_E_SUCCESS)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcatls_get_cert385
NOP	
J	L_atcatls_get_cert170
NOP	
L__atcatls_get_cert385:
;atcatls.c,979 :: 		BREAK(status, "Failed to read certificate");
ANDI	R2, R3, 255
J	L_atcatls_get_cert165
NOP	
L_atcatls_get_cert170:
;atcatls.c,981 :: 		} while (0);
ANDI	R2, R3, 255
L_atcatls_get_cert165:
; status end address is: 12 (R3)
;atcatls.c,983 :: 		return status;
; status start address is: 8 (R2)
; status end address is: 8 (R2)
;atcatls.c,984 :: 		}
L_end_atcatls_get_cert:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcatls_get_cert
