_atcacert_der_enc_length:
;atcacert_der.c,46 :: 		int atcacert_der_enc_length(uint32_t length, uint8_t* der_length, size_t* der_length_size)
;atcacert_der.c,48 :: 		size_t der_length_size_calc = 0;
;atcacert_der.c,49 :: 		int exp = sizeof(length) - 1;
; exp start address is: 16 (R4)
ORI	R4, R0, 3
;atcacert_der.c,51 :: 		if (der_length_size == NULL)
BEQ	R27, R0, L__atcacert_der_enc_length157
NOP	
J	L_atcacert_der_enc_length0
NOP	
L__atcacert_der_enc_length157:
; exp end address is: 16 (R4)
;atcacert_der.c,52 :: 		return ATCACERT_E_BAD_PARAMS;
ORI	R2, R0, 2
J	L_end_atcacert_der_enc_length
NOP	
L_atcacert_der_enc_length0:
;atcacert_der.c,54 :: 		if (length < 0x80) {
; exp start address is: 16 (R4)
SLTIU	R2, R25, 128
BNE	R2, R0, L__atcacert_der_enc_length158
NOP	
J	L_atcacert_der_enc_length1
NOP	
L__atcacert_der_enc_length158:
; exp end address is: 16 (R4)
;atcacert_der.c,56 :: 		der_length_size_calc = 1;
; der_length_size_calc start address is: 12 (R3)
ORI	R3, R0, 1
;atcacert_der.c,57 :: 		exp = 0;
; exp start address is: 20 (R5)
MOVZ	R5, R0, R0
;atcacert_der.c,58 :: 		}else {
; der_length_size_calc end address is: 12 (R3)
; exp end address is: 20 (R5)
J	L_atcacert_der_enc_length2
NOP	
L_atcacert_der_enc_length1:
;atcacert_der.c,62 :: 		while (length / ((uint32_t)1 << (8 * exp)) == 0)
; exp start address is: 16 (R4)
L_atcacert_der_enc_length3:
; exp end address is: 16 (R4)
; exp start address is: 16 (R4)
SEH	R2, R4
SLL	R2, R2, 3
SEH	R3, R2
ORI	R2, R0, 1
SLLV	R2, R2, R3
DIVU	R25, R2
MFLO	R2
BEQ	R2, R0, L__atcacert_der_enc_length159
NOP	
J	L_atcacert_der_enc_length4
NOP	
L__atcacert_der_enc_length159:
;atcacert_der.c,63 :: 		exp--;
ADDIU	R2, R4, -1
SEH	R4, R2
J	L_atcacert_der_enc_length3
NOP	
L_atcacert_der_enc_length4:
;atcacert_der.c,65 :: 		der_length_size_calc = 2 + exp;
ADDIU	R2, R4, 2
; der_length_size_calc start address is: 12 (R3)
SEH	R3, R2
; exp end address is: 16 (R4)
; der_length_size_calc end address is: 12 (R3)
SEH	R5, R4
;atcacert_der.c,66 :: 		}
L_atcacert_der_enc_length2:
;atcacert_der.c,68 :: 		if (der_length != NULL && *der_length_size < der_length_size_calc) {
; der_length_size_calc start address is: 12 (R3)
; exp start address is: 20 (R5)
BNE	R26, R0, L__atcacert_der_enc_length161
NOP	
J	L__atcacert_der_enc_length114
NOP	
L__atcacert_der_enc_length161:
LW	R2, 0(R27)
SLTU	R2, R2, R3
BNE	R2, R0, L__atcacert_der_enc_length162
NOP	
J	L__atcacert_der_enc_length113
NOP	
L__atcacert_der_enc_length162:
; exp end address is: 20 (R5)
L__atcacert_der_enc_length112:
;atcacert_der.c,69 :: 		*der_length_size = der_length_size_calc;
SW	R3, 0(R27)
; der_length_size_calc end address is: 12 (R3)
;atcacert_der.c,70 :: 		return ATCACERT_E_BUFFER_TOO_SMALL;
ORI	R2, R0, 3
J	L_end_atcacert_der_enc_length
NOP	
;atcacert_der.c,68 :: 		if (der_length != NULL && *der_length_size < der_length_size_calc) {
L__atcacert_der_enc_length114:
; exp start address is: 20 (R5)
; der_length_size_calc start address is: 12 (R3)
L__atcacert_der_enc_length113:
;atcacert_der.c,73 :: 		*der_length_size = der_length_size_calc;
SW	R3, 0(R27)
;atcacert_der.c,75 :: 		if (der_length == NULL)
BEQ	R26, R0, L__atcacert_der_enc_length163
NOP	
J	L_atcacert_der_enc_length8
NOP	
L__atcacert_der_enc_length163:
; der_length_size_calc end address is: 12 (R3)
; exp end address is: 20 (R5)
;atcacert_der.c,76 :: 		return ATCACERT_E_SUCCESS; // Caller is only requesting the size
MOVZ	R2, R0, R0
J	L_end_atcacert_der_enc_length
NOP	
L_atcacert_der_enc_length8:
;atcacert_der.c,79 :: 		for (; exp >= 0; exp--)
; exp start address is: 20 (R5)
; der_length_size_calc start address is: 12 (R3)
MOVZ	R4, R3, R0
; exp end address is: 20 (R5)
L_atcacert_der_enc_length9:
; der_length_size_calc end address is: 12 (R3)
; exp start address is: 20 (R5)
; der_length_size_calc start address is: 16 (R4)
SEH	R2, R5
SLTI	R2, R2, 0
BEQ	R2, R0, L__atcacert_der_enc_length164
NOP	
J	L_atcacert_der_enc_length10
NOP	
L__atcacert_der_enc_length164:
;atcacert_der.c,80 :: 		der_length[der_length_size_calc - 1 - exp] = (uint8_t)((length >> (exp * 8)) & 0xFF);
ADDIU	R3, R4, -1
SEH	R2, R5
SUBU	R2, R3, R2
ADDU	R3, R26, R2
SEH	R2, R5
SLL	R2, R2, 3
SEH	R2, R2
SRLV	R2, R25, R2
ANDI	R2, R2, 255
SB	R2, 0(R3)
;atcacert_der.c,79 :: 		for (; exp >= 0; exp--)
ADDIU	R2, R5, -1
SEH	R5, R2
;atcacert_der.c,80 :: 		der_length[der_length_size_calc - 1 - exp] = (uint8_t)((length >> (exp * 8)) & 0xFF);
; exp end address is: 20 (R5)
J	L_atcacert_der_enc_length9
NOP	
L_atcacert_der_enc_length10:
;atcacert_der.c,82 :: 		if (der_length_size_calc > 1)
SLTIU	R2, R4, 2
BEQ	R2, R0, L__atcacert_der_enc_length165
NOP	
J	L_atcacert_der_enc_length12
NOP	
L__atcacert_der_enc_length165:
;atcacert_der.c,83 :: 		der_length[0] = 0x80 | (uint8_t)(der_length_size_calc - 1); // Set number of bytes octet with long-form flag
ADDIU	R2, R4, -1
; der_length_size_calc end address is: 16 (R4)
ORI	R2, R2, 128
SB	R2, 0(R26)
L_atcacert_der_enc_length12:
;atcacert_der.c,85 :: 		return ATCACERT_E_SUCCESS;
MOVZ	R2, R0, R0
;atcacert_der.c,86 :: 		}
L_end_atcacert_der_enc_length:
JR	RA
NOP	
; end of _atcacert_der_enc_length
_atcacert_der_dec_length:
;atcacert_der.c,88 :: 		int atcacert_der_dec_length( uint8_t* der_length, size_t* der_length_size, uint32_t* length)
;atcacert_der.c,90 :: 		if (der_length == NULL || der_length_size == NULL)
BNE	R25, R0, L__atcacert_der_dec_length168
NOP	
J	L__atcacert_der_dec_length117
NOP	
L__atcacert_der_dec_length168:
BNE	R26, R0, L__atcacert_der_dec_length170
NOP	
J	L__atcacert_der_dec_length116
NOP	
L__atcacert_der_dec_length170:
J	L_atcacert_der_dec_length15
NOP	
L__atcacert_der_dec_length117:
L__atcacert_der_dec_length116:
;atcacert_der.c,91 :: 		return ATCACERT_E_BAD_PARAMS;
ORI	R2, R0, 2
J	L_end_atcacert_der_dec_length
NOP	
L_atcacert_der_dec_length15:
;atcacert_der.c,93 :: 		if (*der_length_size < 1)
LW	R2, 0(R26)
SLTIU	R2, R2, 1
BNE	R2, R0, L__atcacert_der_dec_length171
NOP	
J	L_atcacert_der_dec_length16
NOP	
L__atcacert_der_dec_length171:
;atcacert_der.c,94 :: 		return ATCACERT_E_DECODING_ERROR;
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_length
NOP	
L_atcacert_der_dec_length16:
;atcacert_der.c,96 :: 		if (der_length[0] & 0x80) {
LBU	R2, 0(R25)
ANDI	R2, R2, 128
BNE	R2, R0, L__atcacert_der_dec_length173
NOP	
J	L_atcacert_der_dec_length17
NOP	
L__atcacert_der_dec_length173:
;atcacert_der.c,98 :: 		size_t num_bytes = der_length[0] & 0x7F;
LBU	R2, 0(R25)
ANDI	R2, R2, 127
; num_bytes start address is: 24 (R6)
ANDI	R6, R2, 255
;atcacert_der.c,100 :: 		if (*der_length_size < num_bytes + 1)
LW	R3, 0(R26)
ADDIU	R2, R6, 1
SLTU	R2, R3, R2
BNE	R2, R0, L__atcacert_der_dec_length174
NOP	
J	L_atcacert_der_dec_length18
NOP	
L__atcacert_der_dec_length174:
; num_bytes end address is: 24 (R6)
;atcacert_der.c,101 :: 		return ATCACERT_E_DECODING_ERROR;   //  Invalid DER length format, not enough data.
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_length
NOP	
L_atcacert_der_dec_length18:
;atcacert_der.c,102 :: 		if (num_bytes == 0)
; num_bytes start address is: 24 (R6)
BEQ	R6, R0, L__atcacert_der_dec_length175
NOP	
J	L_atcacert_der_dec_length19
NOP	
L__atcacert_der_dec_length175:
; num_bytes end address is: 24 (R6)
;atcacert_der.c,103 :: 		return ATCACERT_E_DECODING_ERROR;   //  Invalid DER length format, indefinite length not supported.
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_length
NOP	
L_atcacert_der_dec_length19:
;atcacert_der.c,104 :: 		if (num_bytes > sizeof(*length))
; num_bytes start address is: 24 (R6)
SLTIU	R2, R6, 5
BEQ	R2, R0, L__atcacert_der_dec_length176
NOP	
J	L_atcacert_der_dec_length20
NOP	
L__atcacert_der_dec_length176:
; num_bytes end address is: 24 (R6)
;atcacert_der.c,105 :: 		return ATCACERT_E_DECODING_ERROR;   //  Can't parse DER length format, larger than length.
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_length
NOP	
L_atcacert_der_dec_length20:
;atcacert_der.c,107 :: 		if (length != NULL) {
; num_bytes start address is: 24 (R6)
BNE	R27, R0, L__atcacert_der_dec_length178
NOP	
J	L__atcacert_der_dec_length118
NOP	
L__atcacert_der_dec_length178:
;atcacert_der.c,109 :: 		*length = 0;
SW	R0, 0(R27)
;atcacert_der.c,110 :: 		for (i = 1; i <= num_bytes; i++)
; i start address is: 20 (R5)
ORI	R5, R0, 1
; num_bytes end address is: 24 (R6)
; i end address is: 20 (R5)
L_atcacert_der_dec_length22:
; i start address is: 20 (R5)
; num_bytes start address is: 24 (R6)
SLTU	R2, R6, R5
BEQ	R2, R0, L__atcacert_der_dec_length179
NOP	
J	L_atcacert_der_dec_length23
NOP	
L__atcacert_der_dec_length179:
;atcacert_der.c,111 :: 		*length += der_length[i] * ((uint32_t)1 << (8 * (num_bytes - i)));
ADDU	R2, R25, R5
LBU	R4, 0(R2)
SUBU	R2, R6, R5
SLL	R3, R2, 3
ORI	R2, R0, 1
SLLV	R3, R2, R3
ANDI	R2, R4, 255
MULTU	R2, R3
MFLO	R3
LW	R2, 0(R27)
ADDU	R2, R2, R3
SW	R2, 0(R27)
;atcacert_der.c,110 :: 		for (i = 1; i <= num_bytes; i++)
ADDIU	R2, R5, 1
MOVZ	R5, R2, R0
;atcacert_der.c,111 :: 		*length += der_length[i] * ((uint32_t)1 << (8 * (num_bytes - i)));
; i end address is: 20 (R5)
J	L_atcacert_der_dec_length22
NOP	
L_atcacert_der_dec_length23:
;atcacert_der.c,112 :: 		}
MOVZ	R3, R6, R0
J	L_atcacert_der_dec_length21
NOP	
; num_bytes end address is: 24 (R6)
L__atcacert_der_dec_length118:
;atcacert_der.c,107 :: 		if (length != NULL) {
MOVZ	R3, R6, R0
;atcacert_der.c,112 :: 		}
L_atcacert_der_dec_length21:
;atcacert_der.c,113 :: 		*der_length_size = num_bytes + 1; // Return the actual number of bytes the DER length encoding used.
; num_bytes start address is: 12 (R3)
ADDIU	R2, R3, 1
; num_bytes end address is: 12 (R3)
SW	R2, 0(R26)
;atcacert_der.c,114 :: 		}else {
J	L_atcacert_der_dec_length25
NOP	
L_atcacert_der_dec_length17:
;atcacert_der.c,115 :: 		if (length != NULL)
BNE	R27, R0, L__atcacert_der_dec_length181
NOP	
J	L_atcacert_der_dec_length26
NOP	
L__atcacert_der_dec_length181:
;atcacert_der.c,116 :: 		*length = der_length[0];
LBU	R2, 0(R25)
ANDI	R2, R2, 255
SW	R2, 0(R27)
L_atcacert_der_dec_length26:
;atcacert_der.c,117 :: 		*der_length_size = 1; // Return the actual number of bytes the DER length encoding used.
ORI	R2, R0, 1
SW	R2, 0(R26)
;atcacert_der.c,118 :: 		}
L_atcacert_der_dec_length25:
;atcacert_der.c,120 :: 		return ATCACERT_E_SUCCESS;
MOVZ	R2, R0, R0
;atcacert_der.c,121 :: 		}
L_end_atcacert_der_dec_length:
JR	RA
NOP	
; end of _atcacert_der_dec_length
_atcacert_der_enc_integer:
;atcacert_der.c,127 :: 		size_t*        der_int_size)
ADDIU	SP, SP, -28
SW	RA, 0(SP)
; der_int_size start address is: 32 (R8)
LW	R8, 28(SP)
;atcacert_der.c,130 :: 		size_t der_length_size = sizeof(der_length);
ORI	R30, R0, 5
SW	R30, 24(SP)
;atcacert_der.c,131 :: 		size_t der_int_size_calc = 0;
;atcacert_der.c,132 :: 		size_t trim = 0;
; trim start address is: 28 (R7)
MOVZ	R7, R0, R0
;atcacert_der.c,133 :: 		size_t pad = 0;
; pad start address is: 16 (R4)
MOVZ	R4, R0, R0
;atcacert_der.c,136 :: 		if (int_data == NULL || der_int_size == NULL || int_data_size <= 0)
BNE	R25, R0, L__atcacert_der_enc_integer184
NOP	
J	L__atcacert_der_enc_integer127
NOP	
L__atcacert_der_enc_integer184:
BNE	R8, R0, L__atcacert_der_enc_integer186
NOP	
J	L__atcacert_der_enc_integer126
NOP	
L__atcacert_der_enc_integer186:
SLTIU	R2, R26, 1
BEQ	R2, R0, L__atcacert_der_enc_integer187
NOP	
J	L__atcacert_der_enc_integer125
NOP	
L__atcacert_der_enc_integer187:
J	L_atcacert_der_enc_integer29
NOP	
; pad end address is: 16 (R4)
; trim end address is: 28 (R7)
; der_int_size end address is: 32 (R8)
L__atcacert_der_enc_integer127:
L__atcacert_der_enc_integer126:
L__atcacert_der_enc_integer125:
;atcacert_der.c,137 :: 		return ATCACERT_E_BAD_PARAMS;
ORI	R2, R0, 2
J	L_end_atcacert_der_enc_integer
NOP	
L_atcacert_der_enc_integer29:
;atcacert_der.c,139 :: 		if (!(is_unsigned && (int_data[0] & 0x80))) {
; der_int_size start address is: 32 (R8)
; trim start address is: 28 (R7)
; pad start address is: 16 (R4)
BNE	R27, R0, L__atcacert_der_enc_integer189
NOP	
J	L_atcacert_der_enc_integer31
NOP	
L__atcacert_der_enc_integer189:
LBU	R2, 0(R25)
ANDI	R2, R2, 128
BNE	R2, R0, L__atcacert_der_enc_integer191
NOP	
J	L_atcacert_der_enc_integer31
NOP	
L__atcacert_der_enc_integer191:
ORI	R2, R0, 1
J	L_atcacert_der_enc_integer30
NOP	
L_atcacert_der_enc_integer31:
MOVZ	R2, R0, R0
L_atcacert_der_enc_integer30:
BEQ	R2, R0, L__atcacert_der_enc_integer192
NOP	
J	L_atcacert_der_enc_integer32
NOP	
L__atcacert_der_enc_integer192:
; pad end address is: 16 (R4)
; trim end address is: 28 (R7)
; der_int_size end address is: 32 (R8)
;atcacert_der.c,142 :: 		while (
L_atcacert_der_enc_integer33:
;atcacert_der.c,143 :: 		(int_data_size - trim >= 2) && (
; pad start address is: 16 (R4)
; trim start address is: 28 (R7)
; der_int_size start address is: 32 (R8)
SUBU	R2, R26, R7
;atcacert_der.c,145 :: 		((int_data[trim] == 0xFF) && ((int_data[trim + 1] & 0x80) != 0))))
SLTIU	R2, R2, 2
BEQ	R2, R0, L__atcacert_der_enc_integer193
NOP	
J	L__atcacert_der_enc_integer132
NOP	
L__atcacert_der_enc_integer193:
;atcacert_der.c,144 :: 		((int_data[trim] == 0x00) && ((int_data[trim + 1] & 0x80) == 0)) ||
ADDU	R2, R25, R7
LBU	R2, 0(R2)
ANDI	R2, R2, 255
BEQ	R2, R0, L__atcacert_der_enc_integer194
NOP	
J	L__atcacert_der_enc_integer129
NOP	
L__atcacert_der_enc_integer194:
ADDIU	R2, R7, 1
ADDU	R2, R25, R2
LBU	R2, 0(R2)
ANDI	R2, R2, 128
ANDI	R2, R2, 255
BEQ	R2, R0, L__atcacert_der_enc_integer195
NOP	
J	L__atcacert_der_enc_integer128
NOP	
L__atcacert_der_enc_integer195:
J	L__atcacert_der_enc_integer121
NOP	
L__atcacert_der_enc_integer129:
L__atcacert_der_enc_integer128:
;atcacert_der.c,145 :: 		((int_data[trim] == 0xFF) && ((int_data[trim + 1] & 0x80) != 0))))
ADDU	R2, R25, R7
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 255
BEQ	R3, R2, L__atcacert_der_enc_integer196
NOP	
J	L__atcacert_der_enc_integer131
NOP	
L__atcacert_der_enc_integer196:
ADDIU	R2, R7, 1
ADDU	R2, R25, R2
LBU	R2, 0(R2)
ANDI	R2, R2, 128
ANDI	R2, R2, 255
BNE	R2, R0, L__atcacert_der_enc_integer198
NOP	
J	L__atcacert_der_enc_integer130
NOP	
L__atcacert_der_enc_integer198:
J	L__atcacert_der_enc_integer121
NOP	
L__atcacert_der_enc_integer131:
L__atcacert_der_enc_integer130:
J	L_atcacert_der_enc_integer34
NOP	
L__atcacert_der_enc_integer121:
L__atcacert_der_enc_integer120:
;atcacert_der.c,146 :: 		trim++;
ADDIU	R2, R7, 1
MOVZ	R7, R2, R0
J	L_atcacert_der_enc_integer33
NOP	
L_atcacert_der_enc_integer34:
;atcacert_der.c,145 :: 		((int_data[trim] == 0xFF) && ((int_data[trim + 1] & 0x80) != 0))))
L__atcacert_der_enc_integer132:
;atcacert_der.c,147 :: 		}else
; pad end address is: 16 (R4)
MOVZ	R6, R4, R0
J	L_atcacert_der_enc_integer43
NOP	
L_atcacert_der_enc_integer32:
;atcacert_der.c,149 :: 		pad = 1;
; pad start address is: 24 (R6)
ORI	R6, R0, 1
; pad end address is: 24 (R6)
; trim end address is: 28 (R7)
; der_int_size end address is: 32 (R8)
L_atcacert_der_enc_integer43:
;atcacert_der.c,151 :: 		ret = atcacert_der_enc_length(int_data_size + pad - trim, der_length, &der_length_size);
; pad start address is: 24 (R6)
; trim start address is: 28 (R7)
; der_int_size start address is: 32 (R8)
ADDIU	R4, SP, 24
ADDIU	R3, SP, 16
ADDU	R2, R26, R6
SUBU	R2, R2, R7
SB	R27, 4(SP)
SW	R26, 8(SP)
SW	R25, 12(SP)
MOVZ	R27, R4, R0
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_atcacert_der_enc_length+0
NOP	
LW	R25, 12(SP)
LW	R26, 8(SP)
LBU	R27, 4(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_der.c,152 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_der_enc_integer200
NOP	
J	L_atcacert_der_enc_integer44
NOP	
L__atcacert_der_enc_integer200:
; pad end address is: 24 (R6)
; trim end address is: 28 (R7)
; der_int_size end address is: 32 (R8)
;atcacert_der.c,153 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_der_enc_integer
NOP	
L_atcacert_der_enc_integer44:
;atcacert_der.c,155 :: 		der_int_size_calc = 1 + der_length_size + int_data_size + pad - trim;
; der_int_size start address is: 32 (R8)
; trim start address is: 28 (R7)
; pad start address is: 24 (R6)
LW	R2, 24(SP)
ADDIU	R2, R2, 1
ADDU	R2, R2, R26
ADDU	R2, R2, R6
SUBU	R2, R2, R7
; der_int_size_calc start address is: 12 (R3)
MOVZ	R3, R2, R0
;atcacert_der.c,157 :: 		if (der_int != NULL && der_int_size_calc > *der_int_size) {
BNE	R28, R0, L__atcacert_der_enc_integer202
NOP	
J	L__atcacert_der_enc_integer134
NOP	
L__atcacert_der_enc_integer202:
LW	R2, 0(R8)
SLTU	R2, R2, R3
BNE	R2, R0, L__atcacert_der_enc_integer203
NOP	
J	L__atcacert_der_enc_integer133
NOP	
L__atcacert_der_enc_integer203:
; pad end address is: 24 (R6)
; trim end address is: 28 (R7)
L__atcacert_der_enc_integer119:
;atcacert_der.c,158 :: 		*der_int_size = der_int_size_calc;
SW	R3, 0(R8)
; der_int_size end address is: 32 (R8)
; der_int_size_calc end address is: 12 (R3)
;atcacert_der.c,159 :: 		return ATCACERT_E_BUFFER_TOO_SMALL;
ORI	R2, R0, 3
J	L_end_atcacert_der_enc_integer
NOP	
;atcacert_der.c,157 :: 		if (der_int != NULL && der_int_size_calc > *der_int_size) {
L__atcacert_der_enc_integer134:
; der_int_size_calc start address is: 12 (R3)
; der_int_size start address is: 32 (R8)
; trim start address is: 28 (R7)
; pad start address is: 24 (R6)
L__atcacert_der_enc_integer133:
;atcacert_der.c,162 :: 		*der_int_size = der_int_size_calc;
SW	R3, 0(R8)
; der_int_size end address is: 32 (R8)
; der_int_size_calc end address is: 12 (R3)
;atcacert_der.c,164 :: 		if (der_int == NULL)
BEQ	R28, R0, L__atcacert_der_enc_integer204
NOP	
J	L_atcacert_der_enc_integer48
NOP	
L__atcacert_der_enc_integer204:
; pad end address is: 24 (R6)
; trim end address is: 28 (R7)
;atcacert_der.c,165 :: 		return ATCACERT_E_SUCCESS;                                                      // Caller just wanted the size of the encoded integer
MOVZ	R2, R0, R0
J	L_end_atcacert_der_enc_integer
NOP	
L_atcacert_der_enc_integer48:
;atcacert_der.c,167 :: 		der_int[0] = 0x02;                                                                  // Integer tag
; trim start address is: 28 (R7)
; pad start address is: 24 (R6)
ORI	R2, R0, 2
SB	R2, 0(R28)
;atcacert_der.c,168 :: 		memcpy(&der_int[1], der_length, der_length_size);                                   // Integer length
ADDIU	R3, SP, 16
ADDIU	R2, R28, 1
SB	R27, 4(SP)
SW	R26, 8(SP)
SW	R25, 12(SP)
LW	R27, 24(SP)
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_memcpy+0
NOP	
LW	R25, 12(SP)
LW	R26, 8(SP)
LBU	R27, 4(SP)
;atcacert_der.c,169 :: 		if (pad)
BNE	R6, R0, L__atcacert_der_enc_integer206
NOP	
J	L_atcacert_der_enc_integer49
NOP	
L__atcacert_der_enc_integer206:
;atcacert_der.c,170 :: 		der_int[der_length_size + 1] = 0;                                               // Unsigned integer value requires padding byte so it's not interpreted as negative
LW	R2, 24(SP)
ADDIU	R2, R2, 1
ADDU	R2, R28, R2
SB	R0, 0(R2)
L_atcacert_der_enc_integer49:
;atcacert_der.c,171 :: 		memcpy(&der_int[der_length_size + 1 + pad], &int_data[trim], int_data_size - trim); // Integer value
SUBU	R4, R26, R7
ADDU	R3, R25, R7
; trim end address is: 28 (R7)
LW	R2, 24(SP)
ADDIU	R2, R2, 1
ADDU	R2, R2, R6
; pad end address is: 24 (R6)
ADDU	R2, R28, R2
SB	R27, 4(SP)
SW	R26, 8(SP)
SW	R25, 12(SP)
SEH	R27, R4
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_memcpy+0
NOP	
LW	R25, 12(SP)
LW	R26, 8(SP)
LBU	R27, 4(SP)
;atcacert_der.c,173 :: 		return ATCACERT_E_SUCCESS;
MOVZ	R2, R0, R0
;atcacert_der.c,174 :: 		}
L_end_atcacert_der_enc_integer:
LW	RA, 0(SP)
ADDIU	SP, SP, 28
JR	RA
NOP	
; end of _atcacert_der_enc_integer
_atcacert_der_dec_integer:
;atcacert_der.c,179 :: 		size_t*        int_data_size)
ADDIU	SP, SP, -36
SW	RA, 0(SP)
;atcacert_der.c,181 :: 		int ret = 0;
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
;atcacert_der.c,182 :: 		size_t der_length_size = 0;
ADDIU	R23, SP, 28
ADDIU	R22, R23, 8
LUI	R24, hi_addr(?ICSatcacert_der_dec_integer_der_length_size_L0+0)
ORI	R24, R24, lo_addr(?ICSatcacert_der_dec_integer_der_length_size_L0+0)
JAL	___CC2DW+0
NOP	
;atcacert_der.c,183 :: 		uint32_t int_data_size_calc = 0;
;atcacert_der.c,185 :: 		if (der_int == NULL || der_int_size == NULL || (int_data != NULL && int_data_size == NULL))
BNE	R25, R0, L__atcacert_der_dec_integer209
NOP	
J	L__atcacert_der_dec_integer142
NOP	
L__atcacert_der_dec_integer209:
BNE	R26, R0, L__atcacert_der_dec_integer211
NOP	
J	L__atcacert_der_dec_integer141
NOP	
L__atcacert_der_dec_integer211:
BNE	R27, R0, L__atcacert_der_dec_integer213
NOP	
J	L__atcacert_der_dec_integer140
NOP	
L__atcacert_der_dec_integer213:
BEQ	R28, R0, L__atcacert_der_dec_integer214
NOP	
J	L__atcacert_der_dec_integer139
NOP	
L__atcacert_der_dec_integer214:
J	L__atcacert_der_dec_integer137
NOP	
L__atcacert_der_dec_integer140:
L__atcacert_der_dec_integer139:
J	L_atcacert_der_dec_integer54
NOP	
L__atcacert_der_dec_integer137:
L__atcacert_der_dec_integer142:
L__atcacert_der_dec_integer141:
;atcacert_der.c,186 :: 		return ATCACERT_E_BAD_PARAMS;
ORI	R2, R0, 2
J	L_end_atcacert_der_dec_integer
NOP	
L_atcacert_der_dec_integer54:
;atcacert_der.c,188 :: 		if (*der_int_size < 1)
LW	R2, 0(R26)
SLTIU	R2, R2, 1
BNE	R2, R0, L__atcacert_der_dec_integer215
NOP	
J	L_atcacert_der_dec_integer55
NOP	
L__atcacert_der_dec_integer215:
;atcacert_der.c,189 :: 		return ATCACERT_E_DECODING_ERROR; // No data to decode
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_integer
NOP	
L_atcacert_der_dec_integer55:
;atcacert_der.c,191 :: 		if (der_int[0] != 0x02)
LBU	R2, 0(R25)
ANDI	R3, R2, 255
ORI	R2, R0, 2
BNE	R3, R2, L__atcacert_der_dec_integer217
NOP	
J	L_atcacert_der_dec_integer56
NOP	
L__atcacert_der_dec_integer217:
;atcacert_der.c,192 :: 		return ATCACERT_E_DECODING_ERROR; // Not an integer tag
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_integer
NOP	
L_atcacert_der_dec_integer56:
;atcacert_der.c,194 :: 		der_length_size = *der_int_size - 1;
LW	R2, 0(R26)
ADDIU	R2, R2, -1
SW	R2, 28(SP)
;atcacert_der.c,195 :: 		ret = atcacert_der_dec_length(&der_int[1], &der_length_size, &int_data_size_calc);
ADDIU	R4, SP, 32
ADDIU	R3, SP, 28
ADDIU	R2, R25, 1
SW	R27, 16(SP)
SW	R26, 20(SP)
SW	R25, 24(SP)
MOVZ	R27, R4, R0
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_atcacert_der_dec_length+0
NOP	
LW	R25, 24(SP)
LW	R26, 20(SP)
LW	R27, 16(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_der.c,196 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_der_dec_integer219
NOP	
J	L_atcacert_der_dec_integer57
NOP	
L__atcacert_der_dec_integer219:
;atcacert_der.c,197 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_der_dec_integer
NOP	
L_atcacert_der_dec_integer57:
;atcacert_der.c,199 :: 		if (*der_int_size < (1 + der_length_size + int_data_size_calc))
LW	R4, 0(R26)
LW	R2, 28(SP)
ADDIU	R3, R2, 1
LW	R2, 32(SP)
ADDU	R2, R3, R2
SLTU	R2, R4, R2
BNE	R2, R0, L__atcacert_der_dec_integer220
NOP	
J	L_atcacert_der_dec_integer58
NOP	
L__atcacert_der_dec_integer220:
;atcacert_der.c,200 :: 		return ATCACERT_E_DECODING_ERROR; // Invalid DER integer, not enough data.
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_integer
NOP	
L_atcacert_der_dec_integer58:
;atcacert_der.c,202 :: 		*der_int_size = (1 + der_length_size + int_data_size_calc);
LW	R2, 28(SP)
ADDIU	R3, R2, 1
LW	R2, 32(SP)
ADDU	R2, R3, R2
SW	R2, 0(R26)
;atcacert_der.c,204 :: 		if (int_data == NULL && int_data_size == NULL)
BEQ	R27, R0, L__atcacert_der_dec_integer221
NOP	
J	L__atcacert_der_dec_integer144
NOP	
L__atcacert_der_dec_integer221:
BEQ	R28, R0, L__atcacert_der_dec_integer222
NOP	
J	L__atcacert_der_dec_integer143
NOP	
L__atcacert_der_dec_integer222:
L__atcacert_der_dec_integer136:
;atcacert_der.c,205 :: 		return ATCACERT_E_SUCCESS; // Caller doesn't want the actual data, just the der_int_size
MOVZ	R2, R0, R0
J	L_end_atcacert_der_dec_integer
NOP	
;atcacert_der.c,204 :: 		if (int_data == NULL && int_data_size == NULL)
L__atcacert_der_dec_integer144:
L__atcacert_der_dec_integer143:
;atcacert_der.c,207 :: 		if (int_data != NULL && *int_data_size < int_data_size_calc) {
BNE	R27, R0, L__atcacert_der_dec_integer224
NOP	
J	L__atcacert_der_dec_integer146
NOP	
L__atcacert_der_dec_integer224:
LW	R3, 0(R28)
LW	R2, 32(SP)
SLTU	R2, R3, R2
BNE	R2, R0, L__atcacert_der_dec_integer225
NOP	
J	L__atcacert_der_dec_integer145
NOP	
L__atcacert_der_dec_integer225:
L__atcacert_der_dec_integer135:
;atcacert_der.c,208 :: 		*int_data_size = int_data_size_calc;
LW	R2, 32(SP)
SW	R2, 0(R28)
;atcacert_der.c,209 :: 		return ATCACERT_E_BUFFER_TOO_SMALL;
ORI	R2, R0, 3
J	L_end_atcacert_der_dec_integer
NOP	
;atcacert_der.c,207 :: 		if (int_data != NULL && *int_data_size < int_data_size_calc) {
L__atcacert_der_dec_integer146:
L__atcacert_der_dec_integer145:
;atcacert_der.c,212 :: 		*int_data_size = int_data_size_calc;
LW	R2, 32(SP)
SW	R2, 0(R28)
;atcacert_der.c,214 :: 		if (int_data == NULL)
BEQ	R27, R0, L__atcacert_der_dec_integer226
NOP	
J	L_atcacert_der_dec_integer65
NOP	
L__atcacert_der_dec_integer226:
;atcacert_der.c,215 :: 		return ATCACERT_E_SUCCESS; // Caller doesn't want the actual data, just the int_data_size
MOVZ	R2, R0, R0
J	L_end_atcacert_der_dec_integer
NOP	
L_atcacert_der_dec_integer65:
;atcacert_der.c,217 :: 		memcpy(int_data, &der_int[1 + der_length_size], int_data_size_calc);
LW	R2, 28(SP)
ADDIU	R2, R2, 1
ADDU	R2, R25, R2
MOVZ	R26, R2, R0
MOVZ	R25, R27, R0
LW	R27, 32(SP)
JAL	_memcpy+0
NOP	
;atcacert_der.c,219 :: 		return ATCACERT_E_SUCCESS;
MOVZ	R2, R0, R0
;atcacert_der.c,220 :: 		}
;atcacert_der.c,219 :: 		return ATCACERT_E_SUCCESS;
;atcacert_der.c,220 :: 		}
L_end_atcacert_der_dec_integer:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 36
JR	RA
NOP	
; end of _atcacert_der_dec_integer
_atcacert_der_enc_ecdsa_sig_value:
;atcacert_der.c,224 :: 		size_t*       der_sig_size)
ADDIU	SP, SP, -40
SW	RA, 0(SP)
;atcacert_der.c,226 :: 		int ret = 0;
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
SW	R28, 16(SP)
;atcacert_der.c,227 :: 		size_t r_size = 0;
ADDIU	R23, SP, 32
ADDIU	R22, R23, 8
LUI	R24, hi_addr(?ICSatcacert_der_enc_ecdsa_sig_value_r_size_L0+0)
ORI	R24, R24, lo_addr(?ICSatcacert_der_enc_ecdsa_sig_value_r_size_L0+0)
JAL	___CC2DW+0
NOP	
;atcacert_der.c,228 :: 		size_t s_size = 0;
;atcacert_der.c,229 :: 		size_t der_sig_size_calc = 0;
;atcacert_der.c,231 :: 		if (raw_sig == NULL || der_sig_size == NULL)
BNE	R25, R0, L__atcacert_der_enc_ecdsa_sig_value229
NOP	
J	L__atcacert_der_enc_ecdsa_sig_value150
NOP	
L__atcacert_der_enc_ecdsa_sig_value229:
BNE	R27, R0, L__atcacert_der_enc_ecdsa_sig_value231
NOP	
J	L__atcacert_der_enc_ecdsa_sig_value149
NOP	
L__atcacert_der_enc_ecdsa_sig_value231:
J	L_atcacert_der_enc_ecdsa_sig_value68
NOP	
L__atcacert_der_enc_ecdsa_sig_value150:
L__atcacert_der_enc_ecdsa_sig_value149:
;atcacert_der.c,232 :: 		return ATCACERT_E_BAD_PARAMS;
ORI	R2, R0, 2
J	L_end_atcacert_der_enc_ecdsa_sig_value
NOP	
L_atcacert_der_enc_ecdsa_sig_value68:
;atcacert_der.c,235 :: 		ret = atcacert_der_enc_integer(&raw_sig[0], 32, TRUE, NULL, &r_size);
ADDIU	R2, SP, 32
SW	R27, 20(SP)
SW	R26, 24(SP)
MOVZ	R28, R0, R0
ORI	R27, R0, 1
ORI	R26, R0, 32
ADDIU	SP, SP, -4
SW	R2, 0(SP)
JAL	_atcacert_der_enc_integer+0
NOP	
ADDIU	SP, SP, 4
LW	R26, 24(SP)
LW	R27, 20(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_der.c,236 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_der_enc_ecdsa_sig_value233
NOP	
J	L_atcacert_der_enc_ecdsa_sig_value69
NOP	
L__atcacert_der_enc_ecdsa_sig_value233:
;atcacert_der.c,237 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_der_enc_ecdsa_sig_value
NOP	
L_atcacert_der_enc_ecdsa_sig_value69:
;atcacert_der.c,240 :: 		ret = atcacert_der_enc_integer(&raw_sig[32], 32, TRUE, NULL, &s_size);
ADDIU	R3, SP, 36
ADDIU	R2, R25, 32
SW	R27, 20(SP)
SW	R26, 24(SP)
SW	R25, 28(SP)
MOVZ	R28, R0, R0
ORI	R27, R0, 1
ORI	R26, R0, 32
MOVZ	R25, R2, R0
ADDIU	SP, SP, -4
SW	R3, 0(SP)
JAL	_atcacert_der_enc_integer+0
NOP	
ADDIU	SP, SP, 4
LW	R25, 28(SP)
LW	R26, 24(SP)
LW	R27, 20(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_der.c,241 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_der_enc_ecdsa_sig_value235
NOP	
J	L_atcacert_der_enc_ecdsa_sig_value70
NOP	
L__atcacert_der_enc_ecdsa_sig_value235:
;atcacert_der.c,242 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_der_enc_ecdsa_sig_value
NOP	
L_atcacert_der_enc_ecdsa_sig_value70:
;atcacert_der.c,246 :: 		der_sig_size_calc = 5 + r_size + s_size;
LW	R2, 32(SP)
ADDIU	R3, R2, 5
LW	R2, 36(SP)
ADDU	R2, R3, R2
; der_sig_size_calc start address is: 36 (R9)
MOVZ	R9, R2, R0
;atcacert_der.c,248 :: 		if (der_sig != NULL && *der_sig_size < der_sig_size_calc) {
BNE	R26, R0, L__atcacert_der_enc_ecdsa_sig_value237
NOP	
J	L__atcacert_der_enc_ecdsa_sig_value152
NOP	
L__atcacert_der_enc_ecdsa_sig_value237:
LW	R2, 0(R27)
SLTU	R2, R2, R9
BNE	R2, R0, L__atcacert_der_enc_ecdsa_sig_value238
NOP	
J	L__atcacert_der_enc_ecdsa_sig_value151
NOP	
L__atcacert_der_enc_ecdsa_sig_value238:
L__atcacert_der_enc_ecdsa_sig_value147:
;atcacert_der.c,249 :: 		*der_sig_size = der_sig_size_calc;
SW	R9, 0(R27)
; der_sig_size_calc end address is: 36 (R9)
;atcacert_der.c,250 :: 		return ATCACERT_E_BUFFER_TOO_SMALL;
ORI	R2, R0, 3
J	L_end_atcacert_der_enc_ecdsa_sig_value
NOP	
;atcacert_der.c,248 :: 		if (der_sig != NULL && *der_sig_size < der_sig_size_calc) {
L__atcacert_der_enc_ecdsa_sig_value152:
; der_sig_size_calc start address is: 36 (R9)
L__atcacert_der_enc_ecdsa_sig_value151:
;atcacert_der.c,253 :: 		*der_sig_size = der_sig_size_calc;
SW	R9, 0(R27)
;atcacert_der.c,255 :: 		if (der_sig == NULL)
BEQ	R26, R0, L__atcacert_der_enc_ecdsa_sig_value239
NOP	
J	L_atcacert_der_enc_ecdsa_sig_value74
NOP	
L__atcacert_der_enc_ecdsa_sig_value239:
; der_sig_size_calc end address is: 36 (R9)
;atcacert_der.c,256 :: 		return ATCACERT_E_SUCCESS;                  // Caller just wanted the encoded size
MOVZ	R2, R0, R0
J	L_end_atcacert_der_enc_ecdsa_sig_value
NOP	
L_atcacert_der_enc_ecdsa_sig_value74:
;atcacert_der.c,258 :: 		der_sig[0] = 0x03;                              // signatureValue bit string tag
; der_sig_size_calc start address is: 36 (R9)
ORI	R2, R0, 3
SB	R2, 0(R26)
;atcacert_der.c,259 :: 		der_sig[1] = (uint8_t)(der_sig_size_calc - 2);  // signatureValue bit string length
ADDIU	R3, R26, 1
ADDIU	R2, R9, -2
SB	R2, 0(R3)
;atcacert_der.c,260 :: 		der_sig[2] = 0x00;                              // signatureValue bit string spare bits
ADDIU	R2, R26, 2
SB	R0, 0(R2)
;atcacert_der.c,263 :: 		der_sig[3] = 0x30;                              // sequence tag
ADDIU	R3, R26, 3
ORI	R2, R0, 48
SB	R2, 0(R3)
;atcacert_der.c,264 :: 		der_sig[4] = (uint8_t)(der_sig_size_calc - 5);  // sequence length
ADDIU	R3, R26, 4
ADDIU	R2, R9, -5
; der_sig_size_calc end address is: 36 (R9)
SB	R2, 0(R3)
;atcacert_der.c,267 :: 		ret = atcacert_der_enc_integer(&raw_sig[0], 32, TRUE, &der_sig[5], &r_size);
ADDIU	R3, SP, 32
ADDIU	R2, R26, 5
SW	R26, 20(SP)
MOVZ	R28, R2, R0
ORI	R27, R0, 1
ORI	R26, R0, 32
ADDIU	SP, SP, -4
SW	R3, 0(SP)
JAL	_atcacert_der_enc_integer+0
NOP	
ADDIU	SP, SP, 4
LW	R26, 20(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_der.c,268 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_der_enc_ecdsa_sig_value241
NOP	
J	L_atcacert_der_enc_ecdsa_sig_value75
NOP	
L__atcacert_der_enc_ecdsa_sig_value241:
;atcacert_der.c,269 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_der_enc_ecdsa_sig_value
NOP	
L_atcacert_der_enc_ecdsa_sig_value75:
;atcacert_der.c,272 :: 		ret = atcacert_der_enc_integer(&raw_sig[32], 32, TRUE, &der_sig[5 + r_size], &s_size);
ADDIU	R4, SP, 36
LW	R2, 32(SP)
ADDIU	R2, R2, 5
ADDU	R3, R26, R2
ADDIU	R2, R25, 32
MOVZ	R28, R3, R0
ORI	R27, R0, 1
ORI	R26, R0, 32
MOVZ	R25, R2, R0
ADDIU	SP, SP, -4
SW	R4, 0(SP)
JAL	_atcacert_der_enc_integer+0
NOP	
ADDIU	SP, SP, 4
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_der.c,273 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_der_enc_ecdsa_sig_value243
NOP	
J	L_atcacert_der_enc_ecdsa_sig_value76
NOP	
L__atcacert_der_enc_ecdsa_sig_value243:
;atcacert_der.c,274 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_der_enc_ecdsa_sig_value
NOP	
L_atcacert_der_enc_ecdsa_sig_value76:
;atcacert_der.c,276 :: 		return ATCACERT_E_SUCCESS;
MOVZ	R2, R0, R0
;atcacert_der.c,277 :: 		}
;atcacert_der.c,276 :: 		return ATCACERT_E_SUCCESS;
;atcacert_der.c,277 :: 		}
L_end_atcacert_der_enc_ecdsa_sig_value:
LW	R28, 16(SP)
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 40
JR	RA
NOP	
; end of _atcacert_der_enc_ecdsa_sig_value
_atcacert_der_dec_ecdsa_sig_value:
;atcacert_der.c,281 :: 		uint8_t raw_sig[64])
ADDIU	SP, SP, -88
SW	RA, 0(SP)
;atcacert_der.c,283 :: 		int ret = 0;
SW	R25, 4(SP)
SW	R27, 8(SP)
SW	R28, 12(SP)
;atcacert_der.c,284 :: 		size_t curr_idx = 0;
;atcacert_der.c,285 :: 		size_t dec_size = 0;
ADDIU	R23, SP, 64
ADDIU	R22, R23, 24
LUI	R24, hi_addr(?ICSatcacert_der_dec_ecdsa_sig_value_dec_size_L0+0)
ORI	R24, R24, lo_addr(?ICSatcacert_der_dec_ecdsa_sig_value_dec_size_L0+0)
JAL	___CC2DW+0
NOP	
;atcacert_der.c,286 :: 		uint32_t bs_length = 0;
;atcacert_der.c,287 :: 		uint32_t seq_length = 0;
;atcacert_der.c,288 :: 		size_t r_size = 0;
;atcacert_der.c,289 :: 		size_t s_size = 0;
;atcacert_der.c,291 :: 		size_t int_data_size = 0;
;atcacert_der.c,293 :: 		if (der_sig == NULL || der_sig_size == NULL)
BNE	R25, R0, L__atcacert_der_dec_ecdsa_sig_value246
NOP	
J	L__atcacert_der_dec_ecdsa_sig_value155
NOP	
L__atcacert_der_dec_ecdsa_sig_value246:
BNE	R26, R0, L__atcacert_der_dec_ecdsa_sig_value248
NOP	
J	L__atcacert_der_dec_ecdsa_sig_value154
NOP	
L__atcacert_der_dec_ecdsa_sig_value248:
J	L_atcacert_der_dec_ecdsa_sig_value79
NOP	
L__atcacert_der_dec_ecdsa_sig_value155:
L__atcacert_der_dec_ecdsa_sig_value154:
;atcacert_der.c,294 :: 		return ATCACERT_E_BAD_PARAMS;
ORI	R2, R0, 2
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value79:
;atcacert_der.c,296 :: 		if (*der_sig_size < 1)
LW	R2, 0(R26)
SLTIU	R2, R2, 1
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value249
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value80
NOP	
L__atcacert_der_dec_ecdsa_sig_value249:
;atcacert_der.c,297 :: 		return ATCACERT_E_DECODING_ERROR; // No data to decode
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value80:
;atcacert_der.c,300 :: 		curr_idx = 0;
; curr_idx start address is: 16 (R4)
MOVZ	R4, R0, R0
;atcacert_der.c,301 :: 		if (der_sig[curr_idx] != 0x03)
LBU	R2, 0(R25)
ANDI	R3, R2, 255
ORI	R2, R0, 3
BNE	R3, R2, L__atcacert_der_dec_ecdsa_sig_value251
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value81
NOP	
L__atcacert_der_dec_ecdsa_sig_value251:
; curr_idx end address is: 16 (R4)
;atcacert_der.c,302 :: 		return ATCACERT_E_DECODING_ERROR; // Unexpected tag value
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value81:
;atcacert_der.c,303 :: 		curr_idx++;
; curr_idx start address is: 16 (R4)
ADDIU	R5, R4, 1
; curr_idx end address is: 16 (R4)
; curr_idx start address is: 28 (R7)
MOVZ	R7, R5, R0
;atcacert_der.c,306 :: 		dec_size = *der_sig_size - curr_idx;
LW	R2, 0(R26)
SUBU	R2, R2, R5
SW	R2, 64(SP)
;atcacert_der.c,307 :: 		ret = atcacert_der_dec_length(&der_sig[curr_idx], &dec_size, &bs_length);
ADDIU	R4, SP, 68
ADDIU	R3, SP, 64
ADDU	R2, R25, R5
SW	R27, 16(SP)
SW	R26, 20(SP)
SW	R25, 24(SP)
MOVZ	R27, R4, R0
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_atcacert_der_dec_length+0
NOP	
LW	R25, 24(SP)
LW	R26, 20(SP)
LW	R27, 16(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_der.c,308 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value253
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value82
NOP	
L__atcacert_der_dec_ecdsa_sig_value253:
; curr_idx end address is: 28 (R7)
;atcacert_der.c,309 :: 		return ret; // Failed to decode length
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value82:
;atcacert_der.c,310 :: 		curr_idx += dec_size;
; curr_idx start address is: 28 (R7)
LW	R2, 64(SP)
ADDU	R3, R7, R2
; curr_idx end address is: 28 (R7)
; curr_idx start address is: 16 (R4)
MOVZ	R4, R3, R0
;atcacert_der.c,311 :: 		if (curr_idx + bs_length > *der_sig_size)
LW	R2, 68(SP)
ADDU	R3, R3, R2
LW	R2, 0(R26)
SLTU	R2, R2, R3
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value254
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value83
NOP	
L__atcacert_der_dec_ecdsa_sig_value254:
; curr_idx end address is: 16 (R4)
;atcacert_der.c,312 :: 		return ATCACERT_E_DECODING_ERROR; // Not enough data in buffer to decode the rest
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value83:
;atcacert_der.c,315 :: 		if (curr_idx >= *der_sig_size)
; curr_idx start address is: 16 (R4)
LW	R2, 0(R26)
SLTU	R2, R4, R2
BEQ	R2, R0, L__atcacert_der_dec_ecdsa_sig_value255
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value84
NOP	
L__atcacert_der_dec_ecdsa_sig_value255:
; curr_idx end address is: 16 (R4)
;atcacert_der.c,316 :: 		return ATCACERT_E_DECODING_ERROR;   // No data left
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value84:
;atcacert_der.c,317 :: 		if (der_sig[curr_idx] != 0x00)
; curr_idx start address is: 16 (R4)
ADDU	R2, R25, R4
LBU	R2, 0(R2)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value257
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value85
NOP	
L__atcacert_der_dec_ecdsa_sig_value257:
; curr_idx end address is: 16 (R4)
;atcacert_der.c,318 :: 		return ATCACERT_E_DECODING_ERROR;   // Unexpected spare bits value
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value85:
;atcacert_der.c,319 :: 		curr_idx++;
; curr_idx start address is: 16 (R4)
ADDIU	R3, R4, 1
MOVZ	R4, R3, R0
;atcacert_der.c,324 :: 		if (curr_idx >= *der_sig_size)
LW	R2, 0(R26)
SLTU	R2, R3, R2
BEQ	R2, R0, L__atcacert_der_dec_ecdsa_sig_value258
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value86
NOP	
L__atcacert_der_dec_ecdsa_sig_value258:
; curr_idx end address is: 16 (R4)
;atcacert_der.c,325 :: 		return ATCACERT_E_DECODING_ERROR;   // No data left
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value86:
;atcacert_der.c,326 :: 		if (der_sig[curr_idx] != 0x30)
; curr_idx start address is: 16 (R4)
ADDU	R2, R25, R4
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 48
BNE	R3, R2, L__atcacert_der_dec_ecdsa_sig_value260
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value87
NOP	
L__atcacert_der_dec_ecdsa_sig_value260:
; curr_idx end address is: 16 (R4)
;atcacert_der.c,327 :: 		return ATCACERT_E_DECODING_ERROR;   // Unexpected tag value
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value87:
;atcacert_der.c,328 :: 		curr_idx++;
; curr_idx start address is: 16 (R4)
ADDIU	R3, R4, 1
; curr_idx end address is: 16 (R4)
; curr_idx start address is: 28 (R7)
MOVZ	R7, R3, R0
;atcacert_der.c,331 :: 		if (curr_idx >= *der_sig_size)
LW	R2, 0(R26)
SLTU	R2, R3, R2
BEQ	R2, R0, L__atcacert_der_dec_ecdsa_sig_value261
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value88
NOP	
L__atcacert_der_dec_ecdsa_sig_value261:
; curr_idx end address is: 28 (R7)
;atcacert_der.c,332 :: 		return ATCACERT_E_DECODING_ERROR; // No data left
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value88:
;atcacert_der.c,333 :: 		dec_size = *der_sig_size - curr_idx;
; curr_idx start address is: 28 (R7)
LW	R2, 0(R26)
SUBU	R2, R2, R7
SW	R2, 64(SP)
;atcacert_der.c,334 :: 		ret = atcacert_der_dec_length(&der_sig[curr_idx], &dec_size, &seq_length);
ADDIU	R4, SP, 72
ADDIU	R3, SP, 64
ADDU	R2, R25, R7
SW	R27, 16(SP)
SW	R26, 20(SP)
SW	R25, 24(SP)
MOVZ	R27, R4, R0
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_atcacert_der_dec_length+0
NOP	
LW	R25, 24(SP)
LW	R26, 20(SP)
LW	R27, 16(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_der.c,335 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value263
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value89
NOP	
L__atcacert_der_dec_ecdsa_sig_value263:
; curr_idx end address is: 28 (R7)
;atcacert_der.c,336 :: 		return ret; // Failed to decode length
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value89:
;atcacert_der.c,337 :: 		curr_idx += dec_size;
; curr_idx start address is: 28 (R7)
LW	R2, 64(SP)
ADDU	R3, R7, R2
MOVZ	R7, R3, R0
;atcacert_der.c,338 :: 		if (curr_idx + seq_length > *der_sig_size)
LW	R2, 72(SP)
ADDU	R3, R3, R2
LW	R2, 0(R26)
SLTU	R2, R2, R3
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value264
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value90
NOP	
L__atcacert_der_dec_ecdsa_sig_value264:
; curr_idx end address is: 28 (R7)
;atcacert_der.c,339 :: 		return ATCACERT_E_DECODING_ERROR; // Not enough data in buffer to decode the rest
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value90:
;atcacert_der.c,342 :: 		if (curr_idx >= *der_sig_size)
; curr_idx start address is: 28 (R7)
LW	R2, 0(R26)
SLTU	R2, R7, R2
BEQ	R2, R0, L__atcacert_der_dec_ecdsa_sig_value265
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value91
NOP	
L__atcacert_der_dec_ecdsa_sig_value265:
; curr_idx end address is: 28 (R7)
;atcacert_der.c,343 :: 		return ATCACERT_E_DECODING_ERROR; // No data left
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value91:
;atcacert_der.c,344 :: 		r_size = *der_sig_size - curr_idx;
; curr_idx start address is: 28 (R7)
LW	R2, 0(R26)
SUBU	R2, R2, R7
SW	R2, 76(SP)
;atcacert_der.c,345 :: 		int_data_size = sizeof(int_data);
ORI	R2, R0, 33
SW	R2, 84(SP)
;atcacert_der.c,346 :: 		ret = atcacert_der_dec_integer(&der_sig[curr_idx], &r_size, int_data, &int_data_size);
ADDIU	R5, SP, 84
ADDIU	R4, SP, 28
ADDIU	R3, SP, 76
ADDU	R2, R25, R7
SW	R27, 16(SP)
SW	R26, 20(SP)
SW	R25, 24(SP)
MOVZ	R28, R5, R0
MOVZ	R27, R4, R0
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_atcacert_der_dec_integer+0
NOP	
LW	R25, 24(SP)
LW	R26, 20(SP)
LW	R27, 16(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_der.c,347 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value267
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value92
NOP	
L__atcacert_der_dec_ecdsa_sig_value267:
; curr_idx end address is: 28 (R7)
;atcacert_der.c,348 :: 		return ret; // Failed to decode length
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value92:
;atcacert_der.c,349 :: 		curr_idx += r_size;
; curr_idx start address is: 28 (R7)
LW	R2, 76(SP)
ADDU	R2, R7, R2
MOVZ	R7, R2, R0
;atcacert_der.c,351 :: 		if (raw_sig != NULL)
BNE	R27, R0, L__atcacert_der_dec_ecdsa_sig_value269
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value93
NOP	
L__atcacert_der_dec_ecdsa_sig_value269:
;atcacert_der.c,352 :: 		memset(raw_sig, 0, 64); // Zero out the raw sig as the decoded integers may not touch all bytes
SW	R27, 16(SP)
SW	R26, 20(SP)
SW	R25, 24(SP)
MOVZ	R26, R0, R0
MOVZ	R25, R27, R0
ORI	R27, R0, 64
JAL	_memset+0
NOP	
LW	R25, 24(SP)
LW	R26, 20(SP)
LW	R27, 16(SP)
L_atcacert_der_dec_ecdsa_sig_value93:
;atcacert_der.c,354 :: 		if (int_data_size <= 32) {
LW	R2, 84(SP)
SLTIU	R2, R2, 33
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value270
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value94
NOP	
L__atcacert_der_dec_ecdsa_sig_value270:
;atcacert_der.c,355 :: 		if (raw_sig != NULL)
BNE	R27, R0, L__atcacert_der_dec_ecdsa_sig_value272
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value95
NOP	
L__atcacert_der_dec_ecdsa_sig_value272:
;atcacert_der.c,356 :: 		memcpy(&raw_sig[32 - int_data_size], &int_data[0], int_data_size);
ADDIU	R4, SP, 28
LW	R3, 84(SP)
ORI	R2, R0, 32
SUBU	R2, R2, R3
ADDU	R2, R27, R2
SW	R27, 16(SP)
SW	R26, 20(SP)
SW	R25, 24(SP)
LW	R27, 84(SP)
MOVZ	R26, R4, R0
MOVZ	R25, R2, R0
JAL	_memcpy+0
NOP	
LW	R25, 24(SP)
LW	R26, 20(SP)
LW	R27, 16(SP)
L_atcacert_der_dec_ecdsa_sig_value95:
;atcacert_der.c,357 :: 		}else if (int_data_size == 33) {
J	L_atcacert_der_dec_ecdsa_sig_value96
NOP	
L_atcacert_der_dec_ecdsa_sig_value94:
LW	R3, 84(SP)
ORI	R2, R0, 33
BEQ	R3, R2, L__atcacert_der_dec_ecdsa_sig_value273
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value97
NOP	
L__atcacert_der_dec_ecdsa_sig_value273:
;atcacert_der.c,358 :: 		if (int_data[0] != 0x00)
ADDIU	R2, SP, 28
LBU	R2, 0(R2)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value275
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value98
NOP	
L__atcacert_der_dec_ecdsa_sig_value275:
; curr_idx end address is: 28 (R7)
;atcacert_der.c,359 :: 		return ATCACERT_E_DECODING_ERROR; // R integer is too large
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value98:
;atcacert_der.c,361 :: 		if (raw_sig != NULL)
; curr_idx start address is: 28 (R7)
BNE	R27, R0, L__atcacert_der_dec_ecdsa_sig_value277
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value99
NOP	
L__atcacert_der_dec_ecdsa_sig_value277:
;atcacert_der.c,362 :: 		memcpy(&raw_sig[0], &int_data[1], 32);
ADDIU	R2, SP, 28
ADDIU	R2, R2, 1
SW	R27, 16(SP)
SW	R26, 20(SP)
SW	R25, 24(SP)
MOVZ	R26, R2, R0
MOVZ	R25, R27, R0
ORI	R27, R0, 32
JAL	_memcpy+0
NOP	
LW	R25, 24(SP)
LW	R26, 20(SP)
LW	R27, 16(SP)
L_atcacert_der_dec_ecdsa_sig_value99:
;atcacert_der.c,363 :: 		}else
J	L_atcacert_der_dec_ecdsa_sig_value100
NOP	
; curr_idx end address is: 28 (R7)
L_atcacert_der_dec_ecdsa_sig_value97:
;atcacert_der.c,364 :: 		return ATCACERT_E_DECODING_ERROR; // R integer is too large
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value100:
; curr_idx start address is: 28 (R7)
L_atcacert_der_dec_ecdsa_sig_value96:
;atcacert_der.c,367 :: 		if (curr_idx >= *der_sig_size)
LW	R2, 0(R26)
SLTU	R2, R7, R2
BEQ	R2, R0, L__atcacert_der_dec_ecdsa_sig_value278
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value101
NOP	
L__atcacert_der_dec_ecdsa_sig_value278:
; curr_idx end address is: 28 (R7)
;atcacert_der.c,368 :: 		return ATCACERT_E_DECODING_ERROR; // No data left
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value101:
;atcacert_der.c,369 :: 		s_size = *der_sig_size - curr_idx;
; curr_idx start address is: 28 (R7)
LW	R2, 0(R26)
SUBU	R2, R2, R7
SW	R2, 80(SP)
;atcacert_der.c,370 :: 		int_data_size = sizeof(int_data);
ORI	R2, R0, 33
SW	R2, 84(SP)
;atcacert_der.c,371 :: 		ret = atcacert_der_dec_integer(&der_sig[curr_idx], &s_size, int_data, &int_data_size);
ADDIU	R5, SP, 84
ADDIU	R4, SP, 28
ADDIU	R3, SP, 80
ADDU	R2, R25, R7
SW	R27, 16(SP)
SW	R26, 20(SP)
MOVZ	R28, R5, R0
MOVZ	R27, R4, R0
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_atcacert_der_dec_integer+0
NOP	
LW	R26, 20(SP)
LW	R27, 16(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atcacert_der.c,372 :: 		if (ret != ATCACERT_E_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value280
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value102
NOP	
L__atcacert_der_dec_ecdsa_sig_value280:
; curr_idx end address is: 28 (R7)
;atcacert_der.c,373 :: 		return ret; // Failed to decode length
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value102:
;atcacert_der.c,374 :: 		curr_idx += s_size;
; curr_idx start address is: 28 (R7)
LW	R2, 80(SP)
ADDU	R2, R7, R2
; curr_idx end address is: 28 (R7)
; curr_idx start address is: 24 (R6)
MOVZ	R6, R2, R0
;atcacert_der.c,376 :: 		if (int_data_size <= 32) {
LW	R2, 84(SP)
SLTIU	R2, R2, 33
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value281
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value103
NOP	
L__atcacert_der_dec_ecdsa_sig_value281:
;atcacert_der.c,377 :: 		if (raw_sig != NULL)
BNE	R27, R0, L__atcacert_der_dec_ecdsa_sig_value283
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value104
NOP	
L__atcacert_der_dec_ecdsa_sig_value283:
;atcacert_der.c,378 :: 		memcpy(&raw_sig[64 - int_data_size], &int_data[0], int_data_size);
ADDIU	R4, SP, 28
LW	R3, 84(SP)
ORI	R2, R0, 64
SUBU	R2, R2, R3
ADDU	R2, R27, R2
SW	R26, 16(SP)
LW	R27, 84(SP)
MOVZ	R26, R4, R0
MOVZ	R25, R2, R0
JAL	_memcpy+0
NOP	
LW	R26, 16(SP)
L_atcacert_der_dec_ecdsa_sig_value104:
;atcacert_der.c,379 :: 		}else if (int_data_size == 33) {
J	L_atcacert_der_dec_ecdsa_sig_value105
NOP	
L_atcacert_der_dec_ecdsa_sig_value103:
LW	R3, 84(SP)
ORI	R2, R0, 33
BEQ	R3, R2, L__atcacert_der_dec_ecdsa_sig_value284
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value106
NOP	
L__atcacert_der_dec_ecdsa_sig_value284:
;atcacert_der.c,380 :: 		if (int_data[0] != 0x00)
ADDIU	R2, SP, 28
LBU	R2, 0(R2)
ANDI	R2, R2, 255
BNE	R2, R0, L__atcacert_der_dec_ecdsa_sig_value286
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value107
NOP	
L__atcacert_der_dec_ecdsa_sig_value286:
; curr_idx end address is: 24 (R6)
;atcacert_der.c,381 :: 		return ATCACERT_E_DECODING_ERROR; // S integer is too large
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value107:
;atcacert_der.c,383 :: 		if (raw_sig != NULL)
; curr_idx start address is: 24 (R6)
BNE	R27, R0, L__atcacert_der_dec_ecdsa_sig_value288
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value108
NOP	
L__atcacert_der_dec_ecdsa_sig_value288:
;atcacert_der.c,384 :: 		memcpy(&raw_sig[32], &int_data[1], 32);
ADDIU	R2, SP, 28
ADDIU	R3, R2, 1
ADDIU	R2, R27, 32
SW	R26, 16(SP)
ORI	R27, R0, 32
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_memcpy+0
NOP	
LW	R26, 16(SP)
L_atcacert_der_dec_ecdsa_sig_value108:
;atcacert_der.c,385 :: 		}else
J	L_atcacert_der_dec_ecdsa_sig_value109
NOP	
; curr_idx end address is: 24 (R6)
L_atcacert_der_dec_ecdsa_sig_value106:
;atcacert_der.c,386 :: 		return ATCACERT_E_DECODING_ERROR; // S integer is too large
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value109:
; curr_idx start address is: 24 (R6)
L_atcacert_der_dec_ecdsa_sig_value105:
;atcacert_der.c,388 :: 		if (seq_length != r_size + s_size)
LW	R3, 80(SP)
LW	R2, 76(SP)
ADDU	R3, R2, R3
LW	R2, 72(SP)
BNE	R2, R3, L__atcacert_der_dec_ecdsa_sig_value290
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value110
NOP	
L__atcacert_der_dec_ecdsa_sig_value290:
; curr_idx end address is: 24 (R6)
;atcacert_der.c,389 :: 		return ATCACERT_E_DECODING_ERROR; // Unexpected extra data in sequence
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value110:
;atcacert_der.c,391 :: 		if (bs_length != r_size + s_size + 3)
; curr_idx start address is: 24 (R6)
LW	R3, 80(SP)
LW	R2, 76(SP)
ADDU	R2, R2, R3
ADDIU	R3, R2, 3
LW	R2, 68(SP)
BNE	R2, R3, L__atcacert_der_dec_ecdsa_sig_value292
NOP	
J	L_atcacert_der_dec_ecdsa_sig_value111
NOP	
L__atcacert_der_dec_ecdsa_sig_value292:
; curr_idx end address is: 24 (R6)
;atcacert_der.c,392 :: 		return ATCACERT_E_DECODING_ERROR; // Unexpected extra data in bit string
ORI	R2, R0, 4
J	L_end_atcacert_der_dec_ecdsa_sig_value
NOP	
L_atcacert_der_dec_ecdsa_sig_value111:
;atcacert_der.c,394 :: 		*der_sig_size = curr_idx;
; curr_idx start address is: 24 (R6)
SW	R6, 0(R26)
; curr_idx end address is: 24 (R6)
;atcacert_der.c,396 :: 		return ATCACERT_E_SUCCESS;
MOVZ	R2, R0, R0
;atcacert_der.c,397 :: 		}
;atcacert_der.c,396 :: 		return ATCACERT_E_SUCCESS;
;atcacert_der.c,397 :: 		}
L_end_atcacert_der_dec_ecdsa_sig_value:
LW	R28, 12(SP)
LW	R27, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 88
JR	RA
NOP	
; end of _atcacert_der_dec_ecdsa_sig_value
