_atcac_sw_sha2_256_init:
;atca_crypto_sw_sha2.c,50 :: 		int atcac_sw_sha2_256_init(atcac_sha2_256_ctx* ctx)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atca_crypto_sw_sha2.c,53 :: 		return ATCA_ASSERT_FAILURE; // atcac_sha1_ctx isn't large enough for this implementation
L_atcac_sw_sha2_256_init0:
;atca_crypto_sw_sha2.c,54 :: 		sw_sha256_init((sw_sha256_ctx*)ctx);
JAL	_sw_sha256_init+0
NOP	
;atca_crypto_sw_sha2.c,56 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_crypto_sw_sha2.c,57 :: 		}
L_end_atcac_sw_sha2_256_init:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcac_sw_sha2_256_init
_atcac_sw_sha2_256_update:
;atca_crypto_sw_sha2.c,67 :: 		int atcac_sw_sha2_256_update(atcac_sha2_256_ctx* ctx,  uint8_t* data, size_t data_size)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atca_crypto_sw_sha2.c,69 :: 		sw_sha256_update((sw_sha256_ctx*)ctx, data, (uint32_t)data_size);
JAL	_sw_sha256_update+0
NOP	
;atca_crypto_sw_sha2.c,71 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_crypto_sw_sha2.c,72 :: 		}
L_end_atcac_sw_sha2_256_update:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcac_sw_sha2_256_update
_atcac_sw_sha2_256_finish:
;atca_crypto_sw_sha2.c,80 :: 		int atcac_sw_sha2_256_finish(atcac_sha2_256_ctx* ctx, uint8_t digest[ATCA_SHA2_256_DIGEST_SIZE])
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;atca_crypto_sw_sha2.c,82 :: 		sw_sha256_final((sw_sha256_ctx*)ctx, digest);
JAL	_sw_sha256_final+0
NOP	
;atca_crypto_sw_sha2.c,84 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_crypto_sw_sha2.c,85 :: 		}
L_end_atcac_sw_sha2_256_finish:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _atcac_sw_sha2_256_finish
_atcac_sw_sha2_256:
;atca_crypto_sw_sha2.c,95 :: 		int atcac_sw_sha2_256( uint8_t* data, size_t data_size, uint8_t digest[ATCA_SHA2_256_DIGEST_SIZE])
ADDIU	SP, SP, -216
SW	RA, 0(SP)
;atca_crypto_sw_sha2.c,100 :: 		ret = atcac_sw_sha2_256_init(&ctx);
SW	R25, 4(SP)
SW	R26, 8(SP)
ADDIU	R2, SP, 24
SW	R27, 12(SP)
SW	R26, 16(SP)
SW	R25, 20(SP)
MOVZ	R25, R2, R0
JAL	_atcac_sw_sha2_256_init+0
NOP	
LW	R25, 20(SP)
LW	R26, 16(SP)
LW	R27, 12(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atca_crypto_sw_sha2.c,101 :: 		if (ret != ATCA_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcac_sw_sha2_2569
NOP	
J	L_atcac_sw_sha2_2561
NOP	
L__atcac_sw_sha2_2569:
;atca_crypto_sw_sha2.c,102 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcac_sw_sha2_256
NOP	
L_atcac_sw_sha2_2561:
;atca_crypto_sw_sha2.c,104 :: 		ret = atcac_sw_sha2_256_update(&ctx, data, data_size);
ADDIU	R2, SP, 24
SW	R27, 12(SP)
MOVZ	R27, R26, R0
MOVZ	R26, R25, R0
MOVZ	R25, R2, R0
JAL	_atcac_sw_sha2_256_update+0
NOP	
LW	R27, 12(SP)
; ret start address is: 12 (R3)
SEH	R3, R2
;atca_crypto_sw_sha2.c,105 :: 		if (ret != ATCA_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcac_sw_sha2_25611
NOP	
J	L_atcac_sw_sha2_2562
NOP	
L__atcac_sw_sha2_25611:
;atca_crypto_sw_sha2.c,106 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcac_sw_sha2_256
NOP	
L_atcac_sw_sha2_2562:
;atca_crypto_sw_sha2.c,108 :: 		ret = atcac_sw_sha2_256_finish(&ctx, digest);
ADDIU	R2, SP, 24
MOVZ	R26, R27, R0
MOVZ	R25, R2, R0
JAL	_atcac_sw_sha2_256_finish+0
NOP	
; ret start address is: 12 (R3)
SEH	R3, R2
;atca_crypto_sw_sha2.c,109 :: 		if (ret != ATCA_SUCCESS)
SEH	R2, R2
BNE	R2, R0, L__atcac_sw_sha2_25613
NOP	
J	L_atcac_sw_sha2_2563
NOP	
L__atcac_sw_sha2_25613:
;atca_crypto_sw_sha2.c,110 :: 		return ret;
SEH	R2, R3
; ret end address is: 12 (R3)
J	L_end_atcac_sw_sha2_256
NOP	
L_atcac_sw_sha2_2563:
;atca_crypto_sw_sha2.c,112 :: 		return ATCA_SUCCESS;
MOVZ	R2, R0, R0
;atca_crypto_sw_sha2.c,113 :: 		}
;atca_crypto_sw_sha2.c,112 :: 		return ATCA_SUCCESS;
;atca_crypto_sw_sha2.c,113 :: 		}
L_end_atcac_sw_sha2_256:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 216
JR	RA
NOP	
; end of _atcac_sw_sha2_256
