sha2_routines_sw_sha256_process:
;sha2_routines.c,54 :: 		static void sw_sha256_process(sw_sha256_ctx* ctx,  uint8_t* blocks, uint32_t block_count)
ADDIU	SP, SP, -288
;sha2_routines.c,56 :: 		int i = 0;
;sha2_routines.c,57 :: 		uint32_t block = 0;
;sha2_routines.c,76 :: 		for (block = 0; block < block_count; block++) {
; block start address is: 32 (R8)
MOVZ	R8, R0, R0
; block end address is: 32 (R8)
L_sha2_routines_sw_sha256_process0:
; block start address is: 32 (R8)
SLTU	R2, R8, R27
BNE	R2, R0, L_sha2_routines_sw_sha256_process30
NOP	
J	L_sha2_routines_sw_sha256_process1
NOP	
L_sha2_routines_sw_sha256_process30:
;sha2_routines.c,83 :: 		uint8_t* cur_msg_block = &blocks[block * SHA256_BLOCK_SIZE];
SLL	R2, R8, 6
ADDU	R2, R26, R2
; cur_msg_block start address is: 16 (R4)
MOVZ	R4, R2, R0
;sha2_routines.c,86 :: 		for (i = 0; i < SHA256_BLOCK_SIZE; i += 4) {
; i start address is: 20 (R5)
MOVZ	R5, R0, R0
; i end address is: 20 (R5)
; block end address is: 32 (R8)
L_sha2_routines_sw_sha256_process3:
; i start address is: 20 (R5)
; cur_msg_block start address is: 16 (R4)
; cur_msg_block end address is: 16 (R4)
; block start address is: 32 (R8)
SEH	R2, R5
SLTI	R2, R2, 64
BNE	R2, R0, L_sha2_routines_sw_sha256_process31
NOP	
J	L_sha2_routines_sw_sha256_process4
NOP	
L_sha2_routines_sw_sha256_process31:
; cur_msg_block end address is: 16 (R4)
;sha2_routines.c,87 :: 		w_union.w_byte[i + 3] = cur_msg_block[i + 0];
; cur_msg_block start address is: 16 (R4)
ADDIU	R2, R5, 3
ADDIU	R3, SP, 32
SEH	R2, R2
ADDU	R3, R3, R2
SEH	R2, R5
ADDU	R2, R4, R2
LBU	R2, 0(R2)
SB	R2, 0(R3)
;sha2_routines.c,88 :: 		w_union.w_byte[i + 2] = cur_msg_block[i + 1];
ADDIU	R2, R5, 2
ADDIU	R3, SP, 32
SEH	R2, R2
ADDU	R3, R3, R2
ADDIU	R2, R5, 1
SEH	R2, R2
ADDU	R2, R4, R2
LBU	R2, 0(R2)
SB	R2, 0(R3)
;sha2_routines.c,89 :: 		w_union.w_byte[i + 1] = cur_msg_block[i + 2];
ADDIU	R2, R5, 1
ADDIU	R3, SP, 32
SEH	R2, R2
ADDU	R3, R3, R2
ADDIU	R2, R5, 2
SEH	R2, R2
ADDU	R2, R4, R2
LBU	R2, 0(R2)
SB	R2, 0(R3)
;sha2_routines.c,90 :: 		w_union.w_byte[i + 0] = cur_msg_block[i + 3];
ADDIU	R3, SP, 32
SEH	R2, R5
ADDU	R3, R3, R2
ADDIU	R2, R5, 3
SEH	R2, R2
ADDU	R2, R4, R2
LBU	R2, 0(R2)
SB	R2, 0(R3)
;sha2_routines.c,86 :: 		for (i = 0; i < SHA256_BLOCK_SIZE; i += 4) {
ADDIU	R2, R5, 4
SEH	R5, R2
;sha2_routines.c,91 :: 		}
; cur_msg_block end address is: 16 (R4)
; i end address is: 20 (R5)
J	L_sha2_routines_sw_sha256_process3
NOP	
L_sha2_routines_sw_sha256_process4:
;sha2_routines.c,93 :: 		w_index = 16;
; w_index start address is: 36 (R9)
ORI	R9, R0, 16
; w_index end address is: 36 (R9)
; block end address is: 32 (R8)
;sha2_routines.c,94 :: 		while (w_index < SHA256_BLOCK_SIZE) {
L_sha2_routines_sw_sha256_process6:
; w_index start address is: 36 (R9)
; block start address is: 32 (R8)
SLTIU	R2, R9, 64
BNE	R2, R0, L_sha2_routines_sw_sha256_process32
NOP	
J	L_sha2_routines_sw_sha256_process7
NOP	
L_sha2_routines_sw_sha256_process32:
;sha2_routines.c,96 :: 		word_value = w_union.w_word[w_index - 15];
ADDIU	R2, R9, -15
ADDIU	R3, SP, 32
SLL	R2, R2, 2
ADDU	R2, R3, R2
LW	R5, 0(R2)
;sha2_routines.c,97 :: 		s0 = rotate_right(word_value, 7) ^ rotate_right(word_value, 18) ^ (word_value >> 3);
SRL	R3, R5, 7
SLL	R2, R5, 25
OR	R4, R3, R2
SRL	R3, R5, 18
SLL	R2, R5, 14
OR	R2, R3, R2
XOR	R3, R4, R2
SRL	R2, R5, 3
XOR	R7, R3, R2
;sha2_routines.c,99 :: 		word_value = w_union.w_word[w_index - 2];
ADDIU	R2, R9, -2
ADDIU	R3, SP, 32
SLL	R2, R2, 2
ADDU	R2, R3, R2
LW	R5, 0(R2)
;sha2_routines.c,100 :: 		s1 = rotate_right(word_value, 17) ^ rotate_right(word_value, 19) ^ (word_value >> 10);
SRL	R3, R5, 17
SLL	R2, R5, 15
OR	R4, R3, R2
SRL	R3, R5, 19
SLL	R2, R5, 13
OR	R2, R3, R2
XOR	R3, R4, R2
SRL	R2, R5, 10
XOR	R6, R3, R2
;sha2_routines.c,102 :: 		w_union.w_word[w_index] = w_union.w_word[w_index - 16] + s0 + w_union.w_word[w_index - 7] + s1;
ADDIU	R3, SP, 32
SLL	R2, R9, 2
ADDU	R5, R3, R2
ADDIU	R2, R9, -16
ADDIU	R3, SP, 32
SLL	R2, R2, 2
ADDU	R2, R3, R2
LW	R2, 0(R2)
ADDU	R4, R2, R7
ADDIU	R2, R9, -7
ADDIU	R3, SP, 32
SLL	R2, R2, 2
ADDU	R2, R3, R2
LW	R2, 0(R2)
ADDU	R2, R4, R2
ADDU	R2, R2, R6
SW	R2, 0(R5)
;sha2_routines.c,104 :: 		w_index++;
ADDIU	R2, R9, 1
MOVZ	R9, R2, R0
;sha2_routines.c,105 :: 		}
; w_index end address is: 36 (R9)
J	L_sha2_routines_sw_sha256_process6
NOP	
L_sha2_routines_sw_sha256_process7:
;sha2_routines.c,108 :: 		for (i = 0; i < 8; i++)
; i start address is: 20 (R5)
MOVZ	R5, R0, R0
; i end address is: 20 (R5)
; block end address is: 32 (R8)
L_sha2_routines_sw_sha256_process8:
; i start address is: 20 (R5)
; block start address is: 32 (R8)
SEH	R2, R5
SLTI	R2, R2, 8
BNE	R2, R0, L_sha2_routines_sw_sha256_process33
NOP	
J	L_sha2_routines_sw_sha256_process9
NOP	
L_sha2_routines_sw_sha256_process33:
;sha2_routines.c,109 :: 		rotate_register[i] = ctx->hash[i];
ADDIU	R3, SP, 0
SEH	R2, R5
SLL	R4, R2, 2
ADDU	R3, R3, R4
ADDIU	R2, R25, 136
ADDU	R2, R2, R4
LW	R2, 0(R2)
SW	R2, 0(R3)
;sha2_routines.c,108 :: 		for (i = 0; i < 8; i++)
ADDIU	R2, R5, 1
SEH	R5, R2
;sha2_routines.c,109 :: 		rotate_register[i] = ctx->hash[i];
; i end address is: 20 (R5)
J	L_sha2_routines_sw_sha256_process8
NOP	
L_sha2_routines_sw_sha256_process9:
;sha2_routines.c,112 :: 		for (i = 0; i < SHA256_BLOCK_SIZE; i++) {
; i start address is: 36 (R9)
MOVZ	R9, R0, R0
; i end address is: 36 (R9)
; block end address is: 32 (R8)
L_sha2_routines_sw_sha256_process11:
; i start address is: 36 (R9)
; block start address is: 32 (R8)
SEH	R2, R9
SLTI	R2, R2, 64
BNE	R2, R0, L_sha2_routines_sw_sha256_process34
NOP	
J	L_sha2_routines_sw_sha256_process12
NOP	
L_sha2_routines_sw_sha256_process34:
;sha2_routines.c,113 :: 		s0 = rotate_right(rotate_register[0], 2)
ADDIU	R7, SP, 0
LW	R6, 0(R7)
SRL	R3, R6, 2
SLL	R2, R6, 30
OR	R4, R3, R2
;sha2_routines.c,114 :: 		^ rotate_right(rotate_register[0], 13)
SRL	R3, R6, 13
SLL	R2, R6, 19
OR	R2, R3, R2
XOR	R4, R4, R2
;sha2_routines.c,115 :: 		^ rotate_right(rotate_register[0], 22);
SRL	R3, R6, 22
SLL	R2, R6, 10
OR	R2, R3, R2
XOR	R5, R4, R2
;sha2_routines.c,116 :: 		maj = (rotate_register[0] & rotate_register[1])
ADDIU	R2, R7, 4
LW	R2, 0(R2)
AND	R3, R6, R2
;sha2_routines.c,117 :: 		^ (rotate_register[0] & rotate_register[2])
ADDIU	R2, R7, 8
LW	R2, 0(R2)
AND	R2, R6, R2
XOR	R4, R3, R2
;sha2_routines.c,118 :: 		^ (rotate_register[1] & rotate_register[2]);
ADDIU	R2, R7, 4
LW	R3, 0(R2)
ADDIU	R2, R7, 8
LW	R2, 0(R2)
AND	R2, R3, R2
XOR	R2, R4, R2
;sha2_routines.c,119 :: 		t2 = s0 + maj;
ADDU	R2, R5, R2
; t2 start address is: 24 (R6)
MOVZ	R6, R2, R0
;sha2_routines.c,120 :: 		s1 = rotate_right(rotate_register[4], 6)
ADDIU	R2, R7, 16
LW	R2, 0(R2)
SRL	R3, R2, 6
ADDIU	R2, R7, 16
LW	R2, 0(R2)
SLL	R2, R2, 26
OR	R4, R3, R2
;sha2_routines.c,121 :: 		^ rotate_right(rotate_register[4], 11)
ADDIU	R2, R7, 16
LW	R2, 0(R2)
SRL	R3, R2, 11
ADDIU	R2, R7, 16
LW	R2, 0(R2)
SLL	R2, R2, 21
OR	R2, R3, R2
XOR	R4, R4, R2
;sha2_routines.c,122 :: 		^ rotate_right(rotate_register[4], 25);
ADDIU	R2, R7, 16
LW	R2, 0(R2)
SRL	R3, R2, 25
ADDIU	R2, R7, 16
LW	R2, 0(R2)
SLL	R2, R2, 7
OR	R2, R3, R2
XOR	R5, R4, R2
;sha2_routines.c,123 :: 		ch = (rotate_register[4] & rotate_register[5])
ADDIU	R2, R7, 16
LW	R3, 0(R2)
ADDIU	R2, R7, 20
LW	R2, 0(R2)
AND	R4, R3, R2
;sha2_routines.c,124 :: 		^ (~rotate_register[4] & rotate_register[6]);
ADDIU	R2, R7, 16
LW	R2, 0(R2)
NOR	R3, R2, R0
ADDIU	R2, R7, 24
LW	R2, 0(R2)
AND	R2, R3, R2
XOR	R3, R4, R2
;sha2_routines.c,125 :: 		t1 = rotate_register[7] + s1 + ch + k[i] + w_union.w_word[i];
ADDIU	R2, R7, 28
LW	R2, 0(R2)
ADDU	R2, R2, R5
ADDU	R3, R2, R3
SEH	R2, R9
SLL	R4, R2, 2
LUI	R2, hi_addr(sha2_routines_sw_sha256_process_k_L0+0)
ORI	R2, R2, lo_addr(sha2_routines_sw_sha256_process_k_L0+0)
ADDU	R2, R2, R4
LW	R2, 0(R2)
ADDU	R3, R3, R2
ADDIU	R2, SP, 32
ADDU	R2, R2, R4
LW	R2, 0(R2)
ADDU	R2, R3, R2
; t1 start address is: 16 (R4)
MOVZ	R4, R2, R0
;sha2_routines.c,127 :: 		rotate_register[7] = rotate_register[6];
ADDIU	R3, R7, 28
ADDIU	R2, R7, 24
LW	R2, 0(R2)
SW	R2, 0(R3)
;sha2_routines.c,128 :: 		rotate_register[6] = rotate_register[5];
ADDIU	R3, R7, 24
ADDIU	R2, R7, 20
LW	R2, 0(R2)
SW	R2, 0(R3)
;sha2_routines.c,129 :: 		rotate_register[5] = rotate_register[4];
ADDIU	R3, R7, 20
ADDIU	R2, R7, 16
LW	R2, 0(R2)
SW	R2, 0(R3)
;sha2_routines.c,130 :: 		rotate_register[4] = rotate_register[3] + t1;
ADDIU	R3, R7, 16
ADDIU	R2, R7, 12
LW	R2, 0(R2)
ADDU	R2, R2, R4
SW	R2, 0(R3)
;sha2_routines.c,131 :: 		rotate_register[3] = rotate_register[2];
ADDIU	R3, R7, 12
ADDIU	R2, R7, 8
LW	R2, 0(R2)
SW	R2, 0(R3)
;sha2_routines.c,132 :: 		rotate_register[2] = rotate_register[1];
ADDIU	R3, R7, 8
ADDIU	R2, R7, 4
LW	R2, 0(R2)
SW	R2, 0(R3)
;sha2_routines.c,133 :: 		rotate_register[1] = rotate_register[0];
ADDIU	R3, R7, 4
LW	R2, 0(R7)
SW	R2, 0(R3)
;sha2_routines.c,134 :: 		rotate_register[0] = t1 + t2;
ADDU	R2, R4, R6
; t2 end address is: 24 (R6)
; t1 end address is: 16 (R4)
SW	R2, 0(R7)
;sha2_routines.c,112 :: 		for (i = 0; i < SHA256_BLOCK_SIZE; i++) {
ADDIU	R2, R9, 1
SEH	R9, R2
;sha2_routines.c,135 :: 		}
; i end address is: 36 (R9)
J	L_sha2_routines_sw_sha256_process11
NOP	
L_sha2_routines_sw_sha256_process12:
;sha2_routines.c,138 :: 		for (i = 0; i < 8; i++)
; i start address is: 24 (R6)
MOVZ	R6, R0, R0
; i end address is: 24 (R6)
; block end address is: 32 (R8)
MOVZ	R5, R8, R0
L_sha2_routines_sw_sha256_process14:
; i start address is: 24 (R6)
; block start address is: 20 (R5)
SEH	R2, R6
SLTI	R2, R2, 8
BNE	R2, R0, L_sha2_routines_sw_sha256_process35
NOP	
J	L_sha2_routines_sw_sha256_process15
NOP	
L_sha2_routines_sw_sha256_process35:
;sha2_routines.c,139 :: 		ctx->hash[i] += rotate_register[i];
ADDIU	R4, R25, 136
SEH	R2, R6
SLL	R3, R2, 2
ADDU	R4, R4, R3
ADDIU	R2, SP, 0
ADDU	R2, R2, R3
LW	R3, 0(R2)
LW	R2, 0(R4)
ADDU	R2, R2, R3
SW	R2, 0(R4)
;sha2_routines.c,138 :: 		for (i = 0; i < 8; i++)
ADDIU	R2, R6, 1
SEH	R6, R2
;sha2_routines.c,139 :: 		ctx->hash[i] += rotate_register[i];
; i end address is: 24 (R6)
J	L_sha2_routines_sw_sha256_process14
NOP	
L_sha2_routines_sw_sha256_process15:
;sha2_routines.c,76 :: 		for (block = 0; block < block_count; block++) {
ADDIU	R2, R5, 1
; block end address is: 20 (R5)
; block start address is: 32 (R8)
MOVZ	R8, R2, R0
;sha2_routines.c,140 :: 		}
; block end address is: 32 (R8)
J	L_sha2_routines_sw_sha256_process0
NOP	
L_sha2_routines_sw_sha256_process1:
;sha2_routines.c,141 :: 		}
L_end_sw_sha256_process:
ADDIU	SP, SP, 288
JR	RA
NOP	
; end of sha2_routines_sw_sha256_process
_sw_sha256_init:
;sha2_routines.c,143 :: 		void sw_sha256_init(sw_sha256_ctx* ctx)
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;sha2_routines.c,151 :: 		memset(ctx, 0, sizeof(*ctx));
SW	R26, 4(SP)
SW	R27, 8(SP)
ORI	R27, R0, 168
MOVZ	R26, R0, R0
JAL	_memset+0
NOP	
;sha2_routines.c,152 :: 		for (i = 0; i < 8; i++)
; i start address is: 20 (R5)
MOVZ	R5, R0, R0
; i end address is: 20 (R5)
L_sw_sha256_init17:
; i start address is: 20 (R5)
SEH	R2, R5
SLTI	R2, R2, 8
BNE	R2, R0, L__sw_sha256_init37
NOP	
J	L_sw_sha256_init18
NOP	
L__sw_sha256_init37:
;sha2_routines.c,153 :: 		ctx->hash[i] = hash_init[i];
ADDIU	R3, R25, 136
SEH	R2, R5
SLL	R4, R2, 2
ADDU	R3, R3, R4
LUI	R2, hi_addr(sw_sha256_init_hash_init_L0+0)
ORI	R2, R2, lo_addr(sw_sha256_init_hash_init_L0+0)
ADDU	R2, R2, R4
LW	R2, 0(R2)
SW	R2, 0(R3)
;sha2_routines.c,152 :: 		for (i = 0; i < 8; i++)
ADDIU	R2, R5, 1
SEH	R5, R2
;sha2_routines.c,153 :: 		ctx->hash[i] = hash_init[i];
; i end address is: 20 (R5)
J	L_sw_sha256_init17
NOP	
L_sw_sha256_init18:
;sha2_routines.c,154 :: 		}
L_end_sw_sha256_init:
LW	R27, 8(SP)
LW	R26, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _sw_sha256_init
_sw_sha256_update:
;sha2_routines.c,156 :: 		void sw_sha256_update(sw_sha256_ctx* ctx,  uint8_t* msg, uint32_t msg_size)
ADDIU	SP, SP, -24
SW	RA, 0(SP)
;sha2_routines.c,159 :: 		uint32_t rem_size = SHA256_BLOCK_SIZE - ctx->block_size;
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
ADDIU	R2, R25, 4
LW	R3, 0(R2)
ORI	R2, R0, 64
SUBU	R2, R2, R3
; rem_size start address is: 12 (R3)
MOVZ	R3, R2, R0
;sha2_routines.c,160 :: 		uint32_t copy_size = msg_size > rem_size ? rem_size : msg_size;
SLTU	R2, R2, R27
BNE	R2, R0, L__sw_sha256_update39
NOP	
J	L_sw_sha256_update20
NOP	
L__sw_sha256_update39:
; ?FLOC___sw_sha256_update?T328 start address is: 16 (R4)
MOVZ	R4, R3, R0
; rem_size end address is: 12 (R3)
; ?FLOC___sw_sha256_update?T328 end address is: 16 (R4)
J	L_sw_sha256_update21
NOP	
L_sw_sha256_update20:
; ?FLOC___sw_sha256_update?T328 start address is: 16 (R4)
MOVZ	R4, R27, R0
; ?FLOC___sw_sha256_update?T328 end address is: 16 (R4)
L_sw_sha256_update21:
; ?FLOC___sw_sha256_update?T328 start address is: 16 (R4)
; copy_size start address is: 40 (R10)
MOVZ	R10, R4, R0
;sha2_routines.c,163 :: 		memcpy(&ctx->block[ctx->block_size], msg, copy_size);
ADDIU	R3, R25, 8
ADDIU	R2, R25, 4
LW	R2, 0(R2)
ADDU	R2, R3, R2
SW	R27, 16(SP)
; ?FLOC___sw_sha256_update?T328 end address is: 16 (R4)
SW	R25, 20(SP)
MOVZ	R27, R4, R0
MOVZ	R25, R2, R0
JAL	_memcpy+0
NOP	
LW	R25, 20(SP)
LW	R27, 16(SP)
;sha2_routines.c,165 :: 		if (ctx->block_size + msg_size < SHA256_BLOCK_SIZE) {
ADDIU	R2, R25, 4
LW	R2, 0(R2)
ADDU	R2, R2, R27
SLTIU	R2, R2, 64
BNE	R2, R0, L__sw_sha256_update40
NOP	
J	L_sw_sha256_update22
NOP	
L__sw_sha256_update40:
; copy_size end address is: 40 (R10)
;sha2_routines.c,167 :: 		ctx->block_size += msg_size;
ADDIU	R3, R25, 4
LW	R2, 0(R3)
ADDU	R2, R2, R27
SW	R2, 0(R3)
;sha2_routines.c,168 :: 		return;
J	L_end_sw_sha256_update
NOP	
;sha2_routines.c,169 :: 		}
L_sw_sha256_update22:
;sha2_routines.c,172 :: 		sw_sha256_process(ctx, ctx->block, 1);
; copy_size start address is: 40 (R10)
ADDIU	R2, R25, 8
SW	R27, 16(SP)
SW	R26, 20(SP)
ORI	R27, R0, 1
MOVZ	R26, R2, R0
JAL	sha2_routines_sw_sha256_process+0
NOP	
LW	R26, 20(SP)
LW	R27, 16(SP)
;sha2_routines.c,175 :: 		msg_size -= copy_size; // Adjust to the remaining message bytes
SUBU	R2, R27, R10
MOVZ	R27, R2, R0
;sha2_routines.c,176 :: 		block_count = msg_size / SHA256_BLOCK_SIZE;
SRL	R3, R2, 6
; block_count start address is: 44 (R11)
MOVZ	R11, R3, R0
;sha2_routines.c,177 :: 		sw_sha256_process(ctx, &msg[copy_size], block_count);
ADDU	R2, R26, R10
SW	R27, 16(SP)
SW	R26, 20(SP)
MOVZ	R27, R3, R0
MOVZ	R26, R2, R0
JAL	sha2_routines_sw_sha256_process+0
NOP	
LW	R26, 20(SP)
LW	R27, 16(SP)
;sha2_routines.c,180 :: 		ctx->total_msg_size += (block_count + 1) * SHA256_BLOCK_SIZE;
ADDIU	R2, R11, 1
SLL	R3, R2, 6
LW	R2, 0(R25)
ADDU	R2, R2, R3
SW	R2, 0(R25)
;sha2_routines.c,181 :: 		ctx->block_size = msg_size % SHA256_BLOCK_SIZE;
ADDIU	R3, R25, 4
ANDI	R2, R27, 63
SW	R2, 0(R3)
;sha2_routines.c,182 :: 		memcpy(ctx->block, &msg[copy_size + block_count * SHA256_BLOCK_SIZE], ctx->block_size);
ADDIU	R2, R25, 4
LW	R4, 0(R2)
SLL	R2, R11, 6
; block_count end address is: 44 (R11)
ADDU	R2, R10, R2
; copy_size end address is: 40 (R10)
ADDU	R3, R26, R2
ADDIU	R2, R25, 8
MOVZ	R27, R4, R0
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_memcpy+0
NOP	
;sha2_routines.c,183 :: 		}
L_end_sw_sha256_update:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 24
JR	RA
NOP	
; end of _sw_sha256_update
_sw_sha256_final:
;sha2_routines.c,185 :: 		void sw_sha256_final(sw_sha256_ctx* ctx, uint8_t digest[SHA256_DIGEST_SIZE])
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;sha2_routines.c,192 :: 		ctx->total_msg_size += ctx->block_size;
SW	R27, 4(SP)
ADDIU	R2, R25, 4
LW	R3, 0(R2)
LW	R2, 0(R25)
ADDU	R2, R2, R3
SW	R2, 0(R25)
;sha2_routines.c,193 :: 		msg_size_bits = ctx->total_msg_size * 8;
LW	R2, 0(R25)
SLL	R2, R2, 3
; msg_size_bits start address is: 28 (R7)
MOVZ	R7, R2, R0
;sha2_routines.c,196 :: 		pad_zero_count = (SHA256_BLOCK_SIZE - ((ctx->block_size + 9) % SHA256_BLOCK_SIZE)) % SHA256_BLOCK_SIZE;
ADDIU	R6, R25, 4
LW	R5, 0(R6)
ADDIU	R2, R5, 9
ANDI	R3, R2, 63
ORI	R2, R0, 64
SUBU	R2, R2, R3
ANDI	R2, R2, 63
; pad_zero_count start address is: 32 (R8)
MOVZ	R8, R2, R0
;sha2_routines.c,199 :: 		ctx->block[ctx->block_size++] = 0x80;
ADDIU	R2, R25, 8
MOVZ	R4, R6, R0
ADDU	R3, R2, R5
ORI	R2, R0, 128
SB	R2, 0(R3)
LW	R2, 0(R4)
ADDIU	R2, R2, 1
SW	R2, 0(R4)
;sha2_routines.c,202 :: 		memset(&ctx->block[ctx->block_size], 0, pad_zero_count + 4);
ADDIU	R4, R8, 4
ADDIU	R3, R25, 8
ADDIU	R2, R25, 4
LW	R2, 0(R2)
ADDU	R2, R3, R2
SW	R26, 8(SP)
SW	R25, 12(SP)
SEH	R27, R4
MOVZ	R26, R0, R0
MOVZ	R25, R2, R0
JAL	_memset+0
NOP	
LW	R25, 12(SP)
;sha2_routines.c,203 :: 		ctx->block_size += pad_zero_count + 4;
ADDIU	R4, R25, 4
ADDIU	R3, R8, 4
; pad_zero_count end address is: 32 (R8)
LW	R2, 0(R4)
ADDU	R2, R2, R3
SW	R2, 0(R4)
;sha2_routines.c,207 :: 		ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 24);
ADDIU	R3, R25, 8
ADDIU	R4, R25, 4
LW	R2, 0(R4)
ADDU	R3, R3, R2
SRL	R2, R7, 24
SB	R2, 0(R3)
LW	R2, 0(R4)
ADDIU	R2, R2, 1
SW	R2, 0(R4)
;sha2_routines.c,208 :: 		ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 16);
ADDIU	R3, R25, 8
ADDIU	R4, R25, 4
LW	R2, 0(R4)
ADDU	R3, R3, R2
SRL	R2, R7, 16
SB	R2, 0(R3)
LW	R2, 0(R4)
ADDIU	R2, R2, 1
SW	R2, 0(R4)
;sha2_routines.c,209 :: 		ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 8);
ADDIU	R3, R25, 8
ADDIU	R4, R25, 4
LW	R2, 0(R4)
ADDU	R3, R3, R2
SRL	R2, R7, 8
SB	R2, 0(R3)
LW	R2, 0(R4)
ADDIU	R2, R2, 1
SW	R2, 0(R4)
;sha2_routines.c,210 :: 		ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 0);
ADDIU	R4, R25, 8
ADDIU	R3, R25, 4
LW	R2, 0(R3)
ADDU	R2, R4, R2
SB	R7, 0(R2)
; msg_size_bits end address is: 28 (R7)
LW	R2, 0(R3)
ADDIU	R2, R2, 1
SW	R2, 0(R3)
;sha2_routines.c,212 :: 		sw_sha256_process(ctx, ctx->block, ctx->block_size / SHA256_BLOCK_SIZE);
ADDIU	R2, R25, 4
LW	R2, 0(R2)
SRL	R3, R2, 6
ADDIU	R2, R25, 8
MOVZ	R27, R3, R0
MOVZ	R26, R2, R0
JAL	sha2_routines_sw_sha256_process+0
NOP	
LW	R26, 8(SP)
;sha2_routines.c,216 :: 		for (i = 0; i < 8; i++)
; i start address is: 24 (R6)
MOVZ	R6, R0, R0
; i end address is: 24 (R6)
L_sw_sha256_final23:
; i start address is: 24 (R6)
SEH	R2, R6
SLTI	R2, R2, 8
BNE	R2, R0, L__sw_sha256_final42
NOP	
J	L_sw_sha256_final24
NOP	
L__sw_sha256_final42:
;sha2_routines.c,217 :: 		for (j = sizeof(int32_t) - 1; j >= 0; j--, ctx->hash[i] >>= 8)
; j start address is: 28 (R7)
ORI	R7, R0, 3
; j end address is: 28 (R7)
; i end address is: 24 (R6)
L_sw_sha256_final26:
; j start address is: 28 (R7)
; i start address is: 24 (R6)
SEH	R2, R7
SLTI	R2, R2, 0
BEQ	R2, R0, L__sw_sha256_final43
NOP	
J	L_sw_sha256_final27
NOP	
L__sw_sha256_final43:
;sha2_routines.c,218 :: 		digest[i * sizeof(int32_t) + j] = ctx->hash[i] & 0xFF;
SEH	R2, R6
SLL	R5, R2, 2
ADDU	R2, R5, R7
SEH	R2, R2
ADDU	R4, R26, R2
ADDIU	R3, R25, 136
SEH	R2, R5
ADDU	R2, R3, R2
LW	R2, 0(R2)
ANDI	R2, R2, 255
SB	R2, 0(R4)
;sha2_routines.c,217 :: 		for (j = sizeof(int32_t) - 1; j >= 0; j--, ctx->hash[i] >>= 8)
ADDIU	R2, R7, -1
SEH	R7, R2
ADDIU	R3, R25, 136
SEH	R2, R6
SLL	R2, R2, 2
ADDU	R3, R3, R2
LW	R2, 0(R3)
SRL	R2, R2, 8
SW	R2, 0(R3)
;sha2_routines.c,218 :: 		digest[i * sizeof(int32_t) + j] = ctx->hash[i] & 0xFF;
; j end address is: 28 (R7)
J	L_sw_sha256_final26
NOP	
L_sw_sha256_final27:
;sha2_routines.c,216 :: 		for (i = 0; i < 8; i++)
ADDIU	R2, R6, 1
SEH	R6, R2
;sha2_routines.c,218 :: 		digest[i * sizeof(int32_t) + j] = ctx->hash[i] & 0xFF;
; i end address is: 24 (R6)
J	L_sw_sha256_final23
NOP	
L_sw_sha256_final24:
;sha2_routines.c,219 :: 		}
L_end_sw_sha256_final:
LW	R27, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _sw_sha256_final
_sw_sha256:
;sha2_routines.c,221 :: 		void sw_sha256( uint8_t* message, unsigned int len, uint8_t digest[SHA256_DIGEST_SIZE])
ADDIU	SP, SP, -188
SW	RA, 0(SP)
;sha2_routines.c,225 :: 		sw_sha256_init(&ctx);
SW	R25, 4(SP)
SW	R26, 8(SP)
ADDIU	R2, SP, 20
SW	R27, 12(SP)
SW	R25, 16(SP)
MOVZ	R25, R2, R0
JAL	_sw_sha256_init+0
NOP	
LW	R25, 16(SP)
;sha2_routines.c,226 :: 		sw_sha256_update(&ctx, message, len);
ADDIU	R2, SP, 20
ANDI	R27, R26, 65535
MOVZ	R26, R25, R0
MOVZ	R25, R2, R0
JAL	_sw_sha256_update+0
NOP	
LW	R27, 12(SP)
;sha2_routines.c,227 :: 		sw_sha256_final(&ctx, digest);
ADDIU	R2, SP, 20
MOVZ	R26, R27, R0
MOVZ	R25, R2, R0
JAL	_sw_sha256_final+0
NOP	
;sha2_routines.c,228 :: 		}
L_end_sw_sha256:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 188
JR	RA
NOP	
; end of _sw_sha256
